package Nawt::Debug;
# $Id: Debug.pm,v 1.4 2005/01/15 00:03:47 ramirez Exp $

use strict;
use FileHandle;


#-------------------------------------------------------------------	
sub stamp {
        return localtime(time)." ".$0." ".$_[0].": ";
}

#-------------------------------------------------------------------	
sub fatalError {
	my $cgi;
	if (exists $Nawt::Session::session{cgi}) {
		$cgi = $Nawt::Session::session{cgi};
	} else {
		use CGI;
		$cgi = CGI->new;
	}
	print $cgi->header;
	print "<h1>Nawt Fatal Error</h1>Something unexpected happened that caused this system to fault.<p><b>Description:</b><p> \n$_[0]"; 
	
	exit;
}

#-------------------------------------------------------------------	
sub accessError {
	my $cgi;
	if (exists $Nawt::Session::session{cgi}) {
		$cgi = $Nawt::Session::session{cgi};
	} else {
		use CGI;
		$cgi = CGI->new;
	}
	print $cgi->header;
	print qq~<HTML><HEAD>
		<TITLE>Intruder Alert!</TITLE>
		<LINK REL="stylesheet" TYPE="text/css" HREF="$Nawt::session{config}{extrasURL}/css/default.css"></HEAD><BODY>~;
	print qq~<center><table width="95%" height="95%"><tr><td align="center" valign="middle">~ . Nawt::Theme::msgBox("err","Intruder Alert!",$_[0]) . "</td></tr></table>"; 
	
	exit;
}

#-------------------------------------------------------------------	
sub warn {
    my $data = stamp("WARNING").$_[0]."\n";
	writeLog($data);	
    $Nawt::Session::session{debug}{warning} .= $data;
}

#-------------------------------------------------------------------	
sub writeLog {
    if (my $log = FileHandle->new(">>".$Nawt::Session::session{config}{logfile})) {
		my $now = time;
		print $log "$now - $ENV{REMOTE_ADDR} - $_[0]\n";
		$log->close;
	} else {
		use CGI;
        my $cgi = CGI->new;
		print $cgi->header(). "<h1>Nawt Error</h1> Can't open log file: <b>".$Nawt::Session::session{config}{logfile}."</b> <br> Check your NaWT configuration file to set the path of the log file, and check to be sure the web server has the privileges to write to the log file.";;
		Nawt::Session::close();
		exit;
	}
}

1;