package Nawt::Navigation;
# $Id$

use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;

our @ISA = qw(Exporter);
our @EXPORT = qw(&addContMenuItem &addFormToDisable);


# addFormToDisable ( formname )
#-------------------------------------------------------------------
sub addFormToDisable {
	my @item = ();
	if (defined $_[0]) {
		push @{$session{page}{disabledforms}}, $_[0];
	}
}

# addContMenuItem ( title , url )
#-------------------------------------------------------------------
sub addContMenuItem {
	my $item = {};
	if (defined $_[0]) {
		$item->{name} = $_[0];
		$item->{url} = $_[1];
		push @{$session{page}{contmenu}}, $item;
	}
}

# build menu html
#-------------------------------------------------------------------
sub getContextMenu {
	my ($body,$result);
	foreach (@{$session{page}{contmenu}}) {
		if (!defined $_->{url}) {
			$body .= qq~<tr class=boxhead><th>$_->{name}</th></tr> ~;
		} elsif ($_->{url} =~ m/fn=$session{form}{fn}&/ && $session{form}{oid} ne "_new") {
			$body .= qq~<tr><td><b>$_->{name}</b></td></tr> ~;
		} else {
			$body .= qq~<tr><td><nobr><a href="$_->{url}">$_->{name}</a></nobr></td></tr> ~;
		}
	}
	$result = qq~<table class=adminlist>$body</table>~;
	return $result;
}

#-------------------------------------------------------------------
sub getRootMenu {
	my (%html);
if (isValidAdmin) {
	$html{billing} = qq~
		_cmSplit,
		[null,'Accounts','#',null,null,
			[null,'List Accounts','$ENV{SCRIPT_NAME}?op=showAccountList',null,null],
			[null,'Create Account','$ENV{SCRIPT_NAME}?op=editAccount',null,null],
			[null,'Plans','$ENV{SCRIPT_NAME}?op=showPlanList',null,null],
			[null,'Pay Cards','$ENV{SCRIPT_NAME}?op=showCardSeries',null,null],
		],
	~ if $session{netams}->hasService("billing");
return qq~
<!-- MAIN MENU -->
<TABLE class=menubar cellSpacing=0 cellPadding=0 width="100%" border=0>
  <TBODY>
  <TR>
    <TD class=menubackgr>
      <DIV id=myMenuID></DIV>
	  <!-- icon,title,url,null,desciption -->
	  <SCRIPT language=JavaScript type=text/javascript>
		var myMenu =
		[
			[null,'NeTAMS','$session{config}{scripturl}',null,'Control Panel',
				[null,'Show Status','$session{config}{scripturl}',null,'Status Information'],
				[null,'View Config','$session{config}{scripturl}?op=showNetamsConfig',null,'NeTAMS Config'],
				[null,'View Log','$session{config}{scripturl}?op=showNetamsLog',null,'NeTAMS Logfile']
			],
			[null,'NaWT','$session{config}{scripturl}',null,'Control Panel',
				[null,'NaWT options','$session{config}{scripturl}?op=showNawtOptions',null,null],
				[null,'Active sessions','$session{config}{scripturl}?op=showNawtSessions',null,null]
			],			
			_cmSplit,
			[null,'Services','$session{config}{scripturl}?op=editService',null,'Manage services',
				[null,'Main','$session{config}{scripturl}?op=editService&type=main',null,'Service Main'],
				[null,'Scheduler','$session{config}{scripturl}?op=editService&type=scheduler',null,'Service Scheduler'],
				[null,'Server','$session{config}{scripturl}?op=editService&type=server',null,'Service Server'],
				[null,'Processor','$session{config}{scripturl}?op=editService&type=processor',null,'Service Processor'],
				[null,'Storages','$session{config}{scripturl}?op=editService&type=storage',null,'Service Storage'],
				[null,'Data Sources','$session{config}{scripturl}?op=editService&type=dsource',null,'Service Data Source'],
				[null,'HTML','$session{config}{scripturl}?op=editService&type=html',null,'Service HTML'],
				[null,'Login','$session{config}{scripturl}?op=editService&type=login',null,'Service Login'],
				[null,'Quota','$session{config}{scripturl}?op=editService&type=quota',null,'Service Quota'],
				[null,'Monitors','$session{config}{scripturl}?op=editService&type=monitor',null,'Service Monitor'],
				[null,'Billing','$session{config}{scripturl}?op=editService&type=billing',null,'Service Billing'],
				[null,'ACL-Server','$session{config}{scripturl}?op=editService&type=acl',null,'Service Billing'],
			],
			_cmSplit,
			[null,'Units',null,null,'Netams Units',
				[null,'Unit List','$session{config}{scripturl}?op=showUnitList',null,'Unit List'],
				[null,'Unit Tree','$session{config}{scripturl}?op=showUnitList&view=tree',null,'Unit Tree'],
				[null,'Add Unit','$session{config}{scripturl}?op=editUnit',null,''],
				[null,'Auto Units','$ENV{SCRIPT_NAME}?op=showAutoUnits',null,''],
				[null,'Ping Units','$ENV{SCRIPT_NAME}?op=showPingUnits',null,''],
			],
			_cmSplit,
			[null,'Policies','#',null,null,
				[null,'List Policies','?op=showPolicyList',null,null],
				[null,'Add Policy','#',null,null]
			],
			$html{billing}

		];
		cmDraw ('myMenuID', myMenu, 'hbr', cmThemeOffice, 'ThemeOffice');
		
	  </SCRIPT>
	</TD>
	<TD class=menubackgr align=right>$session{netams}{options}{welcome}</TD>
	<TD class=menubackgr width=20 style="padding-left: 5px;padding-right:5px;"><a href="?op=mlogout"><img src="$session{config}{extrasURL}/images/exit.gif" alt="Logout"></a></TD>
  </TR>
  </TBODY>
</TABLE>
~;
#### ROOT MENU FOR CLIENTS
} elsif (isUser) {
#	my %faq = Nawt::SQL->buildHash("SELECT id,name FROM pcms_faqcat WHERE `lock`=0");
#	foreach (keys %faq) {
#		$html{faq} .= qq~[null,'$faq{$_}','$session{config}{scripturl}?op=faq&cat=$_',null,null],~;
#	}
	return qq~
<!-- MAIN MENU -->
<TABLE class=menubar cellSpacing=0 cellPadding=0 width="100%" border=0>
  <TBODY>
  <TR>
    <TD class=menubackgr>
      <DIV id=myMenuID></DIV>
	  <!-- icon,title,url,target,desciption -->
	  <SCRIPT language=JavaScript type=text/javascript>
		var myMenu =
		[
			[null,'Home','$session{config}{scripturl}',null,null],
			[null,'Stats',null,null,null,
				[null,'Traffic','$session{config}{scripturl}?op=showStat',null,null],
				[null,'Payments','$session{config}{scripturl}?op=showPayments',null,null]
			],
			_cmSplit,
		];
		cmDraw ('myMenuID', myMenu, 'hbr', cmThemeOffice, 'ThemeOffice');
		
	  </SCRIPT>
	</TD>
	<TD class=menubackgr align=right>$session{userinfo}{name}</TD>
	<TD class=menubackgr width=20 style="padding-left: 5px;padding-right:5px;"><a href="?op=mlogout"><img src="$session{config}{extrasURL}/images/exit.gif" alt="Logout"></a></TD>
  </TR>
  </TBODY>
</TABLE>
	~;
}
	return "";
}

1;