package Nawt::Operation;
# $Id: Operation.pm,v 1.11 2005/02/09 00:10:51 ramirez Exp $
use strict;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Language;
use Nawt::SQL;

use Nawt::Operation::Service;
use Nawt::Operation::AutoUnit;
use Nawt::Operation::User;
use Nawt::Operation::Unit;
use Nawt::Operation::UnitList;
use Nawt::Operation::Policy;
use Nawt::Operation::Account;
use Nawt::Operation::Stats;
use Nawt::Operation::Login;
use Nawt::Operation::Quota;
use Nawt::Operation::Utility;
use Nawt::Operation::Plan;
use Nawt::Operation::Note;
use Nawt::Operation::Usertool;
use Nawt::Operation::Report;
use Nawt::Operation::Options;
use Nawt::Operation::Paycard;

# usage = www_admintool()
#-------------------------------------------------------------------
sub www_admintool {
 	my ($out);

 	return Nawt::Operation::Utility::showStatus;
}

#-------------------------------------------------------------------
sub www_slogin {
	my (%html);
	if ($session{user}{isAdmin}) {
		$html{welcome} = "Use a valid username and password to gain access to the administration console.";
	} else {
		$html{welcome} = "Use a valid username and password to gain access to your account.";
	}
	return qq~
<LINK href="$session{config}{extrasURL}/css/admin_login.css" type=text/css rel=stylesheet>
<DIV id=ctr align=center>
	<DIV class="login">
	<DIV class="login-form">
		<IMG alt=Login src="$session{config}{extrasURL}/images/login.gif">  
		<FORM id=loginForm name=loginForm action="$session{config}{scripturl}" method=GET>
		<input type=hidden name=op value="mlogin">
		<DIV class="form-block">
			<DIV class="inputlabel">Username</DIV>
			<DIV><INPUT class="inputbox" size=15 name=user></DIV>
			<DIV class="inputlabel">Password</DIV>
			<DIV><INPUT class="inputbox" type=password size=15 name=pass></DIV>
			<DIV align=left><INPUT class="button" type=submit value=Login name=submit></DIV>
		</DIV>
		</FORM>
	</DIV>
	<DIV class=login-text>
		<DIV class=ctr><IMG height=64 alt=security src="$session{config}{extrasURL}/images/security.png" width=64></DIV>
			<P>Welcome to NaWT!</P>
			<P>$html{welcome}</P>
			<P>NeTAMS $session{netams}->{options}{version}</P>
		</DIV>
		<DIV class=clr></DIV>
	</DIV>
</DIV>
<DIV id=break></DIV>
<NOSCRIPT>!Warning! Javascript and Cookies must be enabled for proper script operation.</NOSCRIPT>
~;
}

#-------------------------------------------------------------------
sub www_mlogout {
	my $mode = $session{user}{isAdmin};
	Nawt::Session::end($session{var}{sessionId});
	$session{user}{isAdmin} = $mode;
	Nawt::Session::start(-1);
	return Nawt::Theme::getRedirect($ENV{SCRIPT_NAME});
}

#-------------------------------------------------------------------
sub www_mlogin {
	my ($res,$user,$pass);

	if ($session{user}{isAdmin}) {
		$user = $session{form}{user};
		$pass = $session{form}{pass};
		$res = Nawt::Session::makeNetamsConn($user,$pass);
		if ($res == 200) {
			$session{netams}->parseConfig();
			my $userOid = $session{netams}->getUserOidByName($user);
			Nawt::Session::convertVisitorToUser($session{var}{sessionId}, $userOid, 1, $user, $pass,'user');
		} 
	} else {
		$user = $session{config}{nauser};
		$pass = $session{config}{napass};
		$res = Nawt::Session::makeNetamsConn($user,$pass);
		if ($res == 200) {
			$session{netams}->parseConfig();
			my $sessionId = $session{var}{sessionId};
			my $login = $session{form}{user};
			my $passw = $session{form}{pass};
			return Nawt::Theme::getRedirect($ENV{SCRIPT_NAME}) if ($login eq "" or $passw eq "");
			my %units = $session{netams}->getUnit();
			# BILLING AUTH
			if ($session{netams}->hasAccount($session{netams}->getOidByName('account',$login))) {
				my %acc = $session{netams}->getAccount();
				my $dbh = Nawt::Operation::Stats::getDBH('billing');
				my %sql = Nawt::SQL->quickHash("SELECT * FROM billing WHERE name=".quote($login)." AND passwd=".quote($passw)." LIMIT 1",$dbh);
				if ($login ne "" && $passw ne "" && $acc{uc sprintf "%06lx",$sql{oid}}{name} eq $sql{name}) {
					my $userId = uc sprintf("%06lx",$sql{oid});
					Nawt::Session::convertVisitorToUser($sessionId,$userId,0,$session{config}{nauser},$session{config}{napass},'account');
				}
			# BASIC: UNIT, LOGIN
			} else {
				my %loginPtrs;
				if ($session{netams}->hasService('login')) {
					%loginPtrs = Nawt::Login::getUnitLogin($units{name2oid}{$login});
				}
				if ($loginPtrs{password} eq $passw) {
					Nawt::Session::convertVisitorToUser($sessionId, $units{name2oid}{$login}, 0, $session{config}{nauser}, $session{config}{napass}, 'unit');
				} elsif ($units{name2oid}{$login} eq $passw) {
					Nawt::Session::convertVisitorToUser($sessionId, $passw, 0, $session{config}{nauser}, $session{config}{napass}, 'unit');
				}	 
			}
		}
	}
	return Nawt::Theme::getRedirect($ENV{SCRIPT_NAME});
}

1;