package Nawt::Operation::Account;
# $Id: Account.pm,v 1.4 2005/02/09 00:10:49 ramirez Exp $

use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::DateTime;
use Nawt::Navigation;
use Nawt::Language;
use Nawt::SQL;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_showAccountList &www_editAccount &www_editAccountInfo &www_saveAccountInfo
	&www_saveAccount &www_deleteAccount &www_deleteUnitFromAccount 
	&www_addUnitToAccount &www_showPayments &www_makeAccountPayment);

#--------------------------------------------------------------------
sub www_showPayments {
	my ($result,$oid,%html,$dbh,$sth);
	$session{page}{title} = "Account Payment History";
	if ($session{user}{isAdmin}) {
		checkAdmin();
		$oid = $session{form}{oid};
		addContMenuItem("Actions");
		addContMenuItem("Show All Accounts","?op=showAccountList");
		addContMenuItem("Account Options","?op=editAccount&oid=$oid");
		addContMenuItem("Show Payments","?op=showPayments&oid=$oid");
	} else {
		$oid = $session{var}{userId};
	}

	$dbh = Nawt::Operation::Stats::getDBH('all');
	$sth = Nawt::SQL->new("SELECT time, unit_oid, param FROM events WHERE type LIKE 'BILLING' AND account_oid=".hex($oid)." AND (param LIKE 'balance %' OR param LIKE 'periodic fee %') ORDER BY time DESC",$dbh);
	while (my @data = $sth->array) {
		my $time = epochToHuman($data[0],"%y-%m-%d %j:%n");
		$html{list} .= qq~<tr><td>$time</td><td>$data[2]</td></tr>~;
	}
	$result = qq~
	<table class=adminlist>
	$html{list}
	</table>
	~;
	return $result;	
}

#-------------------------------------------------------------------
sub www_editAccount {
	checkAdmin();
	my ($result, $oid, %html, %acc, %units, $menu, $content,$dbh,%ams,%conf);
		$oid = $session{form}{oid};
		$dbh = Nawt::Operation::Stats::getDBH('billing');
		%acc = Nawt::SQL->quickHash("SELECT * FROM billing WHERE oid=".hex($oid)." LIMIT 1",$dbh);
		%ams = $session{netams}->getAccount($oid);
		%conf = $session{netams}->getService('billing');
		$session{page}{title} = "Edit Account $ams{name}";
	
	$html{created} = epochToHuman($acc{created},"%y-%m-%d %j:%n")." (".secondsToInterval2(time-$acc{created})." ago)";
	$html{changed} = epochToHuman($acc{changed},"%y-%m-%d %j:%n")." (".secondsToInterval2(time-$acc{changed})." ago)";
	$html{blocked} = epochToHuman($acc{blocked},"%y-%m-%d %j:%n")." (".secondsToInterval2(time-$acc{blocked})." ago)";
	
	addFormToDisable('acc') if not canEdit('account');
	addContMenuItem("Actions");
	addContMenuItem("Show All Accounts","?op=showAccountList");
	
	# List Attached units
	if ($ams{name}) {
		addContMenuItem("Account Options","?op=editAccount&oid=$oid");
		addContMenuItem("Account Info","?op=editAccountInfo&oid=$oid");
		addContMenuItem("Show Payments","?op=showPayments&oid=$oid");
		addContMenuItem("Show Report","?op=showReport&oid=$oid");
		my $unitlist;
		foreach (split ",",$ams{units}) {
			$unitlist .= qq~<tr>
				<td width=16><img src="$session{config}{extrasURL}/images/icons/$session{netams}->{config}{units}{$_}{type}.gif"></td>
				<td><a href="?op=editUnit&oid=$_">$session{netams}->{config}{units}{$_}{name}</a></td>
				<td>$session{netams}->{config}{units}{$_}{ip}</td>
				<td width=16><a href="?op=deleteUnitFromAccount&oid=$_"><img src="$session{config}{extrasURL}/images/trash.gif" alt="Remove from account"></a></td>
				</tr>~;	
		}
		foreach (keys %{$session{netams}->{config}{units}}) {
			next if $_ eq "name2oid" or $session{netams}->unitInBilling($_);
			$html{optunits} .= qq~<option value="$_">$session{netams}->{config}{units}{$_}{name} ($session{netams}->{config}{units}{$_}{type})</option>~ if $ams{units} !~ m/$_/;
		}
		$html{units} = qq~<p>
			<table class=adminlist>
			<tr class=boxhead><td colspan=2>Name</td><td>IP-Adress</td><td></td></tr>
			$unitlist
			</table>
			<select id=addUnitToAccount>$html{optunits}</select><input type=button value="$LANG{NAWT_ADD}" onclick="location.href='?op=addUnitToAccount&aid=$oid&uid='+document.getElementById('addUnitToAccount').value">
		~;
		# balance options
		$html{balance} = qq~<tr><td class=bold>Payment</td><td><input size=6 type=text id="makePayment" onblur='isNumber(this)'>
			<input type=button value="Add" onclick="location.href='?op=makeAccountPayment&oid=$oid&type=add&sum='+document.getElementById('makePayment').value">
			<input type=button value="Remove" onclick="location.href='?op=makeAccountPayment&oid=$oid&type=rem&sum='+document.getElementById('makePayment').value">
			<input type=button value="Set" onclick="location.href='?op=makeAccountPayment&oid=$oid&type=set&sum='+document.getElementById('makePayment').value">
			</td></tr>~;
	}
	
	foreach (keys %{$conf{plan}}) {
		if ($conf{plan}{$_}{name} eq $ams{plan}) {
			$html{plan} .= qq~<option value="$_" selected>$conf{plan}{$_}{name}</option>~;
		} else {
			$html{plan} .= qq~<option value="$_">$conf{plan}{$_}{name}</option>~;
		}
	}

	if ($ams{status} =~ m/^block/i) {
		$html{blocked} = "checked";
	}
	
	if (canEdit('account') and $ams{name}) {
		$html{delbtn} = qq~<input type=button value="$LANG{NAWT_DELETE}" onclick="location.href='?op=deleteAccount&oid=$oid'">~;	
	}
	
	$result = qq~
	<DIV class=databox>
	<table>
	<form method="GET" action="$session{config}{scripturl}" id=acc>
	<input type="hidden" name="op" value="saveAccount">	
	<input type="hidden" name="oid" value="$oid">	
	<tr><td class="bold">OID</td><td>$oid</td></tr>
	<tr><td class="bold">Created</td><td>$html{created}</td></tr>
	<tr><td class="bold">Changed</td><td>$html{changed}</td></tr>
	<tr><td class="bold">Blocked</td><td>$html{blocked}</td></tr>
	<tr><td class="bold">Name</td><td><input type="text" name="name" value="$ams{name}"></td></tr>
	<tr><td class="bold">Password</td><td><input type="password" name="passwd" value="$acc{passwd}"></td></tr>
	<tr><td class="bold">Description</td><td><input type=text name="descr" value="$acc{description}"></td></tr>
	<tr><td class="bold">Balance</td><td>$ams{balance}</td></tr>
	$html{balance}
	<tr><td class="bold">Credit Limit</td><td><input type=text name="credit" value="$ams{credit}"></td></tr>
	<tr><td class="bold">Blocked</td><td><input type=checkbox name="block" value=1 $html{blocked}></td></tr>
	<tr><td class="bold">Plan</td><td><select name="plan">$html{plan}</select></td></tr>
	<tr><td colspan=2><input type=submit value="$LANG{NAWT_SAVE}"> $html{delbtn}</td></tr>
	</form>
	</table>
	</DIV>
	<DIV class=bold>!     ,       ,     .</DIV>
	$html{units}
	~;
	
	return $result;
}

#-------------------------------------------------------------------
sub www_editAccountInfo {
	checkAdmin();
	my ($result,%html,$oid,%row);
	$oid = $session{form}{oid};
	$session{page}{title} = "Account Info";
	addContMenuItem("Actions");
	addContMenuItem("Show All Accounts","?op=showAccountList");	
	addContMenuItem("Account Options","?op=editAccount&oid=$oid");
	addContMenuItem("Account Info","?op=editAccountInfo&oid=$oid");
	addContMenuItem("Show Payments","?op=showPayments&oid=$oid");
	addContMenuItem("Show Report","?op=showReport&oid=$oid");
	%row = Nawt::SQL->quickHash("SELECT * FROM nawt_accountdata WHERE oid LIKE '$oid' LIMIT 1");
	
	$result = qq~
	<form method=POST action="$session{config}{scripturl}" id=actform>
	<input type="hidden" name="op" value="saveAccountInfo">	
	<input type="hidden" name="oid" value="$oid">	
	<table>
		<tr>
			<td class=bold>$LANG{ACCOUNT_SURNAME}:</td>
			<td><input type="text" name="surname" value="$row{surname}"></td>
		</tr>
		<tr>
			<td class=bold>$LANG{ACCOUNT_NAME}:</td>
			<td><input type="text" name="name" value="$row{name}"></td>
		</tr>
		<tr>
			<td class=bold>$LANG{ACCOUNT_PATRONYMIC}:</td>
			<td><input type="text" name="patronymic" value="$row{patronymic}"></td>
		</tr>	
		<tr>
			<td class=bold>$LANG{ACCOUNT_STREET}:</td>
			<td><input type="text" name="street" value="$row{street}"></td>
			<td class=bold>$LANG{ACCOUNT_HOUSE}:</td>
			<td><input type="text" name="house" value="$row{house}" size="10"></td>
		</tr>
		<tr>
			<td class=bold>$LANG{ACCOUNT_FLAT}:</td>
			<td><input type="text" name="flat" value="$row{flat}" size="4"></td>
			<td class=bold>$LANG{ACCOUNT_ROOM}:</td>
			<td><input type="text" name="room" value="$row{room}" size="5"></td>			
		</tr>	
		<tr>
			<td class=bold>$LANG{ACCOUNT_PHONE}:</td>
			<td><input type="text" name="phone" value="$row{phone}"></td>
		</tr>
		<tr>
			<td class=bold>$LANG{ACCOUNT_PSER}:</td>
			<td><input type="text" name="pser" value="$row{passport_ser}"></td>
			<td class=bold>$LANG{ACCOUNT_PNUM}:</td>
			<td><input type="text" name="pnum" value="$row{passport_num}"></td>			
		</tr>
		<tr>
			<td class=bold>$LANG{ACCOUNT_COMMENT}:</td>
			<td colspan=2><textarea name="comment" rows=10 cols=40>$row{comment}</textarea></td>
		</tr>
		<tr>
			<td colspan=2><input type="submit" value="$LANG{NAWT_SAVE}"></td>		
		</tr>
	</table>
	</form>
	~;
	
	return $result;
}
#-------------------------------------------------------------------
sub www_saveAccountInfo {
	checkAdmin();
	my ($oid,%row,$has,$cmd);
	$oid = $session{form}{oid};
	($has) = Nawt::SQL->quickArray("SELECT COUNT(*) FROM nawt_accountdata WHERE oid LIKE '$oid'");
	if ($has) { 
		Nawt::SQL->write("UPDATE nawt_accountdata SET 
			surname = ".quote($session{form}{surname}).",
			name = ".quote($session{form}{name}).",
			patronymic=".quote($session{form}{patronymic}).",
			street=".quote($session{form}{street}).",
			house=".quote($session{form}{house}).",
			flat=".quote($session{form}{flat}).",
			room=".quote($session{form}{room}).",
			phone=".quote($session{form}{phone}).",
			comment=".quote($session{form}{comment}).",
			passport_ser=".quote($session{form}{pser}).",
			passport_num=".quote($session{form}{pnum})." WHERE oid LIKE '$oid'" ); 
			# "
	} else { 
		Nawt::SQL->write("INSERT INTO nawt_accountdata SET 
			oid=".quote($oid).",
			surname=".quote($session{form}{surname}).",
			name=".quote($session{form}{name}).",
			patronymic=".quote($session{form}{patronymic}).",
			street=".quote($session{form}{street}).",
			house=".quote($session{form}{house}).",
			flat=".quote($session{form}{flat}).",
			room=".quote($session{form}{room}).",
			phone=".quote($session{form}{phone}).",
			comment=".quote($session{form}{comment}).",
			passport_ser=".quote($session{form}{pser}).",
			passport_num=".quote($session{form}{pnum}));
			# "
	}
	
	
	return Nawt::Theme::getRedirect("?op=editAccountInfo&oid=$oid");	
}

#-------------------------------------------------------------------
sub www_makeAccountPayment {
	checkAdmin();
	my ($oid,$type,$sum);
	$oid = $session{form}{oid};
	$type = $session{form}{type};
	$sum = $session{form}{sum};
	if (canEdit('account') && $session{netams}->hasService('billing') && $session{netams}->hasAccount($oid) && $sum > 0) {
		if ($type eq "add") {
			$session{netams}->runCmd("service billing");
			$session{netams}->runCmd("account $oid balance add $sum");
			$session{netams}->runCmd("exit");
		} elsif ($type eq "rem") {
			$session{netams}->runCmd("service billing");
			$session{netams}->runCmd("account $oid balance remove $sum");
			$session{netams}->runCmd("exit");		
		} elsif ($type eq "set") {
			$session{netams}->runCmd("service billing");
			$session{netams}->runCmd("account $oid balance set $sum");
			$session{netams}->runCmd("exit");			
		}
	}
	return Nawt::Theme::getRedirect("?op=editAccount&oid=$oid");	
}

#-------------------------------------------------------------------
sub www_showAccountList {
	checkAdmin();
	my ($result, %units, %html, $row, $dbh, $sth, %list);
	$session{page}{title} = "Accounts";
	$dbh = Nawt::Operation::Stats::getDBH('billing');
	%list = $session{netams}->getAccount();
	
	$html{menu} .= qq~<a class=btn1 href="?op=editAccount">Add Account</a>~ if canEdit('account');
	foreach (keys %list) {
		next if $_ !~/^\w{6}$/;
		my $name;
		my %data = Nawt::SQL->quickHash("SELECT * FROM billing WHERE oid=".hex($_),$dbh);
		$row ++;
		if ($row % 2) {	$html{rowclass} = "row0"; } else { $html{rowclass} = "row1"; }
		$html{status} = $list{$_}{status};
		$html{rowclass} = "rowred" if ($list{$_}{status} eq "BLOCKED" or $list{$_}{balance} <= 0 );
		my $units = scalar(split ",",$list{$_}{units});
		my %info = Nawt::SQL->quickHash("SELECT surname,name,patronymic FROM nawt_accountdata WHERE oid LIKE '$_'");
		if ($info{surname} ne "" or $info{name} ne "") {
			$name = qq~<a href="?op=editAccount&oid=$_">$info{surname} $info{name} $info{patronymic}</a><br><small>$list{$_}{name}</small>~;
		} else {
			$name = qq~<a href="?op=editAccount&oid=$_">$list{$_}{name}</a>~;
		}
		$html{body} .= qq~<tr class="$html{rowclass}">
			<td width="10">$row</td>
			<td width="20"><INPUT TYPE="checkbox" ID="u$row" NAME="u$row" value="$_"></td>
			<td width="10"><a href="?op=editAccount&oid=$_"><img src="$session{config}{extrasURL}/images/user.gif"></a></td>
			<td>$name</td>
			<td width="16"><a href="?op=deleteAccount&oid=$_"><img src="$session{config}{extrasURL}/images/trash.gif" alt="Delete Account..."></a></td>
			<td width="16"><a href="?op=showStat&oid=$list{$_}{units}"><img src="$session{config}{extrasURL}/images/statistics.gif" alt="Show statistics..."></a></td>
			<td><a href="?op=showPayments&oid=$_">$list{$_}{balance}</a></td>
			<td>$list{$_}{plan}</td>
			<td>$units</td>
			<td>$html{status}</td>
			</tr>~;
		}
		
		$result = qq~
		<div align=right>$html{menu}</div>
		<table class=adminlist>
			<tr class=boxhead><td colspan="4">Name</td><td colspan="2" width=50>Actions</td><td>Balance</td><td>Plan</td><td>Units</td><td>Status info</td></tr>
			$html{body}
		</table>
		<div align=right>$html{menu}</div>
		~;
	return $result;
}

#-------------------------------------------------------------------
sub www_saveAccount {
	checkAdmin();
	my ($oid,%op);
	%op = %{$session{form}};
	$oid = $session{form}{oid};
	if (canEdit('account')) {
	$oid = $session{netams}->setAccount(oid=>$oid,
		name		=> $op{name},
		description => $op{description},
		password	=> $op{passwd},
		description	=> $op{descr},
		balance		=> $op{balance},
		credit		=> $op{credit},
		block		=> int($op{block}),
		plan		=> int($op{plan})
		);
	}
	return Nawt::Theme::getRedirect("?op=editAccount&oid=$oid");
}

#-------------------------------------------------------------------
sub www_deleteAccount {
	checkAdmin();
	my(@oid,%html);
	@oid = split(",",$session{form}{oid});
	if (canEdit('account') && $session{form}{confirmed}) {
		if ($session{netams}->hasService('billing')) {
			# Deleting units
			if ($session{form}{units}) {
				$session{netams}->runCmd("service processor");
				foreach (@oid) {
					my %acc = $session{netams}->getAccount($_);
					$session{netams}->runCmd("no unit $session{netams}->{config}{units}{$_}{type} oid $_") foreach split ",",$acc{units};
				}
				$session{netams}->runCmd("exit");
			}
			$session{netams}->runCmd("service billing");
			$session{netams}->runCmd("no account $_") foreach @oid;
			$session{netams}->runCmd("exit");
		}
	} else {
		my $msg;
		my %conf = $session{netams}->getAccount();
		$session{page}{title} = "Delete Account?";
		foreach (@oid) {
			$msg .= qq~<tr><td width=16><img src="$session{config}{extrasURL}/images/user.gif"></td><td colspan=2 class="bold">$conf{$_}{name}</td>~;
			foreach (split ",",$conf{$_}{units}) {
				$msg .= qq~<tr><td></td><td width=16><img src="$session{config}{extrasURL}/images/$session{netams}->{config}{units}{$_}{type}.gif"></td><td>$session{netams}->{config}{units}{$_}{name}</td></tr>~;
			}
		}
		return qq~ Are you really want delete this account(s)? 
			<table>$msg</table>
			<p><a class=btn1 href="?op=showAccountList">Cancel</a>
			<a class=btn1 href="?op=deleteAccount&oid=$session{form}{oid}&confirmed=1">Delete Account Only</a>
			<a class=btn1 href="?op=deleteAccount&oid=$session{form}{oid}&units=1&confirmed=1">Delete Account And His Units</a></p>~;
	}
	return Nawt::Theme::getRedirect("?op=showAccountList");	
}
#split ",",$ams{units}
#-------------------------------------------------------------------
sub www_addUnitToAccount {
	checkAdmin();
	my ($unitId,$accId);
	$unitId = $session{form}{uid};
	$accId = $session{form}{aid};
	#$accId = $session{netams}->unitInBilling($oid);
	if (canEdit('account')) {
		$session{netams}->runCmd("service billing");
		$session{netams}->runCmd("account $accId unit oid $unitId add");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
		return Nawt::Theme::getRedirect("?op=editAccount&oid=$accId");					
	}
	return Nawt::Theme::getRedirect("?op=showAccountList");	
}

#-------------------------------------------------------------------
sub www_deleteUnitFromAccount {
	checkAdmin();
	my ($oid,$accId);
	$oid = $session{form}{oid};
	$accId = $session{netams}->unitInBilling($oid);
	
	if ($accId and canEdit('account')) {
		$session{netams}->runCmd("service billing");
		$session{netams}->runCmd("account $accId unit oid $oid delete");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
		return Nawt::Theme::getRedirect("?op=editAccount&oid=$accId");	
	}
	return Nawt::Theme::getRedirect("?op=showAccountList");	
}
1;