package Nawt::Operation::AutoUnit;
# $Id$

use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Language;
use Nawt::Navigation;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_showAutoUnits &www_saveAutoUnit &www_deleteAutoUnit);

# usage = www_showUserList()
#-------------------------------------------------------------------
sub www_showAutoUnits {
	my($result, %html, %conf, %grp);
	%conf = $session{netams}->getService('processor');
	$session{page}{title} = "AutoUnits Configuration";
	addContMenuItem("Actions");
	addContMenuItem("Service Processor","?op=editService&type=processor");	
	addContMenuItem("Unit List","?op=showUnitList");
	
	%grp = $session{netams}->getUnit("groups");
	foreach (keys %grp) {
		$html{grplist} .= qq~<option value="$grp{$_}">$grp{$_}</option>~;
	}
		
	foreach (sort keys %{$conf{'auto-units'}}) {
		my ($grplist);
		delete $html{auprefix};
		my $id = $_;
		foreach (qw (by-dns prefix1 prefix2)) {
			if ($conf{'auto-units'}{$id}{naming} eq $_) {
				$html{auprefix} .= qq~<option value="$_" selected>$_</option>~;			
			} else {
				$html{auprefix} .= qq~<option value="$_">$_</option>~;	
			}
		}
		if ($conf{'auto-units'}{$_}{type} eq "host") {
			$html{type} = qq~<option value="user">user</option><option value="host" selected>host</option>~;
		} else {
			$html{type} = qq~<option value="user" selected>user</option><option value="host">host</option>~;
		}
		foreach (keys %grp) {
			if ($conf{'auto-units'}{$id}{group} eq $grp{$_}) {
				$grplist .= qq~<option value="$grp{$_}" selected>$grp{$_}</option>~;
			} else {
				$grplist .= qq~<option value="$grp{$_}">$grp{$_}</option>~;
			}
		}
		$html{autou} .= qq~<tr>
		<FORM METHOD="GET" ACTION="$session{env}{scripturl}">
		<INPUT TYPE="hidden" NAME="op" VALUE="saveAutoUnit">
		<INPUT TYPE="hidden" NAME="oid" VALUE="$_">
		<td class="bold">$_</td>
		<td><select name="type">$html{type}</select></td>
		<td><select name="naming">$html{auprefix}</select><input type="text" name="prefix" value="$conf{'auto-units'}{$_}{prefix}"></td>
		<td><select name="groupname"><option value=""></option>$grplist</select></td>
		<td><input type="submit" value="Save"> <input type="button" value="Delete" onclick="window.location='?op=deleteAutoUnit&oid=$_'"></td>
		</FORM>
		</tr>
		~;
	}

$result = qq~
		<table class=adminform>
		<tr class="boxhead"><td>ID</td><td>Type</td><td>Naming</td><td>Group</td><td></td></tr>
		$html{autou}
		<tr class="boxhead"><td colspan="5">Create Auto Unit</td></tr>
		<tr class="row-1"><td></td>
		<FORM METHOD="GET" ACTION="$session{env}{scripturl}">
		<INPUT TYPE="hidden" NAME="op" VALUE="saveAutoUnit">
		<INPUT TYPE="hidden" NAME="oid" VALUE="_new">
		<td><select name="type"><option value="user">user</option><option value="host">host</option></select></td>	
		<td><select name="naming"><option value="by-dns">by-dns</option><option value="prefix1">prefix1</option><option value="prefix2">prefix2</option></select><input type="text" name="prefix"></td>	
		<td><select name="group"><option value=""></option>$html{grplist}</select></td>
		<td><input type="submit" value="Create"></td>
		</FORM>
		</tr>
		</table>

~;
	return $result;
}

#--------------------------------------------------------------------
sub www_saveAutoUnit {
	checkAdmin();
	my ($oid, %proc, $cmd);
		$oid = $session{form}{oid};
		%proc = $session{netams}->getService("processor");
	if ($oid ne "_new") {
		$cmd .= " ".$session{form}{prefix} if $session{form}{naming} ne "by-dns";
		$cmd .= " group $session{form}{group}" if $session{form}{group} ne "";
		$session{netams}->runCmd("service processor");
		$session{netams}->runCmd("auto-units $oid type $session{form}{type} naming $session{form}{naming}$cmd");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
	} else {
		my $id;
		do { $id++ } until !defined $proc{"auto-units"}{$id};
		$cmd .= " ".$session{form}{prefix} if $session{form}{naming} ne "by-dns";
		$cmd .= " group $session{form}{group}" if $session{form}{group} ne "";
		$session{netams}->runCmd("service processor");
		$session{netams}->runCmd("auto-units $id type $session{form}{type} naming $session{form}{naming}$cmd");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");			
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showAutoUnits");	
}

#--------------------------------------------------------------------
sub www_deleteAutoUnit {
	checkAdmin();
	my $oid;
	$oid = $session{form}{oid};
	if ($oid =~ m/\d+/) {
		$session{netams}->runCmd("service processor");
		$session{netams}->runCmd("no auto-units $oid");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showAutoUnits");	
}

1;