package Nawt::Operation::Login;
# $Id: Login.pm,v 1.6 2005/04/15 22:39:13 ramirez Exp $

use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Login;
use Nawt::Navigation;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_showLoginList &www_saveUnitLogin &www_toggleUnitLogin);

#-------------------------------------------------------------------
sub www_showLoginList {
	checkAdmin();
	my ($result, %login, %units, %html);
		$session{page}{title} = "Login Status";
		%login = $session{netams}->getLogin();
		%units = $session{netams}->getUnit();
	
	return "Service login not found. Configure it first." if not $session{netams}->hasService('login');
	addContMenuItem("Actions");
	addContMenuItem("Service Login","?op=editService&type=login");

	foreach (keys %login) {
		$html{body} .= qq~<tr><td width=16><img src="$session{config}{extrasURL}/images/icons/$units{$_}{type}.gif"></td><td><a href="?op=editUnitLogin&oid=$_">$units{$_}{name}</a></td><td>$login{$_}{status}</td></td><td>$login{$_}{last_opened_time}</td></tr>~;
	}
	
	if (scalar %login < 1) {
		$html{body} = qq~<tr><td colspan="3">Not found</td></tr>~;
	}
	
	$result = qq~
		<table class=adminlist>
			<tr class=boxhead>
				<td colspan=2>Unit</td>
				<td><nobr>Connection Status</nobr></td>
				<td><nobr>Last Used</nobr></td>
			</tr>
			$html{body}
		</table>
	~;
	
	return $result;
}

# OPEN / CLOSE CONNECTION
#-------------------------------------------------------------------
sub www_toggleUnitLogin {
	checkAdmin();
	my ($oid, %unit, %login, $cmd);
		$oid = $session{form}{oid};
		%unit = $session{netams}->getUnit($oid);
		%login = Nawt::Login::getUnitLogin($oid);
	if (defined $login{flags} && $login{flags} == 0) {
		$session{netams}->unitLogin(oid=>$oid, pass=>$login{password}, ip=>$session{env}{REMOTE_ADDR});
	} elsif (defined $login{flags} && $login{flags} == 1) {
		$session{netams}->unitLogout(oid=>$oid, pass=>$login{password}, ip=>$session{env}{REMOTE_ADDR});
	}
	return Nawt::Theme::getRedirect("?op=editUnitLogin&oid=$oid");
}

#-------------------------------------------------------------------
sub www_saveUnitLogin {
	checkAdmin();
	my ($oid, %login, $cmd);
		$oid = $session{form}{oid};
		%login = $session{netams}->getLogin();	

	foreach (keys %{$session{form}}) {
		$session{form}{$_} =~ s/^ +$//g;
	}	
	
	if (defined $oid && $session{form}{useLogin}) {
		$cmd .= "set oid $oid";
		$cmd .= " password $session{form}{password}" if $session{form}{password} =~ m/^\w+$/;
		$cmd .= " inact $session{form}{inact}" if $session{form}{inact} =~ m/^\d+$/;
		$cmd .= " abs $session{form}{abs}" if $session{form}{abs} =~ m/^\d+$/;
		$cmd .= " mac $session{form}{mac}" if $session{form}{mac} =~ m/^\w{2}:\w{2}:\w{2}:\w{2}:\w{2}:\w{2}$/;
		if ($session{form}{strict}) {
			$cmd .= " strict";
		} else {
			$cmd .= " nostrict";
		}
		$session{netams}->runCmd("service login");
		$session{netams}->runCmd($cmd);
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
	} elsif (defined $oid && not $session{form}{useLogin}) {
		#Nawt::SQL->write("DELETE FROM login WHERE unit_oid='".hex($oid)."' LIMIT 1");
	}
	
	return Nawt::Theme::getRedirect("?op=editUnitLogin&oid=$oid");
}

1;