package Nawt::Operation::Note;
# $Id$
use strict;
use Exporter;
use Nawt::SQL;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Navigation;
use Nawt::Theme;
use Nawt::DateTime;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_editNote &www_saveNote &www_showNote &www_deleteNote);


#-------------------------------------------------------------------
sub www_showNote {
	my ($result, $id, %item, $menu, $time);
	$id = int($session{form}{id});
	%item = Nawt::SQL->quickHash("SELECT * FROM nawt_note WHERE id = $id LIMIT 1");
	$session{page}{title} = $item{name};
	
	addContMenuItem("Actions");
	if ($item{parentClass} eq "unit") {
		addContMenuItem("Back to Unit","?op=editUnit&oid=$item{parentId}");
	}
	
	if (isValidAdmin) {
		addContMenuItem("Edit Note","?op=editNote&id=$id");
		addContMenuItem("Delete Note","?op=deleteNote&id=$item{id}");
	}
	$time = epochToHuman($item{tModifed},"%y-%m-%d %j:%n")." (".secondsToInterval2(time-$item{tModifed})." ago)";
	$result = qq~<DIV class=databox>$item{text} <div class=bold>Last modifed: $time</div></DIV>~;
	return $result;
}

#-------------------------------------------------------------------
sub www_editNote {
	checkAdmin();
	my ($result, $id, %html, %item, $parentClass, $parentId);
	$id = int($session{form}{id});
	$parentClass = $session{form}{parentClass};
	$parentId = $session{form}{parentId};
	$session{page}{title} = "Edit Note";
	addContMenuItem("Actions");
	
	%item = Nawt::SQL->quickHash("SELECT * FROM nawt_note WHERE id = $id LIMIT 1");
	if ($item{id} > 0) {
		$parentId = $item{parentId};
		$parentClass = $item{parentClass};
		addContMenuItem("Delete Note","?op=deleteNote&id=$item{id}");
	}
	
	if ($parentClass eq "unit") {
		addContMenuItem("Back to Unit","?op=editUnit&oid=$parentId");
	}
	

	$result = qq~
	<!-- tinyMCE -->
	<script language="javascript" type="text/javascript" src="$session{config}{extrasURL}/js/tiny_mce/tiny_mce.js"></script>
	<script language="javascript" type="text/javascript">
		tinyMCE.init({
			theme : "advanced",
			mode : "textareas",
			theme_advanced_buttons1 : "bold,italic,underline,strikethrough,separator,justifyleft,justifycenter,justifyright,justifyfull,separator,formatselect,fontselect,fontsizeselect,forecolor",
			extended_valid_elements : "font[face|size|color]"
		});
	</script>
	<!-- /tinyMCE -->
	<DIV class=databox>
  	<table width="100%">
 	<form method=POST action="$ENV{SCRIPT_NAME}">
	<input type=hidden name=op value="saveNote">
	<input type=hidden name=parentClass value="$parentClass">
	<input type=hidden name=parentId value="$parentId">
	<input type=hidden name=id value="$id">
	<tr><td colspan=2><b></b> <br> <input type=text style="width:100%" name=name value="$item{name}"></td></tr>
	<tr><td colspan=2><b></b> <br> <textarea name=text style="width:100%" rows=20>$item{text}</textarea></td></tr>
	<tr><td></td><td><input type=submit value="Save"></td></tr>
	<tr><td></td><td></td></tr>
	</form>
 	</table> 
 	</DIV>
 	~;
	
	return $result;
}

#-------------------------------------------------------------------
sub www_saveNote {
	checkAdmin();
	my ($id, %item, $parentClass, $parentId, $exist);
	$id = int($session{form}{id});
	$parentClass = $session{form}{parentClass};
	$parentId = $session{form}{parentId};
	%item = Nawt::SQL->quickHash("SELECT * FROM nawt_note WHERE id=$id");
	
	if ($item{id} > 0) {
		Nawt::SQL->write("UPDATE nawt_note SET
			name = ".quote($session{form}{name}).",
			text = ".quote($session{form}{text}).",
			tModifed = ".time."
			WHERE id = $id");		
	} else {
		$id = getNewId('nawt_note');
		Nawt::SQL->write("INSERT INTO nawt_note SET
			id = $id,
			parentClass = ".quote($parentClass).",
			parentId = ".quote($parentId).",
			name = ".quote($session{form}{name}).",
			text = ".quote($session{form}{text}).",
			tModifed = ".time);
	}
	if ($item{id} > 0) {
		return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editUnit&oid=$item{parentId}");
	} else {
		return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editUnit&oid=$parentId");
	}
}

# getNewId ( table )
#-------------------------------------------------------------------
sub getNewId {
	for (my $i=1; $i<10000; $i++) {
		my ($isDuplicate) = Nawt::SQL->buildArray("SELECT COUNT(*) FROM $_[0] WHERE id = '$i'");
		return $i if not $isDuplicate;
	}
}

# getNoteList ( parentClass , parentId )
#-------------------------------------------------------------------
sub getNoteList {
	my ($result, $parentClass, $parentId, %list, $body);
	($parentClass, $parentId) = (shift, shift);
	%list = Nawt::SQL->buildHash("SELECT id, name FROM nawt_note WHERE parentClass LIKE '$parentClass' AND parentId LIKE '$parentId'");
	
	foreach (keys %list) {
		$body .= qq~<tr><td><img src="$session{config}{extrasURL}/images/document.gif"></td><td><a href="?op=showNote&id=$_">$list{$_}</a></td></tr>~;
	}
	
	$result = qq~
	<DIV class=databox>
	<DIV class=boxhead>Notes</DIV>
	<table>$body</table>
	<a class=btn1 href="?op=editNote&parentClass=$parentClass&parentId=$parentId">Add Note</a>
	</DIV>
	~;
	return $result;
}


#-------------------------------------------------------------------
sub www_deleteNote {
	my ($id,%item);
	$id = int($session{form}{id});
	%item = Nawt::SQL->quickHash("SELECT * FROM nawt_note WHERE id=$id");
	if ($item{id} > 0) {
		Nawt::SQL->write("DELETE FROM nawt_note WHERE id=$id");
		if ($item{parentClass} eq "unit") {
			return Nawt::Theme::getRedirect("?op=editUnit&oid=$item{parentId}");
		}
	}
	
	return Nawt::Theme::getRedirect("?op=showUnitList");
}
1;