package Nawt::Operation::Paycard;
# $Id$

use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Navigation;
use Nawt::Theme;
use Nawt::SQL;
use Nawt::DateTime;
use Nawt::Language;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( 
	&www_showCardSeries 
	&www_saveCardSerie 
	&www_showSerie 
	&www_showCard 
	&www_activateCard 
	&www_blockCard
	&www_blockSerie
	&www_cancelSeriePayments
	&www_deleteSerie
	&www_cancelCardPayment
	);


#-------------------------------------------------------------------
sub www_showCardSeries {
	checkAdmin;
	$session{page}{title} = $LANG{CARD_CARDS}.": ".$LANG{CARD_SERIES};
	my (%html,$result);
	
	my (@series) = Nawt::SQL->buildArray("SELECT distinct(series) FROM nawt_paycard");
	foreach (@series) {
		my ($date) = Nawt::SQL->quickArray("SELECT distinct(time_c) FROM nawt_paycard WHERE series='$_'");
		my ($value) = Nawt::SQL->quickArray("SELECT distinct(nominal) FROM nawt_paycard WHERE series='$_'");
		my ($count) = Nawt::SQL->quickArray("SELECT count(number) FROM nawt_paycard WHERE series='$_'");
		my ($active) = Nawt::SQL->quickArray("SELECT count(number) FROM nawt_paycard WHERE series='$_' AND status LIKE 'ACTIVE'");
		my ($blocked) = Nawt::SQL->quickArray("SELECT count(number) FROM nawt_paycard WHERE series='$_' AND status LIKE 'BLOCKED'");
		my $inact = $count - $active - $blocked;
		my $bal_total = $value * $count;
		my $bal_used = $value * ($count - $inact);
		$date = epochToHuman($date,"%y.%m.%d %j:%n");
		$html{series} .= qq~<tr><td width="16"><img src="$session{config}{extrasURL}/images/cardserie.gif"></td><td><a href="?op=showSerie&id=$_">$_</a></td><td>$date</td><td>$value</td><td>$count</td><td>$active</td><td>$blocked</td><td>$inact</td><td>$bal_used / $bal_total</td></tr>~;
	}

	my ($lastserie) = Nawt::SQL->quickArray("SELECT max(series) FROM nawt_paycard");
		$lastserie++;

	$result .= qq~
	<table class=adminlist>
	<tr class=boxhead>
		<td colspan=2>$LANG{CARD_SERIE}</td>
		<td>Date</td><td>$LANG{CARD_NOMINAL}</td>
		<td>$LANG{CARD_CARDS}</td>
		<td>$LANG{CARD_ACTIVE}</td>
		<td>$LANG{CARD_BLOCKED}</td>
		<td>$LANG{CARD_INACTIVE}</td>
		<td>$LANG{CARD_BALANCE}</td>
	</tr>
	$html{series}
	</table>
	
	<form method="POST" action="$session{config}{scripturl}" id=serie>
	<input type="hidden" name="op" value="saveCardSerie">
	<table class=adminform>
	<tr class=boxhead><td colspan=7>$LANG{NAWT_CREATE} $LANG{CARD_SERIE}</td></tr>
	<tr>
	<td class=bold>$LANG{CARD_SERIE}:</td><td>$lastserie</td>
	<td class=bold>$LANG{CARD_NOMINAL} (1-10000):</td><td><input type="text" name="value" value="" size="6"></td>
	<td class=bold>$LANG{NAWT_COUNT} (10-1000):</td><td><input type="text" name="count" value="" size="6"></td>
	<td class=bold><input type="submit" value="$LANG{NAWT_CREATE}"></td>
	</tr>
	</table>
	</form>
	~;
	
	return $result;
	
}

#-------------------------------------------------------------------
sub www_showSerie {
	checkAdmin();
	my ($result, %html, $sId, $status);
		$sId = int($session{form}{id});
		$status = int($session{form}{status});
		$session{page}{title} = "$LANG{CARD_SERIE} $sId";
		
	my $sth = Nawt::SQL->new("SELECT * FROM nawt_paycard WHERE series = $sId ORDER BY status DESC");
	while (my @data = $sth->array) {
		my ($time_a,$time_c);
		$time_a = epochToHuman($data[6],"%y.%m.%d %j:%n") if $data[6] > 0;
		$html{rows} .= qq~<tr><td width="16"><img src="$session{config}{extrasURL}/images/paycard.gif"></td><td><a href="?op=showCard&id=$data[1]">$data[1]</a></td><td>$data[3]</td><td>$data[4]</td><td>$time_a</td><td>$data[2]</td></tr>~;
	}

	$result = qq~
	<div align=right>
		<a href="?op=blockSerie&id=$sId" class=btn1>$LANG{NAWT_BLOCK} / $LANG{NAWT_UNBLOCK}</a>
		<a href="?op=cancelSeriePayments&id=$sId" class=btn1>$LANG{NAWT_CANCEL} $LANG{CARD_PAYMENTS}</a>
		<a href="?op=deleteSerie&id=$sId" class=btn1>$LANG{NAWT_DELETE} $LANG{CARD_SERIE}</a>
	</div>
	<table class=adminlist>
	<tr class=boxhead>
		<td colspan=2>$LANG{CARD_CARDNUM}</td>
		<td>$LANG{CARD_PIN}</td>
		<td>$LANG{CARD_STATUS}</td>
		<td>$LANG{CARD_ACTIVATED}</td>
		<td>$LANG{CARD_NOMINAL}</td>
	</tr>
	$html{rows}
	</table>
	~;		

	return $result;
}


#-------------------------------------------------------------------
sub www_showCard {
	checkAdmin();
	my ($result,%html,$id,%card,$dbh,%accs);
		$id = int($session{form}{id});
		$session{page}{title} = "$LANG{CARD_CARD} $id";
		
	%card = Nawt::SQL->quickHash("SELECT * FROM nawt_paycard WHERE number = $id");
	$html{time_c} = epochToHuman($card{time_c},"%y.%m.%d %j:%n") if $card{time_c} > 0;
	$html{time_a} = epochToHuman($card{time_a},"%y.%m.%d %j:%n") if $card{time_a} > 0;
	
	%accs = $session{netams}->getAccount();
	foreach (keys %accs) {
		$html{accs} .= qq~<option value="$_">$accs{$_}{name}</option>~;
	}
	
	if ($card{status} eq "BLOCKED") {
		$html{block} = "UNBLOCK";
	} else {
		$html{block} = "BLOCK";
	}
	if ($card{status} eq "ACTIVE") {
		$html{cancelPayment} = qq~[<a href="?op=cancelCardPayment&id=$id">$LANG{NAWT_CANCEL} $LANG{CARD_PAYMENT}</a>]~;
	}
	
	$result = qq~
	<table>
	<tr><td>Serie</td><td><a href="?op=showSerie&id=$card{series}">$LANG{CARD_SERIE} $card{series}</a></td></tr>
	<tr><td>$LANG{CARD_PIN}</td><td>$card{pin}</td></tr>
	<tr><td>$LANG{CARD_NOMINAL}</td><td>$card{nominal}</td></tr>
	<tr><td>$LANG{CARD_STATUS}</td><td>$card{status} [<a href="?op=blockCard&id=$id">$html{block}</a>]</td></tr>
	<tr><td>$LANG{CARD_CREATED}</td><td>$html{time_c}</td></tr>
	<tr><td>$LANG{CARD_ACTIVATED}</td><td>$html{time_a} by $accs{$card{account}}{name} $html{cancelPayment}</td></tr>
	</table>
	~;
	
	if ($card{status} eq "OK") {
		$result .= qq~	
		<p>
		<b>$LANG{CARD_ACTIVATE}</b>
		<form method=GET action="$session{config}{scripturl}" id=actform>
		<input type="hidden" name="op" value="activateCard">
		<input type="hidden" name="id" value="$id">
		$LANG{ACCOUNT_ACCOUNT} <select name="acc"><option></option>$html{accs}</select>
		<input type="submit" value="$LANG{CARD_ACTIVATE}">
		</form>
		~;	
	} 
	return $result;	
}

#-------------------------------------------------------------------
sub www_deleteSerie {
	checkAdmin;
	my $id = int($session{form}{id});
	if ($session{form}{confirmed}) {
		Nawt::SQL->write("DELETE FROM nawt_paycard WHERE series='$id'");	
	} else {
		return qq~<div align=center>$LANG{MSG_SERIE_DELETE}</div>
			<div align=center> <a href="?op=deleteSerie&id=$id&confirmed=1" class=btn1>Yes</a>
				<a href="?op=showSerie&id=$id" class=btn1>NO</a> </div>
		~;	
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showCardSeries");		
}

#-------------------------------------------------------------------
sub www_cancelCardPayment {
	checkAdmin;
	my ($id,%html,%card);
		$id = int($session{form}{id});
		%card = Nawt::SQL->quickHash("SELECT account,nominal FROM nawt_paycard WHERE number='$id' LIMIT 1");
	if ($session{form}{confirmed}) {
		if ($session{netams}->hasAccount($card{account})) {
			$session{netams}->setBalance(oid=>$card{account},sum=>$card{nominal},mode=>"remove");
		}
		Nawt::SQL->write("UPDATE nawt_paycard SET account='', time_a='', status='OK' WHERE number='$id' LIMIT 1");
	} else {
		$session{page}{title} = "$LANG{NAWT_CANCEL} $LANG{CARD_PAYMENT}";
		return qq~<div align=center>$LANG{MSG_PAYMENT_CANCEL}</div>
			<div align=center> <a href="?op=cancelCardPayment&id=$id&confirmed=1" class=btn1>Yes</a>
			<a href="?op=showCard&id=$id" class=btn1>NO</a> </div>
		~;
	}		
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showCard&id=$id");		
}

#-------------------------------------------------------------------
sub www_cancelSeriePayments {
	checkAdmin;
	my ($id,%html,%cards);
		$id = int($session{form}{id});
		%cards = Nawt::SQL->buildHash("SELECT account,nominal FROM nawt_paycard WHERE series='$id' AND status LIKE 'ACTIVE' AND account <> ''");
	if ($session{form}{confirmed}) {
		foreach (keys %cards) {
			if ($session{netams}->hasAccount($_)) {
				$session{netams}->setBalance(oid=>$_,sum=>$cards{$_},mode=>"remove");
			}
		}
		Nawt::SQL->write("UPDATE nawt_paycard SET account='', time_a='', status='OK' WHERE series='$id' AND status LIKE 'ACTIVE' AND account <> ''");
	} else {
		$session{page}{title} = "$LANG{NAWT_CANCEL} $LANG{CARD_PAYMENTS}";
		my %accs = $session{netams}->getAccount();
		foreach (keys %cards) {
			$html{rows}	.= qq~<tr><td width="16"><img src="$session{config}{extrasURL}/images/paycard.gif"></td><td>$accs{$_}{name}</td><td>$cards{$_}</td></tr>~;
			$html{total} += $cards{$_};
		}
		return qq~<div align=center>$LANG{MSG_PAYMENTS_CANCEL}</div>
		<table class=adminlist>
		<tr class=boxhead><td colspan=2>$LANG{ACCOUNT_ACCOUNT}</td><td>$LANG{CARD_PAYMENT}</td></tr>
			$html{rows}
			<tr><td></td><td class=bold align=right>$LANG{NAWT_TOTAL}:</td><td>$html{total}</td></tr>
		</table>
			<div align=center> <a href="?op=cancelSeriePayments&id=$id&confirmed=1" class=btn1>Yes</a>
				<a href="?op=showSerie&id=$id" class=btn1>NO</a> </div>
		~;	
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showSerie&id=$id");		
}

#-------------------------------------------------------------------
sub www_blockSerie {
	checkAdmin;
	my $id = int($session{form}{id});
	my ($card_t) = Nawt::SQL->quickArray("SELECT count(*) FROM nawt_paycard");
	my ($card_b) = Nawt::SQL->quickArray("SELECT count(*) FROM nawt_paycard WHERE status LIKE 'BLOCKED'");
	
	if ($card_t == $card_b) {
		Nawt::SQL->write("UPDATE nawt_paycard SET status='ACTIVE' WHERE series='$id' AND status LIKE 'BLOCKED' AND account <> ''");
		Nawt::SQL->write("UPDATE nawt_paycard SET status='OK' WHERE series='$id' AND status LIKE 'BLOCKED' AND account LIKE ''");
	} else {
		Nawt::SQL->write("UPDATE nawt_paycard SET status='BLOCKED' WHERE series='$id' AND status <> 'BLOCKED'");
	}
	
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showSerie&id=$id");	
}

#-------------------------------------------------------------------
sub www_blockCard {
	checkAdmin;
	my $num = int($session{form}{id});	
	my %row = Nawt::SQL->quickHash("SELECT * FROM nawt_paycard WHERE number='$num' LIMIT 1");
	if ($row{status} eq "BLOCKED" && $row{account} ne "") {
		Nawt::SQL->write("UPDATE nawt_paycard SET status='ACTIVE' WHERE number='$num' LIMIT 1");
	} elsif ($row{status} eq "BLOCKED" && $row{account} eq "") {
		Nawt::SQL->write("UPDATE nawt_paycard SET status='OK' WHERE number='$num' LIMIT 1");
	} else {
		Nawt::SQL->write("UPDATE nawt_paycard SET status='BLOCKED' WHERE number='$num' LIMIT 1");
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showCard&id=$num");
}

#-------------------------------------------------------------------
sub www_activateCard {
	my ($num,$pin,$acc,%row);
		$num = int($session{form}{id});
	if (isValidAdmin && $num > 0) {
		$acc = $session{form}{acc};
		%row = Nawt::SQL->quickHash("SELECT * FROM nawt_paycard WHERE number = $num LIMIT 1");		
		if ($row{number} == $num && $row{status} eq "OK") {
			$session{netams}->setBalance(oid=>$acc,sum=>$row{nominal},mode=>"add");
			Nawt::SQL->write("UPDATE nawt_paycard SET status='ACTIVE', time_a=".time.", account='$acc' WHERE number='$num' LIMIT 1");
		}
		return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showCard&id=$num");
	} elsif (isUserAcc && $num > 0 && $session{form}{pin} ne "") {
		$acc = $session{var}{userId};
		%row = Nawt::SQL->quickHash("SELECT * FROM nawt_paycard WHERE number = $num LIMIT 1");		
		if ($row{number} == $num && $row{status} eq "OK" && $row{pin} eq $session{form}{pin}) {
			$session{netams}->setBalance(oid=>$acc,sum=>$row{nominal},mode=>"add");
			Nawt::SQL->write("UPDATE nawt_paycard SET status='ACTIVE', time_a=".time.", account='$acc' WHERE number='$num' LIMIT 1");
		}
		return Nawt::Theme::getRedirect("$ENV{SCRIPT_NAME}");
	} else {
		return Nawt::Theme::getRedirect("$ENV{SCRIPT_NAME}");
	}
}

#-------------------------------------------------------------------
sub www_saveCardSerie {
	checkAdmin();
	my(%html,$value,$count,$randomfile);
	$value = int($session{form}{value});
	$count = int($session{form}{count});
	my ($serie) = Nawt::SQL->quickArray("SELECT max(series) FROM nawt_paycard");
		$serie++;
	if ( ($value<1 or $value>10000) or ($count<10 or $count>1000) or ($serie<0) ) {
		return "Error, wrong params: $value, $count, $serie";
	} else {
		open($randomfile, '/dev/random');
		for (my $i=1; $i<=$count; $i++) {
			my (@pin);
			srand((ord getc $randomfile)*(ord getc $randomfile)*(ord getc $randomfile));
			my $number=sprintf "%03u%07u", $serie, rand(10000000);
			for (my $k=0; $k<4; $k++) { $pin[$k]=rand(100000); }
			my $pin=sprintf "%05d-%05d-%05d-%05d", @pin;
			my ($duplicate) = Nawt::SQL->quickArray("SELECT COUNT(*) FROM nawt_paycard WHERE series='$serie' AND number='$number'");
			redo if $duplicate;
			my $rows_affected = Nawt::SQL->write("INSERT INTO nawt_paycard VALUES ($serie, ".($number).", $value, \"$pin\", 'OK', UNIX_TIMESTAMP(), 0, '');");
			#if ($rows_affected ==0) { $total++; } else { $total_ok++; }
		}
		close($randomfile);
	}			
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showCardSeries");
}


1;
