package Nawt::Operation::Plan;
# $Id: Plan.pm,v 1.1 2005/02/09 00:10:49 ramirez Exp $

use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Navigation;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_showPlanList &www_editPlan 
	&www_editSubPlan &www_saveSubPlan &www_deleteSubPlan 
	&www_savePlan &www_deletePlan &www_removeSubplan &www_addSubplan);

#--------------------------------------------------------------------
sub www_showPlanList {
	checkAdmin();
	my ($result, %html, %s_bill, $row);
	$session{page}{title} = "Plans and Subplans";
		%s_bill = $session{netams}->getService("billing");
	
	# plans
	foreach (keys %{$s_bill{plan}}) {
		$row ++;
		delete $html{subplan};		
		if ($row % 2) { $html{rowclass} = "row0"; } else {	$html{rowclass} = "row1"; }
		$html{subplan} .= qq~<a href="?op=editSubPlan&id=$_">$_</a> ~ foreach (split " ",$s_bill{plan}{$_}{subplan});
		$html{plans} .= qq~<tr class="$html{rowclass}"><td width=16><img src="$session{config}{extrasURL}/images/dollar.gif"></td><td><a href="?op=editPlan&id=$_">$s_bill{plan}{$_}{name}</a></td><td>$html{subplan}</td><td>$s_bill{plan}{$_}{descr}</td></tr>~;
	}
	
	# Subplans
	foreach (sort keys %{$s_bill{subplan}}) {
		$row ++;
		my $fee = sprintf("%.3f",$s_bill{subplan}{$_}{fee});
		my ($inc,$over);
		if ($s_bill{subplan}{$_}{incl_sum} ne "") {
			$inc = sprintf("%.3f",$s_bill{subplan}{$_}{incl_sum});
		} else {
			$inc = sprintf("%.3f",$s_bill{subplan}{$_}{incl_in})."/".sprintf("%.3f",$s_bill{subplan}{$_}{incl_out});
		}
		if ($s_bill{subplan}{$_}{over_sum} ne "") {
			$over = sprintf("%.3f",$s_bill{subplan}{$_}{over_sum});
		} else {
			$over = sprintf("%.3f",$s_bill{subplan}{$_}{over_in})."/".sprintf("%.3f",$s_bill{subplan}{$_}{over_out});
		}		
		if ($row % 2) { $html{rowclass} = "row0"; } else {	$html{rowclass} = "row1"; }
		$html{subplans} .= qq~<tr class="$html{rowclass}"><td width=16><img src="$session{config}{extrasURL}/images/gear.gif"></td><td><a href="?op=editSubPlan&id=$_">Subplan $_</a></td><td>$s_bill{subplan}{$_}{policy}</td><td>$fee $s_bill{subplan}{$_}{spread}</td><td>$inc</td><td>$over</td></tr>~;
	}
		
	$result = qq~<a class=btn1 href="?op=editPlan">Add Plan</a>
	<table class=adminlist>
	<tr class=boxhead><td colspan=2>Name</td><td>Subplans</td><td>Description</td></tr>
	$html{plans}
	</table>
	<p>
	<a class=btn1 href="?op=editSubPlan">Add SubPlan</a>
	<table class=adminlist>
	<tr class=boxhead><td colspan=2>Name</td><td>Policy</td><td>Fee</td><td>Included</td><td>Overdraft</td></tr>
	$html{subplans}
	</table>
	~;
	return $result;
}

# @list = getPlanPolicyList ( id ) 
#--------------------------------------------------------------------
sub getPlanPolicyList {
	my ($id,%conf, @list);
	$id = shift;
	%conf = $session{netams}->getService('billing');
	if ($id !~ m/^\d+$/) {
		foreach (keys %{$conf{plan}}) {
			if ($conf{plan}{$_}{name} eq $id) {
				$id = $_;
				last;
			}
		}
	}
	foreach (split " ",$conf{plan}{$id}{subplan}) {
		push @list, $session{netams}->{config}{policies}{name2oid}{$conf{subplan}{$_}{policy}};
	}
	return @list;
}

#--------------------------------------------------------------------
sub www_editPlan {
	checkAdmin();
	my ($result, %conf, $id, %html);
	$id = int($session{form}{id});
	%conf = $session{netams}->getService('billing');
	$session{page}{title} = "Edit Plan";
	addFormToDisable('plan') if not canEdit('plan');
	addContMenuItem("Actions");
	addContMenuItem("Show All","?op=showPlanList");
	
	# For existing plan
	if (defined $conf{plan}{$id}) {
		$html{btndelete} = qq~<input type=button value="Delete" onclick="location.href='?op=deletePlan&id=$id'">~;
		my $subadd;
		my $subadded;
		foreach (keys %{$conf{subplan}}) {
			if ($conf{plan}{$id}{subplan} !~ m/(?:^| )$_(?:$| )/) {
				$subadd .= qq~<option value="$_">Subplan $_ ($conf{subplan}{$_}{policy})</option>~;
			}
		}
		
		foreach (split " ",$conf{plan}{$id}{subplan}) {
			my $fee = sprintf("%.3f",$conf{subplan}{$_}{fee});
			my ($inc,$over);
			if ($conf{subplan}{$_}{inc_sum} ne "") {
				$inc = sprintf("%.3f",$conf{subplan}{$_}{inc_sum});
			} else {
				$inc = sprintf("%.3f",$conf{subplan}{$_}{inc_in})."/".sprintf("%.3f",$conf{subplan}{$_}{inc_out});
			}
			if ($conf{subplan}{$_}{over_sum} ne "") {
				$over = sprintf("%.3f",$conf{subplan}{$_}{over_sum});
			} else {
				$over = sprintf("%.3f",$conf{subplan}{$_}{over_in})."/".sprintf("%.3f",$conf{subplan}{$_}{over_out});
			}
			$subadded .= qq~<tr><td width=16><img src="$session{config}{extrasURL}/images/gear.gif"></td>
				<td><a href="?op=editSubPlan&id=$_">Subplan $_</a></td>
				<td>$conf{subplan}{$_}{policy}</td>
				<td>$fee</td>
				<td>$inc</td>
				<td>$over</td>
				<td width=16><a href="?op=removeSubplan&pid=$id&sid=$_"><img src="$session{config}{extrasURL}/images/trash.gif" alt="Remove subplan"></a></td>
				</tr>~;
		}
		
		$html{subplans} = qq~
			<p>
			<table class=adminlist>
			<tr class=boxhead><td colspan=2>Subplans</td><td>Policy</td><td>Fee</td><td>Included</td><td>Overdraft</td><td></td></tr>
			$subadded
			</table>
			<select id=addSPlan>$subadd</select> <input type=button value="Add Subplan" onclick="location.href='?op=addSubplan&pid=$id&sid='+document.getElementById('addSPlan').value">
		~;
	}
	

		
	$result = qq~
	<DIV class=databox>
	<table>
	<form method="GET" action="$session{config}{scripturl}" id=plan>
	<input type="hidden" name="op" value="savePlan">	
	<input type="hidden" name="id" value="$id">
	<tr><td class="bold">Name</td><td><input type=text name="name" value="$conf{plan}{$id}{name}"></td></tr>
	<tr><td class="bold">Description</td><td><input type=text name="descr" value="$conf{plan}{$id}{descr}"></td></tr>
	<tr><td colspan=2><input type=submit value="Save"> $html{btndelete}</td></tr>
	</form>
	</table>
	</DIV>
	$html{subplans}
	~;
	return $result;
}

#--------------------------------------------------------------------
sub www_editSubPlan {
	checkAdmin();	
	my ($result, $id, %conf, %html);
	%conf = $session{netams}->getService('billing');
	$id = int($session{form}{id});
	$session{page}{title} = "Edit SubPlan";
	addFormToDisable('subplan') if not canEdit('plan');
	addContMenuItem("Actions");
	addContMenuItem("Show All","?op=showPlanList");
	
	foreach (qw (monthly daily hourly)) {
		if ($_ eq $conf{subplan}{$id}{spread}) {
			$html{spread} .= qq~<option value="$_" selected>$_</option>~;
		} else {
			$html{spread} .= qq~<option value="$_">$_</option>~;
		}
	}
	
	foreach (keys %{$session{netams}->{config}{policies}}) {
		next if $_ eq "name2oid";
		if ($conf{subplan}{$id}{policy} eq $session{netams}->{config}{policies}{$_}{name}) {
			$html{policy} .= qq~<option value="$_" selected>$session{netams}->{config}{policies}{$_}{name}</option>~;
		} else {
			$html{policy} .= qq~<option value="$_">$session{netams}->{config}{policies}{$_}{name}</option>~;
		}
	}
	
	# For EXISTING plan
	if (defined $conf{subplan}{$id}) {
		$html{btndelete} = qq~<input type=button value="Delete" onclick="location.href='?op=deleteSubPlan&id=$id'">~;
		# Used by plans
		my $planlist;
		foreach (keys %{$conf{plan}}) {
			if ($conf{plan}{$_}{subplan} =~ m/(?:^| )$id(?:$| )/) {
				$planlist .= qq~<tr><td width=16><img src="$session{config}{extrasURL}/images/dollar.gif"></td><td><a href="?op=editPlan&id=$_">$conf{plan}{$_}{name}</a></td></tr>~;
			}
		}
		$html{plans} = qq~
		<p>
		<div class=boxhead>This subplan used by plans:</div>
		<table class=adminlist>$planlist</table>
		~;
	}
	
	$html{adj_incl} = "checked" if $conf{subplan}{$id}{adjust_included} eq "yes";
	$html{adj_fee} = "checked" if $conf{subplan}{$id}{adjust_fee} eq "yes";
	
	$result = qq~
	<DIV class=databox>
	<table>
	<form method="GET" action="$session{config}{scripturl}" id=subplan>
	<input type="hidden" name="op" value="saveSubPlan">	
	<input type="hidden" name="id" value="$id">		
	<tr class=boxhead><td colspan=2>Subplan $id</td></tr>
	<tr><td class="bold">Policy</td><td><select name=policy>$html{policy}</select></td></tr>
	<tr><td class="bold">Fee</td><td><input type=text name="fee" value="$conf{subplan}{$id}{fee}"></td></tr>
	<tr><td class="bold">Spread</td><td><select name=spread>$html{spread}</select></td></tr>
	<tr><td class="bold">Adjust Fee</td><td><input type=checkbox name="adj_fee" $html{adj_fee} value=1></td></tr>
	<tr class=boxhead><td colspan=2>Included (Mb)</td></tr>
		<tr><td colspan=2><table><tr>
			<td>IN <input type=text name="incl_in" size=8 value="$conf{subplan}{$id}{incl_in}"></td>
			<td>OUT <input type=text name="incl_out" size=8 value="$conf{subplan}{$id}{incl_out}"></td>
			<td>SUM <input type=text name="incl_sum" size=8 value="$conf{subplan}{$id}{incl_sum}"></td>
			</tr></table>
		</td></tr>
	<tr><td class="bold">Adjust Included</td><td><input type=checkbox name="adj_incl" $html{adj_incl} value=1></td></tr>

	<tr class=boxhead><td colspan=2>Overdraft (\$)</td></tr>
		<tr><td colspan=2><table><tr>
			<td>IN <input type=text name="over_in" size=8 value="$conf{subplan}{$id}{over_in}"></td>
			<td>OUT <input type=text name="over_out" size=8 value="$conf{subplan}{$id}{over_out}"></td>
			<td>SUM <input type=text name="over_sum" size=8 value="$conf{subplan}{$id}{over_sum}"></td>
			</tr></table>
		</td></tr>
	<tr><td colspan=2><input type=submit value="Save"> $html{btndelete}</td></tr>
	</form>
	</table>	
	</DIV>
	$html{plans}
	~;
	return $result;	
}

#--------------------------------------------------------------------
sub www_saveSubPlan {
	checkAdmin();	
	my ($result, $id, %conf, %html, %op);
	%conf = $session{netams}->getService('billing');
	%op = %{$session{form}};
	$id = int($session{form}{id});
	return Nawt::Theme::getRedirect("?op=showPlanList") if not canEdit('plan');	
	if (!defined $conf{subplan}{$id}) {
		my $i;
		for ($i=1; $i<1000; $i++) {
			$id = $i;
			last if !defined $conf{subplan}{$id};
		}
	}
	if ($op{adj_fee}) { $html{adj_fee} = "yes"; } else { $html{adj_fee} = "no";	}
	if ($op{adj_incl}) { $html{adj_incl} = "yes"; } else { $html{adj_incl} = "no";	}
	$session{netams}->runCmd("service billing");
	$session{netams}->runCmd("subplan $id fee $op{fee} spread $op{spread}");
	$session{netams}->runCmd("subplan $id adjust-fee $html{adj_fee}");
	$session{netams}->runCmd("subplan $id policy $op{policy}");
	$session{netams}->runCmd("subplan $id included $op{incl_in} in $op{incl_out} out");
	$session{netams}->runCmd("subplan $id included $op{incl_sum} sum") if $op{incl_sum} ne "";
	$session{netams}->runCmd("subplan $id adjust-included $html{adj_incl}");
	$session{netams}->runCmd("subplan $id overdraft $op{over_in} in $op{over_out} out");
	$session{netams}->runCmd("subplan $id overdraft $op{over_sum} sum") if $op{over_sum} ne "";
	$session{netams}->runCmd("exit");
	$session{netams}->runCmd("save");
	return Nawt::Theme::getRedirect("?op=editSubPlan&id=$id");	
}

#--------------------------------------------------------------------
sub www_savePlan {
	checkAdmin();	
	my ($result, $id, %conf, %html, %op);
	%conf = $session{netams}->getService('billing');
	%op = %{$session{form}};
	$id = int($session{form}{id});
	return Nawt::Theme::getRedirect("?op=showPlanList") if not canEdit('plan');	
	if (!defined $conf{plan}{$id}) {
		my $i;
		for ($i=1; $i<1000; $i++) {
			$id = $i;
			last if !defined $conf{plan}{$id};
		}
	}
	$op{name} =~ s/ +/_/g;
	$op{descr} =~ s/[\"\']+//g; #'";

	$session{netams}->runCmd("service billing");
	$session{netams}->runCmd("plan $id name $op{name}");
	$session{netams}->runCmd("plan $id description \"$op{descr}\"");
	$session{netams}->runCmd("exit");
	$session{netams}->runCmd("save");
	return Nawt::Theme::getRedirect("?op=editPlan&id=$id");	
}

#--------------------------------------------------------------------
sub www_deleteSubPlan {
	checkAdmin();
	my $id = int($session{form}{id});
	if (canEdit('plan')) {
		$session{netams}->runCmd("service billing");		
		$session{netams}->runCmd("no subplan $id");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
	}
	return Nawt::Theme::getRedirect("?op=showPlanList");
}

#--------------------------------------------------------------------
sub www_deletePlan {
	checkAdmin();
	my $id = int($session{form}{id});
	if (canEdit('plan')) {
		$session{netams}->runCmd("service billing");		
		$session{netams}->runCmd("no plan $id");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
	}
	return Nawt::Theme::getRedirect("?op=showPlanList");
}

#--------------------------------------------------------------------
sub www_addSubplan {
	checkAdmin();	
	my ($pid,$sid,%conf);
	$pid = int($session{form}{pid});
	$sid = int($session{form}{sid});
	%conf = $session{netams}->getService('billing');
	if (canEdit('plan') and defined $conf{plan}{$pid}) {
		$session{netams}->runCmd("service billing");		
		$session{netams}->runCmd("plan $pid subplan $sid");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");			
	}
	return Nawt::Theme::getRedirect("?op=editPlan&id=$pid");	
}

#--------------------------------------------------------------------
sub www_removeSubplan {
	checkAdmin();
	my ($pid,$sid,%conf);
	$pid = int($session{form}{pid});
	$sid = int($session{form}{sid});	
	%conf = $session{netams}->getService('billing');	
	if (canEdit('plan') and defined $conf{plan}{$pid}) {
		$session{netams}->runCmd("service billing");		
		$session{netams}->runCmd("plan $pid no subplan $sid");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");			
	}	
	return Nawt::Theme::getRedirect("?op=editPlan&id=$pid");	
}

1;