package Nawt::Operation::Policy;
# $Id: Policy.pm,v 1.13 2005/04/20 14:28:43 ramirez Exp $
use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Navigation;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_showPolicyList &www_editPolicy &www_updatePolicy &www_deletePolicy);


#--------------------------------------------------------------------
sub www_showPolicyList {
	checkAdmin();
	my ($result, %html, %pols, $row, %proc);
		%pols = $session{netams}->getPolicy();
		%proc = $session{netams}->getService('processor');
		$session{page}{title} = "Policies";
		addContMenuItem("Actions");
		addContMenuItem("Add Policy","?op=editPolicy");		
		
	foreach (keys %pols) {
		next if $_ eq "name2oid";
		$row ++;
		if ($row % 2) { $html{rowclass} = "row0"; } else { $html{rowclass} = "row1"; }
		$html{icon} = qq~<img src="$session{config}{extrasURL}/images/filter_ico.gif">~;
		$html{icon} = qq~<a href="?op=editService&type=processor"><img src="$session{config}{extrasURL}/images/clients.gif" alt="This policy used as DEFAULT in service processor \n Be careful"></a>~ if $proc{'def-acct-policy'} =~ m/$pols{$_}{name}/ || $proc{'def-fw-policy'} =~ m/$pols{$_}{name}/;
		$html{pols} .= qq~<tr class="$html{rowclass}">
			<td width="20"><a href="?op=editPolicy&oid=$_">$html{icon}</a></td>
			<td><a href="?op=editPolicy&oid=$_">$pols{$_}{name}</a></td>
			<td>$pols{$_}{target}</td>
			<td width="20"><a href="$session{env}{scripturl}?op=deletePolicy&oid=$_"><img src="$session{config}{extrasURL}/images/trash.gif" alt="Delete policy..."></a></td>				
			</tr>~;
	}

	$result = qq~<p>
		<table class=adminlist>
			<tr><th colspan=2 class=title>Name</th><th class=title>Target</th><th></td></tr>
			$html{pols}
		</table>		

		~;
	return $result;
}

#--------------------------------------------------------------------
sub www_editPolicy {
	checkAdmin();
	my ($result, %html, %pol, $oid);
		$oid = $session{form}{oid};
		%pol = $session{netams}->getPolicy($oid);
		$html{proto} = getProtocols($pol{proto});
		$html{units} = getUnits($pol{units});
		
		$session{page}{title} = "Policy $pol{name} Configuration";

		addContMenuItem("Actions");
		addContMenuItem("Policy List","?op=showPolicyList");
		addContMenuItem("Delete","?op=deletePolicy&oid=$oid") if defined $oid;
		addContMenuItem("Add Policy","?op=editPolicy") if defined $oid;
		addFormToDisable('policy') if not canEdit('policy');
	$result = qq~
	<DIV class=databox>
			<table>
				<form method="GET" action="$session{env}{scripturl}" id=policy>
				<input type="hidden" name="op" value="updatePolicy">
				<input type="hidden" name="oid" value="$oid">
				<tr><td class="bold">OID</td><td>$oid</td></tr>
				<tr><td class="bold">Name</td><td><input type="text" NAME="name" value="$pol{name}"></td></tr>
				<tr><td class="bold">Proto</td><td>$html{proto}</td></tr>
				<tr><td class="bold">ToS</td><td><input type="text" NAME="tos" value="$pol{tos}" size="3"></td></tr>
				<tr><td class="bold">Ports</td><td><input type="text" NAME="port" value="$pol{port}"></td></tr>	
				<tr><td class="bold">Units oid</td><td>$html{units}</td></tr>	
				<tr><td class="bold">Prefix file</td><td><input type="text" NAME="file" value="$pol{file}"></td></tr>	
				<tr><td class="bold">Addr</td><td><input type="text" NAME="addr" value="$pol{addr}"></td></tr>	
				<tr><td class="bold">Interface (netflow)</td><td><input type="text" NAME="ifindex" value="$pol{ifindex}"></td></tr>	
				<tr><td class="bold">Policy-or</td><td><input type="text" NAME="policy-or" value="$pol{'policy-or'}"></td></tr>	
				<tr><td class="bold">Plicy-and</td><td><input type="text" NAME="policy-and" value="$pol{'policy-and'}"></td></tr>	
				<tr><td class="bold">Time</td><td><input type="text" NAME="time" value="$pol{time}"></td></tr>	
				<tr><td class="bold">Days</td><td><input type="text" NAME="day" value="$pol{day}"></td></tr>
				<tr><td class="bold">BW IN</td><td><input type="text" NAME="bw_in" value="$pol{bw_in}"></td></tr>	
				<tr><td class="bold">BW OUT</td><td><input type="text" NAME="bw_out" value="$pol{bw_out}"></td></tr>	
				<tr><td class="bold"></td><td><input type="submit" value="Save"></td></tr>
			</table>
	</DIV>
		~;

	return $result;
}

#--------------------------------------------------------------------
sub getUnits {
	my ($result, %units, $opts);
		%units = $session{netams}->getUnit();
	foreach (keys %units) {
		if ($_ eq $_[0] && $_ ne "name2oid") {
			$opts .= qq~<option value="$_" selected>$units{$_}{name}</option>~;
		} elsif ($_ ne "name2oid") {
			$opts .= qq~<option value="$_">$units{$_}{name}</option>~;
		}
	}
	$result = qq~<SELECT NAME="units"><option value=""></option>$opts</SELECT>~;
	return $result;
}

#--------------------------------------------------------------------
sub getProtocols {
	my (%proto, $opts, $result);
	open (FH, "/etc/protocols");
	my @lines = <FH>;
	close (FH);
	foreach (@lines) {
		#$_ =~ s/ +/|/g;
		my @pairs =	split(" ",$_);
		unless ($pairs[0] =~ m/\#/) {
			if ($_[0] eq $pairs[0]) {
				$opts .= qq~<option selected value="$pairs[0]">$pairs[0]</option>~; 
			} else {
				$opts .= qq~<option value="$pairs[0]">$pairs[0]</option>~; 
			}
		}

	}
	
	$result = qq~<SELECT NAME="proto"><option value=""></option>$opts</SELECT>~;
	return $result;
}

#--------------------------------------------------------------------
sub www_updatePolicy {
	checkAdmin();
	my (%pol, $oid, $cmd, $url);
		$oid = $session{form}{oid};
	
	$session{form}{name} =~ s/ +/_/g;
	foreach (keys %{$session{form}}) {
		$session{form}{$_} =~ s/^ +$//g;
	}
	
	$oid = $session{netams}->setPolicy(oid=>$session{form}{oid},
				name=>$session{form}{name},
				proto=>$session{form}{proto},
				tos=>$session{form}{tos},
				port=>$session{form}{port},
				units=>$session{form}{units},
				file=>$session{form}{file},
				addr=>$session{form}{addr},
				ifindex=>$session{form}{ifindex},
				policyor=>$session{form}{'policy-or'},
				policyand=>$session{form}{'policy-and'},
				time=>$session{form}{time},
				day=>$session{form}{day},
				bw_in=>$session{form}{bw_in},
				bw_out=>$session{form}{bw_out}
				) if canEdit('policy');

	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editPolicy&oid=$oid");
}

#--------------------------------------------------------------------
sub www_deletePolicy {
	checkAdmin();
	my (%pol, $oid, $cmd, $url, $msg);
		$oid = $session{form}{oid};
		%pol = $session{netams}->getPolicy($oid);	

	foreach (keys %{$session{form}}) {
		$session{form}{$_} =~ s/^ +$//g;
	}	

	if (canEdit('policy') and $session{form}{confirmed}) {
		$session{netams}->runCmd("service processor");
		$session{netams}->runCmd("no policy oid $oid");
		$session{netams}->runCmd("exit");
		return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showPolicyList");

	} else {
		$session{page}{title} = "Delete Policy";
		my %proc = $session{netams}->getService("processor");
		if ($proc{'def-acct-policy'} =~ m/$pol{name}/ || $proc{'def-fw-policy'} =~ m/$pol{name}/) {
			$msg = qq~ <br><b>Warning:</b> You are deleting <b>DEFAULT</b> policy. This policy applied to ALL units.~;
		}
		return qq~Are you really want delete policy <b>$pol{name}</b> ($oid)? Be careful, all counted data will be lost! $msg 
			<p><a class=btn1 href="$session{env}{scripturl}?op=deletePolicy&oid=$oid&confirmed=1">Delete</a> <a class=btn1 href="$session{env}{scripturl}?op=showPolicyList">Cnacel</a> </p>~;
	}
}

1;