package Nawt::Operation::Report;
# $Id$

use strict;
use Exporter;
use Nawt::SQL;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::DateTime;
use Nawt::Theme;
use Nawt::Navigation;
	
our @ISA = qw( Exporter ); 
our @EXPORT = qw(&www_showReport);

#--------------------------------------------------------------------
sub www_showReport {
	checkAdmin();
	my ($result,%html,$oid,@now,$month,$year,%acc,%conf);
	$session{page}{title} = "Balance Detail Report";
	$oid = $session{form}{oid} || return "Bad account";
	%acc = $session{netams}->getAccount($oid);
	@now = localtime();
	$session{form}{date} = "$now[0]-$now[1]" if $session{form}{date} !~ m/^\d{4}-\d{1,2}$/;
	($year,$month) = split "-",$session{form}{date};
	$html{month} = Nawt::DateTime::getMonthName($month);
	$html{now} = epochToHuman(time,"%y.%m.%d %j:%n:%s");
	%conf = $session{netams}->getService('billing');
	# find plan
	foreach (keys %{$conf{plan}}) {
		if ($conf{plan}{$_}{name} eq $acc{plan}) {
			# process subplans
			foreach (split " ",$conf{plan}{subplan}) {
				$conf{subplan}{$_}{fee};
			}
			
			
			last;
		} 
	}

	
	$result = qq~
	<table>
		<tr><td align=right>Creation Time:</td><td class=bold>$html{now}</td></tr>
		<tr><td align=right>Period:</td><td class=bold>$html{month} $year</td></tr>
		<tr><td align=right>Account:</td><td class=bold>$acc{name}</td></tr>
		<tr><td align=right>Tarif:</td><td class=bold>$acc{plan}</td></tr>
		<tr><td align=right>Balance:</td><td class=bold>$acc{balance}</td></tr>
	</table>
	~;
			
	return $result;	
}


1;