package Nawt::Operation::Service;
# $Id: Service.pm,v 1.11 2005/04/11 18:03:45 ramirez Exp $

use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Theme;
use Nawt::Navigation;
use Nawt::Language;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_editService 
	&www_saveSchedule 
	&www_deleteSchedule 
	&www_saveService 
	&www_deleteService );

	
#--------------------------------------------------------------------
sub www_editService {
	checkAdmin();
	my ($result, %html, $type);
		$type = $session{form}{type} || "main";
		$session{form}{type} = $type;

	if ($type eq "scheduler") {
		$html{body} = editScheduler();
	} elsif ($type eq "server") {
		$html{body} = editServer();
	} elsif ($type eq "processor") {
		$html{body} = editProcessor();
	} elsif ($type eq "storage") {
		$html{body} = editStorage();
	} elsif ($type eq "dsource") {
		$html{body} = editDataSource();
	} elsif ($type eq "alerter") {
		$html{body} = editAlerter();
	} elsif ($type eq "html") {
		$html{body} = editHtml();
	} elsif ($type eq "monitor") {
		$html{body} = editMonitor();
	} elsif ($type eq "quota") {
		$html{body} = editQuota();
	} elsif ($type eq "login") {
		$html{body} = editLogin();
	} elsif ($type eq "billing") {
		$html{body} = editBilling();
	} elsif ($type eq "acl") {
		$html{body} = editAcl();
	}else {
		$session{form}{type} = "main";
		$html{body} = editMain();
	}
	
	return $html{body};
}


#--------------------------------------------------------------------
sub editMain {
	checkAdmin();
	my ($result, %conf, %html, @users, $row);
		%conf = $session{netams}->getService('main');
		$session{page}{title} = "Service Main";
		addContMenuItem("Actions");
		addContMenuItem($LANG{NAWT_MANAGE}." ".$LANG{USER_USERS},"?op=showUserList");
		addFormToDisable('service') if (not canEdit('service'));
		
	my $i = 0;
	foreach ($session{netams}->getDebugTypes()) {
		my $item;
		if ($conf{debug} =~ m/$_/) {
			$item .= qq~<td><input type=checkbox name=dbg_$_ value=1 checked></td><td>$_</td>~;
		} else {
			$item .= qq~<td><input type=checkbox name=dbg_$_ value=1></td><td>$_</td>~;
		}
		if ($i%2) {
			$html{debugTypes} .= $item."</tr>";
		} else {
			$html{debugTypes} .= "<tr>".$item;
		}
		$i++;		
	}
	
	# getting mac-control settings
	my %s_sched;
	%s_sched = $session{netams}->getService('scheduler');
	foreach (keys %s_sched) {
		if ($s_sched{$_}{action} =~ m/^mac (control) ?(block|alert)?/) {
			$html{mac_control} = qq~ MAC-control Enabled ~;
		}
	}
	
	$result = qq~
	<DIV class=databox>
		<DIV class=boxhead>Debug options</DIV>
		<DIV class=boxinner>
			<FORM METHOD="GET" ACTION="$ENV{SCRIPT_NAME}" ID=service>
				<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
				<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
				<table>$html{debugTypes}</table>
				<p><input type="submit" value="Save">
			</FORM>
		</DIV>
	</DIV>
	
	<DIV class=pagetitle>MAC control</DIV>
	
			
	~;
	
	return $result;	
}


#--------------------------------------------------------------------
sub editProcessor {
	my ($result, %conf, %html, @users, %st, %pols);
		%conf = $session{netams}->getService('processor');
		%pols = $session{netams}->getPolicy();
		$session{page}{title} = "Service Processor";
		addContMenuItem("Actions");
		addContMenuItem("Manage AutoUnits","?op=showAutoUnits");
		addFormToDisable('service') if (not canEdit('service'));
	
	$conf{'def-acct-policy'} =~ s/[!&]{0,2}(\w{6})/$pols{$1}{name}/g;
	$conf{'def-fw-policy'} =~ s/[!&]{0,2}(\w{6})/$pols{$1}{name}/g;
		
	if ($conf{'restrict-all'} eq "drop") {
		$html{resall} = qq~<option value="pass">PASS</option><option value="drop" selected>DROP</option>~;
	} else {
		$html{resall} = qq~<option value="pass" selected>PASS</option><option value="drop">DROP</option>~;
	}
	if ($conf{'restrict-local'} eq "drop") {
		$html{resloc} = qq~<option value="pass">PASS</option><option value="drop" selected>DROP</option>~;
	} else {
		$html{resloc} = qq~<option value="pass" selected>PASS</option><option value="drop">DROP</option>~;
	}
	
	foreach (split " ",$conf{"auto-assign"}) {
		$html{autoass} .= "$_\n";
	}
	
	my @lines = $session{netams}->runCmd("show processor");
	$html{proc} .= "$_" foreach @lines;

	$result = qq~
	<p>
	<DIV class=databox>
		<table>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
			<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
			<tr><td class="bold" width="150">Lookup delay</td><td><input type="text" name="lookup-delay" value="$conf{'lookup-delay'}"></td></tr>
			<tr><td class="bold">Flow lifetime</td><td><input type="text" name="flow-lifetime" value="$conf{'flow-lifetime'}"></td></tr>
			<tr><td class="bold">Default acct-policy set</td><td><input type="text" name="def-acct-policy" value="$conf{'def-acct-policy'}"></td></tr>
			<tr><td class="bold">Default fw-policy set</td><td><input type="text" name="def-fw-policy" value="$conf{'def-fw-policy'}"></td></tr>
			<tr><td class="bold">Restrict</td><td><b>all:</b> <select name="restrict-all">$html{resall}</select> <b>local:</b> <select name="restrict-local">$html{resloc}</select></td></tr>
			<tr><td class="bold">Access script</td><td><input type="text" name="access-script" value="$conf{'access-script'}"></tr>
			<tr><td class="bold">Auto Assign<BR><i>One diapason per row.<br>Example: 10.10.10.2-10.10.10.50</i></td><td><textarea name="autoassign" rows="5" cols="31">$html{autoass}</textarea></tr>
			<tr><td colspan="2" class="ceneter"><input type="submit" value="Apply settings..."></td></tr>
			</FORM>
		</table>
	</DIV>
	<p>
	<DIV class=databox>
	<pre>$html{proc}</pre>
	</DIV>
	~;
	
	return $result;	
}

#--------------------------------------------------------------------
sub editScheduler {
	my ($result, %conf, %html, @users, $row);
		%conf = $session{netams}->getService('scheduler');
		$session{page}{title} = "Service Scheduler";
		addFormToDisable('service') if (not canEdit('service'));
		
	foreach (keys %conf) {
		$row++;
		if ($row % 2) { $html{rowclass} = "row0"; } else { $html{rowclass} = "row1"; }
		addFormToDisable($_) if (not canEdit('service'));
		$html{body} .= qq~
		<tr class=$html{rowclass}>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=$_>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveSchedule">
			<INPUT TYPE="hidden" NAME="oid" VALUE="$_">			
			<td>$_</td><td><input type="text" name="time" value="$conf{$_}{time}"></td>
			<td><input type="text" name="action" size="40" value="$conf{$_}{action}"></td>
			<td width="10"><input type="submit" value="Save"></td>
			<td width="10"><input type="button" value="Delete" onclick="window.location='?op=deleteSchedule&oid=$_'"></td>
			</FORM>
		</tr>~ if $_ =~ m/^\w{6}$/;
	};
	
	$result = qq~
		<table class=adminlist>
			<tr><th class=title>OID</th><th class=title>Time</th><th colspan="3" class=title>Command</th></tr>
			$html{body}
			<tr><th colspan="5">Add new task</th></tr>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveSchedule">
			<INPUT TYPE="hidden" NAME="oid" VALUE="_new">	
			<tr><td></td>
				<td><input type="text" name="time" value=""></td>
				<td><input type="text" size="40" name="action" value=""></td>
				<td colspan="2"><input type="submit" value="Create"></td>
			</tr>
			</FORM>
		</table>
		~;
	
	return $result;	
}

#--------------------------------------------------------------------
sub www_deleteSchedule {
	checkAdmin();
	my $oid;
	$oid = $session{form}{oid};
	if ($oid =~ m/\w{6}/ and canEdit('service')) {
		$session{netams}->runCmd("service scheduler");
		$session{netams}->runCmd("no oid $oid");
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editService&type=scheduler");	
}

#--------------------------------------------------------------------
sub www_saveSchedule {
	checkAdmin();
	my $oid;
#	foreach (keys %{$session{form}}) {
#		$session{form}{$_} =~ s/ {2,}/ /g;
#	}	
	$oid = $session{form}{oid};
	if (canEdit('service') and $oid ne "" && $session{form}{time} ne "" && $session{form}{action} ne "") {
		$session{netams}->runCmd("service scheduler");		
		if ($oid ne "_new") {
			$session{netams}->runCmd("oid $oid time $session{form}{time} action \"$session{form}{action}\"");		
		} else {
			$session{netams}->runCmd("time $session{form}{time} action \"$session{form}{action}\"");		
		}
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editService&type=scheduler");	
}


#--------------------------------------------------------------------
sub editAcl {
	my ($result, %conf, %html);
		%conf = $session{netams}->getService('acl-server',1);
		$session{page}{title} = "ACL-Servers Configuration";
		addFormToDisable('service') if (not canEdit('service'));
		
	foreach (sort keys %conf) {
		my $srvid = $_;
		
		if ($conf{$_}{direction} eq "src") {
			$html{direct} = qq~<option value="src" selected>src</option><option value="dst">dst</option>~;
		} else {
			$html{direct} = qq~<option value="src">src</option><option value="dst" selected>dst</option>~;
		}
		
		$html{list} .= qq~
		<DIV class=databox>
			<DIV class=boxhead>Service $_</DIV>
			<table>
				<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
				<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
				<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
				<INPUT TYPE="hidden" NAME="id" VALUE="$conf{$_}{id}">
				<tr><td class="bold">Hostname</td><td><input type="text" name="hostname" value="$conf{$_}{hostname}"></td></tr>
				<tr><td class="bold">Direction</td><td><select name=direction>$html{direct}</select></td></tr>
				<tr><td class="bold">Dynamic Name</td><td><input type="text" name="dynamic-name" value="$conf{$_}{'dynamic-name'}"></td></tr>
				<tr><td class="bold">Delay</td><td><input type="text" name="delay" value="$conf{$_}{'delay'}"></td></tr>
				<tr><td class="bold">Set Uptime</td><td><input type="text" name="set-uptime" value="$conf{$_}{'set-uptime'}"></td></tr>
				<tr><td colspan="2"><input type="submit" value="Save"> <input type=button value="Delete" onclick="location.href='?op=deleteService&type=acl'"></td></tr>
				</FORM>
			</table>
		</DIV>
		<p>
		~;
	}
	$result = qq~$html{list}
	<input type="button" value="Add ACL-Server" onclick="location.href='?op=saveService&type=acl'">
	~;
	return $result;	
}

#--------------------------------------------------------------------
sub editServer {
	my ($result, %conf, %html);
		%conf = $session{netams}->getService('server');
		$session{page}{title} = "Service Server";
		addFormToDisable('service') if (not canEdit('service'));
		
	if ($conf{login} eq "local") {
		$html{login} = qq~<option value="local" selected>localhost</option><option value="any">any host</option>~;
	} else {
		$html{login} = qq~<option value="local">localhost</option><option value="any" selected>any host</option>~;
	}

	$result = qq~
	<DIV class=databox>
		<table>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
			<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
			<tr class="row-2"><td class="bold" width="150">Allow login from</td><td><select name="login">$html{login}</select></td></tr>
			<tr class="row-2"><td class="bold">Listen port</td><td>$conf{listen}</td></tr>
			<tr class="row-2"><td class="bold">Max connections</td><td><input type="text" name="max-conn" value="$conf{'max-conn'}" size=6></td></tr>
			<tr class="row-category"><td colspan="2"><input type="submit" value="Save"></td></tr>
			</FORM>
		</table>
	</DIV>
	~;
	
	return $result;	
}

#--------------------------------------------------------------------
sub editAlerter {
	my ($result, %conf, %html);
		%conf = $session{netams}->getService('alerter');
		addFormToDisable('service') if (not canEdit('service'));
		
	my @info = $session{netams}->runCmd("show alerter");
	
	$result = qq~<p align="center">
		<table>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
			<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
			<tr class="row-category"><td colspan="2">Service ALERTER</td></tr>
			<tr class="row-2"><td class="bold" width="150">Service status</td><td>$info[1]</td></tr>
			<tr class="row-2"><td class="bold">SMTP server</td><td><input type="text" name="smtp-server" value="$conf{'smtp-server'}"></td></tr>
			<tr class="row-category"><td colspan="2"><input type="submit" value="Save"></td></tr>
			</FORM>
		</table>
		~;
	
	return $result;	
}

#--------------------------------------------------------------------
sub editBilling {
	my ($result, %conf, %html, %st);
		$session{page}{title} = "Service Billing";
		addFormToDisable('service') if (not canEdit('service'));
		
	if ($session{netams}->hasService('billing')) {
		%conf = $session{netams}->getService('billing');
		addContMenuItem("Actions");
		addContMenuItem("Manage Plans","?op=showPlanList");
		addContMenuItem("Manage Accounts","?op=showAccountList");
	} else {
		return qq~<input type="button" value="Create service Billing" onclick="location.href='?op=saveService&type=billing'">~;
	}	

	$result = qq~
	<DIV class=databox>
		<table>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
			<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
			<tr><td class="bold">Delay (sec)</td><td><input type="text" name="delay" size="4" value="$conf{delay}"></td></tr>
			<tr><td class="bold">Default Credit Limit</td><td><input type="text" name="default-credit-limit" value="$conf{'default-credit-limit'}"></td></tr>
			<tr><td colspan="2"><input type="submit" value="Save"> <input type="button" value="Delete" onclick="location.href='?op=deleteService&type=billing'"></td></tr>
			</FORM>
		</table>
	</DIV>
	~;
	
	return $result;	
}

#--------------------------------------------------------------------
sub editDataSource {
	my ($result, %conf, %html, @type, @srcs, %src);
		%conf = $session{netams}->getService('data-source',1);
		@type = $session{netams}->getDataSourceTypes();
		$session{page}{title} = "Data-Sources Configuration";
		%src = (tee=>"ip-traffic",divert=>"ip-traffic",ipq=>"ip-traffic",ulog=>"ip-traffic","a.b.c.d"=>"netflow",ifname=>"libpcap",nodename=>"netgraph");
	foreach (@type) {
		$html{types} .= qq~<option value="$_">$_</option>~;
	}
	

	foreach (sort keys %conf) {
		my $srvid = $_;
		my $srcs;
		my $opts;
		foreach (keys %src) {
			if ($conf{$srvid}{type} eq $src{$_}) {
				if ($conf{$srvid}{source} =~ m/$_/) {
					$srcs .= qq~<option value="$_" selected>$_</option>~;
				} else {
					$srcs .= qq~<option value="$_">$_</option>~;
				}
			}
		}
		# NETFLOW
		if ($conf{$srvid}{type} eq "netflow") {
			my $clock;
			foreach (qw(local remote)) {
				if ($_ eq $conf{$srvid}{clock}) {
					$clock .= qq~<option value="$_" selected>$_</option>~;
				} else {
					$clock .= qq~<option value="$_">$_</option>~;
				}
			}
			$opts = qq~
				<tr><td class="bold">Listen IP Port</td><td><input type="text" name="listen" value="$conf{$_}{listen}"></td></tr>
				<tr><td class="bold">Clock</td><td><select name="clock">$clock</select></td></tr>
				~;			
		# IP-TRAFFIC
		} elsif ($conf{$srvid}{type} eq "ip-traffic") {
			if ($conf{$srvid}{source} =~ m/(tee|divert) (\d+)/) {
				$opts = qq~<tr><td class="bold">Port</td><td><input type="text" name="port" value="$2"></td></tr>~;			
			} elsif ($conf{$srvid}{source} =~ m/ulog (.+)$/) {
				$opts = qq~<tr><td class="bold">Port</td><td><input type="text" name="port" value="$1"></td></tr>~;			
			}
		# LIBPCAP
		} elsif ($conf{$srvid}{type} eq "libpcap") {
			$opts = qq~<tr><td class="bold">Ifname</td><td><input type="text" name="ifname" value="$conf{$_}{ifname}"></td></tr>~;			
		# NETGRAPH
		} elsif ($conf{$srvid}{type} eq "netgraph") {
			$opts = qq~<tr><td class="bold">Nodename</td><td><input type="text" name="nodename" value="$conf{$_}{nodename}"></td></tr>~;			
		}
		if ($conf{$srvid}{type} ne "netflow") {
			$html{source} = qq~<select name="source">$srcs</select>~;
		} else {
			$conf{$srvid}{source} =~ s/ /\n/g;
			$html{source} = qq~<textarea rows=5 name="source">$conf{$srvid}{source}</textarea>~;
		}
		addFormToDisable("ds$conf{$_}{id}") if (not canEdit('service'));
		$html{list} .= qq~
		<DIV class=databox>
			<DIV class=boxhead>Service $_</DIV>		
			<table>
				<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=ds$conf{$_}{id}>
				<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
				<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
				<INPUT TYPE="hidden" NAME="id" VALUE="$conf{$_}{id}">
				<tr><td class="bold">Type</td><td>$conf{$_}{type}</td></tr>
				<tr><td class="bold">Source</td><td>$html{source}</td></tr>
				$opts
				<tr><td colspan="2"><input type="submit" value="Save"> <input type=button value="Delete" onclick="location.href='?op=deleteService&type=dsource&id=$conf{$_}{id}'"></td></tr>
				</FORM>
			</table>
		</DIV>
		<p>
		~;
	}
	$html{ds} .= "$_" foreach $session{netams}->runCmd("show ds");	
	$result = qq~$html{list}
		<select id="newType">$html{types}</select><input type="button" value="Add Data-Source" onclick="location.href='?op=saveService&type=dsource&stype='+document.getElementById('newType').value">
	<p><DIV class=databox><pre>$html{ds}</pre></DIV>
		~;
	return $result;	
}

#--------------------------------------------------------------------
sub editHtml {
	my ($result, %conf, %html);
		%conf = $session{netams}->getService('html');
		$session{page}{title} = "Service HTML";
		addFormToDisable('service') if (not canEdit('service'));
		
	if (not $session{netams}->hasService("html")) {
		return qq~<input type="button" value="Create service HTML" onclick="location.href='?op=saveService&type=html'">~;
	}	
	
	foreach (qw(all groups none)) {
		if ($conf{'client-pages'} =~ m/$_/) {
			$html{cpages} .= qq~<option value="$_" selected>$_</option>~;
		} else {
			$html{cpages} .= qq~<option value="$_">$_</option>~;
		}
	}
	
	foreach (qw(all none)) {
		if ($conf{'account-pages'} =~ m/$_/) {
			$html{apages} .= qq~<option value="$_" selected>$_</option>~;
		} else {
			$html{apages} .= qq~<option value="$_">$_</option>~;
		}
	}
	
	foreach (qw(yes no)) {
		if ($conf{htaccess} =~ m/$_/) {
			$html{htaccess} .= qq~<option value="$_" selected>$_</option>~;
		} else {
			$html{htaccess} .= qq~<option value="$_">$_</option>~;
		}
	}
	
	$result = qq~
	<DIV class=databox>
		<table>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
			<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
			<tr><td class="bold">Language</td><td>$conf{language}</td></tr>
			<tr><td class="bold">Run</td><td><input type="text" name="run" value="$conf{run}"></td></tr>
			<tr><td class="bold">Path</td><td><input type="text" size=40 name="path" value="$conf{path}"></td></tr>
			<tr><td class="bold">URL</td><td><input type="text" size=40 name="url" value="$conf{url}"></td></tr>
			<tr><td class="bold">Servlet URL</td><td><input type="text" name="servlet-url" value="$conf{'servlet-url'}"></td></tr>
			<tr><td class="bold">.htaccess</td><td><select name="htaccess">$html{htaccess}</select></td></tr>
			<tr><td class="bold">Client pages</td><td><select name="client-pages">$html{cpages}</select></td></tr>
			<tr><td class="bold">Account pages</td><td><select name="account-pages">$html{apages}</select></td></tr>
			<tr><td colspan="2"><input type="submit" value="Save"> <input type="button" value="Delete" onclick="location.href='?op=deleteService&type=html'"></td></tr>
			</FORM>
		</table>
	</DIV>
	~;
	
	return $result;	
}

#--------------------------------------------------------------------
sub editLogin {
	my ($result, %conf, %html);
		$session{page}{title} = "Service Login";
		%conf = $session{netams}->getService('login');
		addFormToDisable('service') if (not canEdit('service'));
		
	if (not $session{netams}->hasService("login")) {
		return qq~<input type="button" value="Create service Login" onclick="location.href='?op=saveService&type=login'">~;
	}
	
	addContMenuItem("Actions");
	addContMenuItem("Login Status","?op=showLoginList");
	
	foreach (qw(yes no)) {
		if ($conf{'set-user-ip'} =~ m/$_/) {
			$html{setip} .= qq~<option value="$_" selected>$_</option>~;
		} else {
			$html{setip} .= qq~<option value="$_">$_</option>~;
		}
		if ($conf{relogin} =~ m/$_/) {
			$html{relogin} .= qq~<option value="$_" selected>$_</option>~;
		} else {
			$html{relogin} .= qq~<option value="$_">$_</option>~;
		}		
	}
	
	$result = qq~
	<DIV class=databox>
		<table>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
			<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
			<tr><td class="bold">default-inact (sec)</td><td ><input type="text" size="6" name="default-inact" onblur="isNumber(this)" value="$conf{'default-inact'}"></td></tr>
			<tr><td class="bold">max-inact (sec)</td><td><input type="text" size="6" name="max-inact" onblur="isNumber(this)" value="$conf{'max-inact'}"></td></tr>
			<tr><td class="bold">min-inact (sec)</td><td><input type="text" size="6" name="min-inact" onblur="isNumber(this)" value="$conf{'min-inact'}"></td></tr>
			<tr><td class="bold">default-abs (sec)</td><td><input type="text" size="6" name="default-abs" onblur="isNumber(this)" value="$conf{'default-abs'}"></td></tr>
			<tr><td class="bold">max-abs (sec)</td><td><input type="text" size="6" name="max-abs" onblur="isNumber(this)" value="$conf{'max-abs'}"></td></tr>
			<tr><td class="bold">min-abs (sec)</td><td><input type="text" size="6" name="min-abs" onblur="isNumber(this)" value="$conf{'min-abs'}"></td></tr>
			<tr><td class="bold">min password length</td><td><input type="text" size="6" name="min_passwd_length" onblur="isNumber(this)" value="$conf{'min_passwd_length'}"></td></tr>
			<tr><td class="bold">Delay (sec)</td><td><input type="text" size="6" name="delay" onblur="isNumber(this)" value="$conf{delay}"></td></tr>
			<tr><td class="bold">Set user IP</td><td><select name="set-user-ip">$html{setip}</select></td></tr>
			<tr><td class="bold">Relogin</td><td><select name="relogin">$html{relogin}</select></td></tr>
			<tr><td colspan="2"><input type="submit" value="Save"> <input type="button" value="Delete" onclick="location.href='?op=deleteService&type=login'"></td></tr>
			</FORM>
		</table>
	</DIV>
	~;
	
	return $result;	
}

#--------------------------------------------------------------------
sub editMonitor {
	my ($result, %mon, %html, %ds, @list, %units);
		%mon = $session{netams}->getService('monitor',1);
		%ds = $session{netams}->getService('storage',1);
		%units = $session{netams}->getUnit();
		$session{page}{title} = "Service Monitor";
		addFormToDisable('service') if not canEdit('service');
	
	foreach (sort keys %mon) {
		my ($oid, $sname);
		$oid = $1 if $_ =~ m/monitor (\d+)/;
		$sname = $_;
		delete $html{dslist};
		delete $html{units};
		# building storage list
		foreach (sort keys %ds) {
			if ($mon{$sname}{type}) {
				$html{dslist} .= qq~<option value="$ds{$_}{id}" selected>$_</option>~;
			} else {
				$html{dslist} .= qq~<option value="$ds{$_}{id}">$_</option>~;
			}
		}
		if ($mon{$_}{type} eq "storage") {
			$html{r1} = qq~<input type="radio" name="to" value="file">~;
			$html{r2} = qq~<input type="radio" name="to" value="storage" checked>~;
		} else {
			$html{r1} = qq~<input type="radio" name="to" value="file" checked>~;
			$html{r2} = qq~<input type="radio" name="to" value="storage">~;
			$html{file} = $mon{$_}{targ};			
		}
		
		foreach (split " ",$mon{$sname}{units}) {
			$html{units} .= qq~<a href="?op=editUnit&fn=Monitor&oid=$_">$units{$_}{name}</a> ~;
		}
		
		$html{result} .= qq~
		<DIV class=databox>
		<DIV class=boxhead>Service $_</DIV>
		<table>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
			<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
			<INPUT TYPE="hidden" NAME="id" VALUE="$mon{$_}{id}">
			<tr><td class="bold" width="150" rowspan="2">Monitor to</td><td>$html{r1}<b>File: </b><input type="text" name="file" value="$html{file}"></td></tr>
			<tr><td>$html{r2}<b>Storage: </b><select name="storage">$html{dslist}</select></td></tr>
			<tr><td class="bold">Monitoring units</td><td>$html{units}</td></tr>
			<tr><td colspan="2"><input type="submit" value="Save"> <input type="button" value="Delete" onclick="location.href='?op=deleteService&type=monitor&id=$mon{$_}{id}'"></td></tr>
			</FORM>
		</table>
		</DIV>
		<p>
		~;
	}
	
	# Result
	$result = qq~
	$html{result}
	<p>
	<input type="button" value="Add Monitor" onclick="location.href='?op=saveService&type=monitor'">
	~;

	return $result;	
}

#--------------------------------------------------------------------
sub editQuota {
	my ($result, %conf, %html, %pols);
		%conf = $session{netams}->getService('quota');
		%pols = $session{netams}->getPolicy();
		$session{page}{title} = "Service Quota";
		addFormToDisable('service') if (not canEdit('service'));

	if (not $session{netams}->hasService("quota")) {
		return qq~<input type="button" value="Create service Quota" onclick="location.href='?op=saveService&type=quota'">~;
	}

	foreach (keys %pols) {
		if ($_ ne "name2oid") { 
			if ($conf{policy} eq $pols{$_}{name}) {
				$html{pols} .= qq~<option value="$pols{$_}{name}" selected>$pols{$_}{name}</option>~;
			} else {
				$html{pols} .= qq~<option value="$pols{$_}{name}">$pols{$_}{name}</option>~;
			}
			if ($conf{'block-policy'} eq $pols{$_}{name}) {
				$html{bpols} .= qq~<option value="$pols{$_}{name}" selected>$pols{$_}{name}</option>~;
			} else {
				$html{bpols} .= qq~<option value="$pols{$_}{name}">$pols{$_}{name}</option>~;
			}			
		}
	}

	$result = qq~
	<DIV class=databox>
		<table>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=service>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
			<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
			<tr><td class="bold">Default policy</td><td><select name="policy"><option value=""></option>$html{pols}</select></td></tr>
			<tr><td class="bold">Block policy</td><td><select name="block-policy"><option value=""></option>$html{bpols}</select></td></tr>
			<tr><td class="bold">Soft-treshold (%)</td><td><input type="text" name="soft-treshold" size="6" value="$conf{'soft-treshold'}"></td></tr>
			<tr><td class="bold">Delay (sec)</td><td><input type="text" name="delay" size="6" value="$conf{delay}"></td></tr>
			<tr><td colspan="2"><input type="submit" value="Save"> <input type="button" value="Delete" onclick="location.href='?op=deleteService&type=quota'"></td></tr>
			</FORM>
		</table>
	~;
	
	return $result;	
}

#--------------------------------------------------------------------
sub editStorage {
	my ($result, %conf, %html, @list, @type);
		%conf = $session{netams}->getService('storage',1);
		@type = $session{netams}->getStorageTypes();
		$session{page}{title} = "Sorages Configuration";
	
	foreach (@type) {
		$html{types} .= qq~<option value="$_">$_</option>~;
	}
	
	foreach (sort keys %conf) {
		my $opt;
		# TYPE RELATED OPTIONS
		if ($conf{$_}{type} eq "hash") {
			$opt = qq~<tr><td class="bold">Path</td><td><input type="text" name="path" value="$conf{$_}{path}"></td></tr>~;
		} elsif ($conf{$_}{type} =~ m/mysql|oracle|postgres/) {
			$opt = qq~<tr><td class="bold">User</td><td><input type="text" name="user" value="$conf{$_}{user}"></td></tr>
				<tr><td class="bold">Password</td><td><input type="text" name="password" value="$conf{$_}{password}"></td></tr>
				<tr><td class="bold">Database Name</td><td><input type="text" name="dbname" value="$conf{$_}{dbname}"></td></tr>
				<tr><td class="bold">Host</td><td><input type="text" name="host" value="$conf{$_}{host}"></td></tr>			
				<tr><td class="bold">Port</td><td><input type="text" name="port" value="$conf{$_}{port}"></td></tr>	
				<tr><td class="bold">Socket</td><td><input type="text" name="socket" value="$conf{$_}{socket}"></td></tr>
			~;
		} elsif ($conf{$_}{type} eq "radius") {
			$opt = qq~<tr><td class="bold">Port</td><td><input type="text" name="port" value="$conf{$_}{port}"></td></tr>
			<tr><td class="bold">Retry</td><td><input type="text" name="retry" value="$conf{$_}{retry}"></td></tr>
			<tr><td class="bold">Timeout</td><td><input type="text" name="timeout" value="$conf{$_}{timeout}"></td></tr>
			<tr><td class="bold">Nas-IP</td><td><input type="text" name="nas_ip" value="$conf{$_}{nas_ip}"></td></tr>~;
		}
		addFormToDisable("st$conf{$_}{id}") if not canEdit('service');		
		$html{list} .= qq~
		<DIV class=databox>
			<DIV class=boxhead>Service $_</DIV>
			<table cellspacing="1">
				<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=st$conf{$_}{id}>
				<INPUT TYPE="hidden" NAME="op" VALUE="saveService">
				<INPUT TYPE="hidden" NAME="type" VALUE="$session{form}{type}">
				<INPUT TYPE="hidden" NAME="id" VALUE="$conf{$_}{id}">
				<tr><td class="bold" width="150">Type</td><td>$conf{$_}{type}</td></tr>
				$opt
				<tr><td class="bold">Accept</td><td><input type="text" name="accept" value="$conf{$_}{accept}"></td></tr>
				<tr><td colspan="2"><input type="submit" value="Save"> <input type=button value="Delete" onclick="location.href='?op=deleteService&type=storage&id=$conf{$_}{id}'"></td></tr>
				</FORM>
			</table>
		</DIV>
		<p>
		~;
	}
	
	$result = qq~$html{list}<p>
		<select id="newType">$html{types}</select><input type="button" value="Add Storage" onclick="location.href='?op=saveService&type=storage&stype='+document.getElementById('newType').value">
	~;
	return $result;	
}

#--------------------------------------------------------------------
sub www_deleteService {
	my ($type, $id);
		$type = $session{form}{type};
		$id = $session{form}{id};
	if (canEdit('service')) {
		if ($type eq "storage") {
			$session{netams}->runCmd("no service storage $id");
		} elsif ($type eq "dsource") {
			$session{netams}->runCmd("no service data-source $id");
		} elsif ($type eq "acl") {
			$session{netams}->runCmd("no service acl-server $id");
		} elsif ($type eq "login") {
			$session{netams}->runCmd("no service login");
		} elsif ($type eq "quota") {
			$session{netams}->runCmd("no service quota");
		} elsif ($type eq "billing") {
			$session{netams}->runCmd("no service billing");
		} elsif ($type eq "html") {
			$session{netams}->runCmd("no service html");
		} elsif ($type eq "monitor") {
			$session{netams}->runCmd("no service monitor $id");
		}
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editService&type=$type");	
}
	

#--------------------------------------------------------------------
sub www_saveService {
	checkAdmin();
	my ($type, %html);
		$type = $session{form}{type};
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editService&type=$session{form}{type}") if not canEdit('service');
	# MAIN
	if ($type eq "main") {
		my $cmd;
		foreach ($session{netams}->getDebugTypes()){
			$cmd .= "$_ " if $session{form}{"dbg_$_"} == 1;
		}
		$session{netams}->runCmd("debug $cmd");
	# SERVER
	} elsif ($type eq "server") {
		$session{netams}->runCmd("service server");
		$session{netams}->runCmd("login $session{form}{login}");
		$session{netams}->runCmd("max-conn $session{form}{'max-conn'}");
		$session{netams}->runCmd("exit");
	# PROCESSOR
	} elsif ($type eq "processor") {
		my %proc = $session{netams}->getService("processor");
		$session{netams}->runCmd("service processor");
		$session{netams}->runCmd("lookup-delay $session{form}{'lookup-delay'}") if $proc{'lookup-delay'} ne $session{form}{'lookup-delay'};
		$session{netams}->runCmd("flow-lifetime $session{form}{'flow-lifetime'}") if $proc{'flow-lifetime'} ne $session{form}{'flow-lifetime'};
		if ($session{form}{'def-acct-policy'} ne "" && $session{form}{'def-acct-policy'} ne $proc{'def-acct-policy'}) {
			$session{netams}->runCmd("no default acct-policy $proc{'def-acct-policy'}");
			$session{netams}->runCmd("default acct-policy $session{form}{'def-acct-policy'}");
		} else {
			$session{netams}->runCmd("no default acct-policy $proc{'def-acct-policy'}");
		}
		if ($session{form}{'def-fw-policy'} ne "" && $session{form}{'def-fw-policy'} ne $proc{'def-fw-policy'}) {
			$session{netams}->runCmd("no default fw-policy $proc{'def-fw-policy'}");
			$session{netams}->runCmd("default fw-policy $session{form}{'def-fw-policy'}");
		} else {
			$session{netams}->runCmd("no default fw-policy $proc{'def-fw-policy'}");
		}
		$session{netams}->runCmd("restrict all $session{form}{'restrict-all'} local $session{form}{'restrict-local'}");
		foreach (keys %{$session{form}}) {
			if ($_ =~ m/storage (\d)/) {
				if ($proc{storage}{$1} ne $session{form}{$_}) {
					$session{netams}->runCmd("$_ $session{form}{$_}");
				}
			}
		}
		$session{netams}->runCmd("access-script \"$session{form}{'access-script'}\"");
		# auto assign
		foreach (split " ",$proc{"auto-assign"}) {
			$_ =~ s/-/ /g;
			$session{netams}->runCmd("no auto-assign $_");
		}
		foreach (split "\n",$session{form}{autoassign}) {
			$_ =~ s/ +//g;
			$_ =~ s/-/ /g;
			$_ =~ s/[^\d\. ]//;
			$session{netams}->runCmd("auto-assign $_");
		}
		$session{netams}->runCmd("exit");
	# STORAGE
	} elsif ($type eq "storage") {
		my (%op, $id, %st);
			%op = %{$session{form}};
			$id = $op{id};
		
		# existing storage
		if ($id =~ /^\d+$/) {
			%st = $session{netams}->getService("storage $id");
			$session{netams}->runCmd("service storage $id");
			if (defined $op{user} && $op{user} ne "" && $op{user} ne $st{user}) {
				$session{netams}->runCmd("user $op{user}");
			}
			if (defined $op{password} && $op{password} ne "" && $op{password} ne $st{password}) {
				$session{netams}->runCmd("password $op{password}");
			}
			if (defined $op{host} && $op{host} ne "" && $op{host} ne $st{host}) {
				$session{netams}->runCmd("host $op{host}");
			}
			if (defined $op{dbname} && $op{dbname} ne "" && $op{dbname} ne $st{dbname}) {
				$session{netams}->runCmd("dbname $op{dbname}");
			}
			if (defined $op{port} && $op{port} ne "" && $op{port} ne $st{port}) {
				$session{netams}->runCmd("port $op{port}");
			}
			if (defined $op{rerty} && $op{rerty} ne "" && $op{rerty} ne $st{rerty}) {
				$session{netams}->runCmd("rerty $op{rerty}");
			}				
			if (defined $op{timeout} && $op{timeout} ne "" && $op{timeout} ne $st{timeout}) {
				$session{netams}->runCmd("timeout $op{timeout}");
			}
			if (defined $op{accept} && $op{accept} ne "" && $op{accept} ne $st{accept}) {
				$session{netams}->runCmd("accept $op{accept}");
			}
			if (defined $op{nas_ip} && $op{nas_ip} ne "" && $op{nas_ip} ne $st{nas_ip}) {
				$session{netams}->runCmd("nas-ip $op{nas_ip}");
			}
			if (defined $op{socket} && $op{socket} ne "" && $op{socket} ne $st{socket}) {
				$session{netams}->runCmd("socket $op{socket}");
			}															
			$session{netams}->runCmd("exit");
		# creating new
		} else {
			%st = $session{netams}->getService("storage",1);
			for ($id=0; $id<100; $id++) {
				last if !defined $st{"storage $id"}{id};
			}
			$session{netams}->runCmd("service storage $id");
			$session{netams}->runCmd("type $op{stype}");
			$session{netams}->runCmd("exit");
		}
		
	# DATA-SOURCE
	} elsif ($type eq "dsource") {
		my (%op, $id, %ds);
			%op = %{$session{form}};
			$id = $op{id};
		# existing data-source
		if ($id =~ /^\d+$/) {
			%ds = $session{netams}->getService("data-source $id");
			$session{netams}->runCmd("service data-source $id");
			# IP-TRAFFIC
			if ($ds{type} eq "ip-traffic") {
				if ($op{source} =~ m/(tee|divert|ulog)/) {
					$session{netams}->runCmd("source $1 $op{port}");
				} else {
					$session{netams}->runCmd("source ipq");
				}
			# NETFLOW
			} elsif ($ds{type} eq "netflow") {
				$session{netams}->runCmd("listen $op{listen}");
				$session{netams}->runCmd("clock $op{clock}");
				if ($op{source} ne $ds{source}) {
					$session{netams}->runCmd("no source $_") foreach split " ",$ds{source};
					$session{netams}->runCmd("source $_") foreach split "\n",$op{source};
				}
			# libpcap
			} elsif ($ds{type} eq "libpcap") {
			
			# NETGRAPH
			} elsif ($ds{type} eq "netgraph") {
			
			}
			$session{netams}->runCmd("exit");
		# creating new
		} else {
			%ds = $session{netams}->getService("data-source",1);
			for ($id=0; $id<100; $id++) {
				last if !defined $ds{"data-source $id"}{id};
			}
			$session{netams}->runCmd("service data-source $id");
			$session{netams}->runCmd("type $op{stype}");
			$session{netams}->runCmd("exit");					
		}
	# ALERTER
	} elsif ($type eq "alerter") {
		$session{netams}->runCmd("service alerter");
		if (defined $session{form}{'smtp-server'}) {
			$session{netams}->runCmd("smtp-server $session{form}{'smtp-server'}");
		} else {
			$session{netams}->runCmd("no smtp-server");
		}
		$session{netams}->runCmd("exit");
	# HTML
	} elsif ($type eq "html") {
		$session{netams}->runCmd("service html");
		if (defined $session{form}{run}) {
			$session{netams}->runCmd("run $session{form}{run}");
		}
		#if (defined $session{form}{path}) {
			$session{netams}->runCmd("path $session{form}{path}");
		#}
		#if (defined $session{form}{url}) {
			$session{netams}->runCmd("url $session{form}{url}");
		#} 
		#if (defined $session{form}{'servlet-url'}) {
			$session{netams}->runCmd("servlet-url $session{form}{'servlet-url'}");
		#}
		if (defined $session{form}{htaccess}) {
			$session{netams}->runCmd("htaccess $session{form}{htaccess}");
		}
		if (defined $session{form}{'client-pages'}) {
			$session{netams}->runCmd("client-pages $session{form}{'client-pages'}");
		}
		if (defined $session{form}{'account-pages'}) {
			$session{netams}->runCmd("account-pages $session{form}{'account-pages'}");
		}
		$session{netams}->runCmd("exit");
	# MONITOR
	} elsif ($type eq "monitor") {
		my (%op, $id, %mon);
			%op = %{$session{form}};
			$id = $op{id};
			
		# EXISTING
		if ($id =~ m/^\d+$/) {
			%mon = $session{netams}->getService("monitor $id");
			$session{netams}->runCmd("service monitor $id");
			if ($op{to} eq "storage") {
				$session{netams}->runCmd("monitor to storage $session{form}{storage}");
			} else {
				$session{netams}->runCmd("monitor to file $session{form}{file}");
			}
			$session{netams}->runCmd("exit");
		# CREATE NEW				
		} else {
			%mon = $session{netams}->getService('monitor',1);
			for ($id=0; $id<100; $id++) {
				last if !defined $mon{"monitor $id"}{id};
			}
			$session{netams}->runCmd("service monitor $id");			
			$session{netams}->runCmd("exit");
		}
	# QUOTA
	} elsif ($type eq "quota") {
		my %op = %{$session{form}};
		$session{netams}->runCmd("service quota");
		$session{netams}->runCmd("policy $op{policy}");
		$session{netams}->runCmd("soft-treshold ".int($op{'soft-treshold'}));
		#$session{netams}->runCmd("delay ".int($op{'delay'}));
		$session{netams}->runCmd("exit");
	# LOGIN
	} elsif ($type eq "login") {
		my (%op, $id, %st);
			%op = %{$session{form}};
			#%st = $session{netams}->getService("login");
		$session{netams}->runCmd("service login");
		if ($op{'default-inact'} ne "") {
			$session{netams}->runCmd("default-inact $op{'default-inact'}");
		}
		if ($op{'max-inact'} ne "") {
			$session{netams}->runCmd("max-inact $op{'max-inact'}");
		}
		if ($op{'min-inact'} ne "") {
			$session{netams}->runCmd("min-inact $op{'min-inact'}");
		}
		if ($op{'default-abs'} ne "") {
			$session{netams}->runCmd("default-abs $op{'default-abs'}");
		}				
		if ($op{'min-abs'} ne "") {
			$session{netams}->runCmd("min-abs $op{'min-abs'}");
		}
		if ($op{'min_passwd_length'} ne "") {
			$session{netams}->runCmd("min_passwd_length $op{'min_passwd_length'}");
		}
		if ($op{'delay'} ne "") {
			$session{netams}->runCmd("delay $op{'delay'}");
		}	
		if ($op{'set-user-ip'} ne "") {
			$session{netams}->runCmd("set-user-ip $op{'set-user-ip'}");
		}	
		if ($op{'relogin'} ne "") {
			$session{netams}->runCmd("relogin $op{'relogin'}");
		}									
		$session{netams}->runCmd("exit");
	# BILLING
	} elsif ($type eq "billing") {
		my (%op, %st, $id);
			%op = %{$session{form}};
			$id = $op{id};
		$session{netams}->runCmd("service billing");
		$session{netams}->runCmd("delay ".int($op{delay}));
		$session{netams}->runCmd("default-credit-limit ".int($op{'default-credit-limit'}));
		$session{netams}->runCmd("exit");
	# ACL
	} elsif ($type eq "acl") {
		my (%op, %st, $id);
			%op = %{$session{form}};
			$id = $op{id};
		
		if ($op{id} =~ m/^\d+$/) {
			$session{netams}->runCmd("service acl-server");
			$session{netams}->runCmd("hostname $op{hostname}");
			$session{netams}->runCmd("direction $op{direction}");
			$session{netams}->runCmd("dynamic-name $op{'dynamic-name'}");
			$session{netams}->runCmd("acl-number $op{'acl-number'}");
			$session{netams}->runCmd("delay $op{delay}");
			$session{netams}->runCmd("set-uptime $op{'set-uptime'}");
			$session{netams}->runCmd("exit");
		} else {
			%st = $session{netams}->getService("acl-server",1);
			foreach (keys %st) {
				$id = $st{$_}{id} if $st{$_}{id} > $id;
			}
			$id++;
			$session{netams}->runCmd("service acl-server $id");
			$session{netams}->runCmd("exit");
		}
		
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editService&type=$session{form}{type}");	
}


1;