package Nawt::Operation::Stats;
# $Id: Stats.pm,v 1.7 2005/04/15 22:39:13 ramirez Exp $

use DBI;
use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Navigation;
use Nawt::SQL;
use Nawt::DateTime;
use Nawt::Theme;
use Time::Local;
use Tie::IxHash;

our @ISA = qw( Exporter ); 
our @EXPORT = qw(&www_showStat &www_showStatSum &www_showStatMonitor);

# Summary Stats
#--------------------------------------------------------------------
sub www_showStatSum {
	my ($result,%html);
	
	
	return $result;
}

# $str = bytesToHuman( indeger )
#--------------------------------------------------------------------
sub bytesToHuman {
	my ($int, $result, $prefix, $kb);
		$int = $_[0];
		$kb = $session{config}{kilobyte};
	# determing prefix
	if ($int !~ m/^\d+$/) {
		return "--";
	} elsif ($int >= 1000000000000) {
		return sprintf("%3.3f",$int/($kb*$kb*$kb*$kb))." T";
	} elsif ($int >= 1000000000) {
		return sprintf("%3.3f",$int/($kb*$kb*$kb))." G";
	} elsif ($int >= 1000000) {
		return sprintf("%3.3f",$int/($kb*$kb))." M";
	} elsif ($int >= 1000) {
		return sprintf("%3.3f",$int/$kb)." K";
	} else {
		return $int." B";
	}

}

#--------------------------------------------------------------------
sub www_showStat {
	#checkAdmin();
	my ($result, $content, $menu, @oids, $oid, @now,%html);
		$oid = $session{form}{oid};
		# check for right date
		@now = localtime();
		$session{form}{date} = "$now[0]-$now[1]" if $session{form}{date} !~ m/^\d{4}(-\d{1,2})?(-\d{1,2})?$/;

	if ($session{var}{userType} eq "unit") {
		$oid = $session{var}{userId};
		$session{form}{oid} = $oid;
	} elsif ($session{var}{userType} eq "account") {
		my %data = $session{netams}->getAccount($session{var}{userId});
		$oid = $data{units};
		$session{form}{oid} = $oid;
	}
	
	$content = makeStat($oid,$session{form}{date});

	# getting avalible years
	my $dbh = getDBH('summary');
	my @aYears = Nawt::SQL->quickArray("SELECT MIN(t_from), MAX(t_from) FROM summary",$dbh);
	my $minY = epochToHuman(@aYears[0],"%y");
	my $maxY = epochToHuman(@aYears[1],"%y");
	for my $i ($minY..$maxY) {
		$html{aYears}.=qq~<a href="?op=showStat&date=$i&oid=$oid" class=btn1>$i</a>~;
	}
	
	if ($session{user}{isAdmin}) {
		if ($session{form}{oid} =~ m/^\w{6}$/) {
			$menu = qq~<div align=right>$html{aYears}<a class=btn1 href="?op=editUnit&oid=$oid">Edit This Unit</a></div>~;
		} else {
			$menu = qq~<div align=right>$html{aYears}<a class=btn1 href="?op=showUnitList">List All Units</a></div>~;
		}
	} else {
		$menu = qq~<div align=right>$html{aYears}</div>~;
	}
	
	return $menu.$content.$menu;
}


# $html = makeStat ( oid , [yyyy-mm-dd] )
#-------------------------------------------------------------------
sub makeStat {
	my ($result, %html, $oid, @unitPols, %pols, @date, %unit, $dbh);
		$oid = $_[0];
		%pols = $session{netams}->getPolicy();
		%unit = $session{netams}->getUnit($oid);
		@date = split(/-/,$_[1]);
		$session{page}{title} = "Statistics for ";
		
		# Get oid list
		my %ourPols;
		tie %ourPols, "Tie::IxHash";
		my @oidList;
		@oidList = split(",",$oid);
	
		# Building complex policy list
		if ($session{form}{pol} !~ m/^(\w{6},?)+$/) {		
			foreach (@oidList) {
				my $acc = $session{netams}->unitInBilling($_);
				if ($acc) {
					my %conf = $session{netams}->getService('billing');
					my %account = $session{netams}->getAccount($acc);
					foreach (Nawt::Operation::Plan::getPlanPolicyList($account{plan})) {
						$ourPols{$_} = 1;
					}
				} else {
					$ourPols{$_} = 1 foreach $session{netams}->getUnitPolicies($_,"acct","all");
				}
				$session{page}{title} .= $session{netams}->{config}{units}{$_}{type}." ".$session{netams}->{config}{units}{$_}{name}.", ";
			}
		} else {
			$ourPols{$_} = 1 foreach split(",",$session{form}{pol});
		}

	# Building table head
	$html{thead} .= "<th rowspan=2>Unit</th>" if $#oidList > 0;
	foreach (keys %ourPols) {
		$_ =~ m/([!%]{0,2})(\w{6})/;
		$html{thead} .= "<th colspan=2 align=center>$1$pols{$2}{name}</th>";
		$html{thead2} .= "<th>in</th><th>out</th>";
	}
	
	$dbh = getDBH('summary');
	#$sth = Nawt::SQL->new("SELECT * FROM summary",$dbh);
	# generating stats page
	if (defined $date[2]) {
	# HOURS
		my $month = ucfirst(Nawt::DateTime::getMonthName($date[1]));
		for my $i(0..23) {
			my $pols;
			my $time = timelocal(0,0,$i,$date[2],$date[1]-1,$date[0]);
			foreach (@oidList) {
				my $oid = $_;
				my $oidCount = $#oidList + 1;
				if ($i % 2) { $html{rowclass} = "row0"; } else { $html{rowclass} = "row1"; }
				$i = sprintf("%02d",$i);				
				if ($pols eq "") {
					$pols .= qq~<tr class="$html{rowclass}" onmouseover="this.className='row3'" onmouseout="this.className='$html{rowclass}'"><td rowspan=$oidCount><a href="?op=showStat&oid=$session{form}{oid}&date=$date[0]">$date[0]</a>-<a href="?op=showStat&oid=$session{form}{oid}&date=$date[0]-$date[1]">$month</a>-$date[2] $i:00</td>~;
				} else { 
					$pols .= qq~<tr class="$html{rowclass}" onmouseover="this.className='row3'" onmouseout="this.className='$html{rowclass}'">~; 
				}
				$pols .= qq~<td class=bold>$session{netams}->{config}{units}{$oid}{name}</td>~ if $#oidList > 0;			
				foreach (keys %ourPols) {
					$_ =~ m/([!%]{0,2})(\w{6})/;
					my ($in, $out) = getUnitTraf($dbh,$oid,$time,$2,"H");
					$in = bytesToHuman($in);
					$out = bytesToHuman($out);
					$pols .= qq~<td align="right">$in</td><td align="right">$out</td>~;
				}
			}
			$html{body} .= $pols;
		}
	} elsif (defined $date[1]) {
	# DAYS 
		my $month = ucfirst(Nawt::DateTime::getMonthName($date[1]));
		my $dayCount = Nawt::DateTime::monthDayCount(setToEpoch("$date[1]/01/$date[0]"));
		for my $i(1..$dayCount) {
			my $pols;
			my $time = timelocal(0,0,0,$i,$date[1]-1,$date[0]);
			if ($i % 2) { $html{rowclass} = "row0"; } else { $html{rowclass} = "row1"; }			
			$i = sprintf("%02d",$i);			
			foreach (@oidList) {
				my $oid = $_;
				my $oidCount = $#oidList + 1;
				if ($pols eq "") {
					$pols .= qq~<tr class="$html{rowclass}" onmouseover="this.className='row3'" onmouseout="this.className='$html{rowclass}'"><td rowspan=$oidCount><a href="?op=showStat&oid=$session{form}{oid}&date=$date[0]">$date[0]</a>-$month-<a href="?op=showStat&oid=$session{form}{oid}&date=$date[0]-$date[1]-$i">$i</a></td>~;
				} else { 
					$pols .= qq~<tr class="$html{rowclass}" onmouseover="this.className='row3'" onmouseout="this.className='$html{rowclass}'">~; 
				}
				$pols .= qq~<td class=bold>$session{netams}->{config}{units}{$oid}{name}</td>~ if $#oidList > 0;
				foreach (keys %ourPols) {
					$_ =~ m/([!%]{0,2})(\w{6})/;
					my ($in, $out) = getUnitTraf($dbh,$oid,$time,$2,"D");
					$in = bytesToHuman($in);
					$out = bytesToHuman($out);
					$pols .= qq~<td align="right">$in</td><td align="right">$out</td>~;
				}
				$pols .= "</tr>";
			}
			$html{body} .= $pols;
		}

	} elsif (defined $date[0]) {
	# MONTHS
		for my $i(1..12) {
			my $month = ucfirst(Nawt::DateTime::getMonthName($i));
			my ($pols, @monthTraf, $time);
				#$time = humanToEpoch("$date[0]-4-1");
				$time = timelocal(0,0,0,1,$i-1,$date[0]);
				if ($i % 2) { $html{rowclass} = "row0"; } else { $html{rowclass} = "row1"; }
			foreach (@oidList) {
				my $oid = $_;
				my $oidCount = $#oidList + 1;
				if ($pols eq "") {
					$pols .= qq~<tr class="$html{rowclass}" onmouseover="this.className='row3'" onmouseout="this.className='$html{rowclass}'"><td rowspan=$oidCount>$date[0]-<a href="?op=showStat&oid=$session{form}{oid}&date=$date[0]-$i">$month</a></td>~;
				} else { 
					$pols .= qq~<tr class="$html{rowclass}" onmouseover="this.className='row3'" onmouseout="this.className='$html{rowclass}'">~; 
				}
				$pols .= qq~<td class=bold>$session{netams}->{config}{units}{$oid}{name}</td>~ if $#oidList > 0;				
				foreach (keys %ourPols) {
					$_ =~ m/([!%]{0,2})(\w{6})/;
					@monthTraf = getUnitTraf($dbh,$oid,$time,$2,"M");
					$monthTraf[0] = bytesToHuman($monthTraf[0]);
					$monthTraf[1] = bytesToHuman($monthTraf[1]);
					$pols .= qq~<td align="right">$monthTraf[0]</td><td align="right">$monthTraf[1]</td>~;
				}
			}
			$html{body} .= $pols;
		}
	}

	$result = qq~
	<table class=adminlist border=1>
	<tr><th rowspan=2>Period/Policy</th>$html{thead}</tr>$html{thead2}
	$html{body}
	</table>
	~;
	
	return $result;
}


# $summ = getMonthTraf ( $dbh, unit_oid , time , policy_oid , prefix) 
#-------------------------------------------------------------------
sub getUnitTraf {
	my ($dbh, @sql, @sql1, $pol, $oid, $tfrom, $prefix);
		$dbh = $_[0];
		$oid = hex($_[1]);
		$tfrom = $_[2];
		$pol = hex($_[3]);
		$prefix = $_[4];
		@sql = Nawt::SQL->quickArray("SELECT bytes_in, bytes_out FROM summary WHERE prefix like '$prefix' AND unit_oid='$oid' AND policy_oid='$pol' AND t_from='$tfrom' LIMIT 1",$dbh);
	return ($sql[0], $sql[1], $sql1[0], $sql1[1],);
}

# getDBH ( [data_type] )
#-------------------------------------------------------------------
sub getDBH {
	my ($dbh, %conf, $type, $dsn, $user, $pass);
	$type = $_[0];
	%conf = $session{netams}->getService("storage",1);
	
	foreach (keys %conf) {
		if ($conf{$_}{type} =~ m/(mysql|postgres|oracle)/) {
			my $dbtype = $1;
			$dbtype = "Oracle" if $dbtype eq "oracle";
			if ($conf{$_}{accept} =~ /all|$type/) {
				my $dbname = "netams";
				$dbname = $conf{dbname} if $conf{dbname} ne "";
				$dsn = "DBI:$dbtype:$dbname";
				$dsn .= "@".$conf{$_}{host} if $conf{$_}{host} ne "";
				$user = $conf{$_}{user};
				$pass = $conf{$_}{password};
				last;
			}
		}
	}

	$dbh = DBI->connect($dsn,$user,$pass,{ RaiseError=>0,AutoCommit=>1 });
	return $dbh;
}

#-------------------------------------------------------------------
sub www_showStatMonitor {
	my ($result, $oid, $mid, $dbh, %srv, %unit, $sth, $output, %html, @data, $sql, $limit, @proto);
	$oid = $session{form}{oid};
	$mid = $session{form}{mid};
	$session{page}{title} = "Monitoring results";
	%srv = $session{netams}->getService("monitor $mid");
	%unit = $session{netams}->getUnit($oid);
	$dbh = getDBH2($srv{targ});

	open (my $file, "<", "/etc/protocols");
	while (<$file>) {
		if ($_ =~ m/^([\w-]+)\s(\d+)/) {
			$html{proto} .= "<option value=$2>$1</option>";
			@proto[$2] = $1;
		}
	}
	
	my $menu;
	if (isValidAdmin) {
		$menu = qq~<div align=right><a class=btn1 href="?op=editUnit&oid=$oid">Edit This Unit</a></div>~;
	}
	
	# FILTER
	if ($session{form}{date1} =~ m/^\d{4}-\d{2}-\d{2} \d{2}:\d{2}$/ and $session{form}{date2} =~ m/^\d{4}-\d{2}-\d{2} \d{2}:\d{2}$/) {
		$sql = "time > ".humanToEpoch($session{form}{date1})." AND time < ".humanToEpoch($session{form}{date2})." AND ";
	}
	if ($session{form}{src} =~ m/^[\d\.\/]+$/) {
		$sql .= "src=inet_aton(".quote($session{form}{src}).") AND ";
	}
	if ($session{form}{dst} =~ m/^[\d\.\/]+$/) {
		$sql .= "dst=inet_aton(".quote($session{form}{dst}).") AND ";
	}
	if ($session{form}{srcport} =~ m/^\d+$/) {
		$sql .= "srcport=".quote($session{form}{srcport})." AND ";
	}
	if ($session{form}{dstport} =~ m/^\d+$/) {
		$sql .= "dstport=".quote($session{form}{dstport})." AND ";
	}
	if ($session{form}{proto} =~ m/^\d+$/) {
		$sql .= "proto=".quote($session{form}{proto})." AND ";
	}		
	$limit = "LIMIT 100" if $sql eq "";
	
	# MAKING QUERY
    $sth = Nawt::SQL->new("SELECT time, proto, inet_ntoa(src), srcport, inet_ntoa(dst), dstport, len FROM monitor WHERE $sql unit_oid=".hex($oid)." ORDER BY time DESC, src, srcport, dst, dstport $limit",$dbh);
	foreach ($sth->getColumnNames) {
		$html{heads} .= "<td>$_</td>";
	}
	my $row;
	while (@data = $sth->array) {	
		if ($row % 2) { $html{rowclass} = "row0"; } else { $html{rowclass} = "row1"; }
		$html{data} .= "<tr class=$html{rowclass}>
			<td>".epochToHuman($data[0],"%y-%m-%d %j:%n")."</td>
			<td>$proto[$data[1]]</td>
			<td>$data[2]</td>
			<td>$data[3]</td>
			<td>$data[4]</td>
			<td>$data[5]</td>
			<td>$data[6]</td>
		</tr>";
		$html{lensum} += $data[6];
		$row++;
	}

	$result = qq~
	$menu
  <!-- calendar -->
  <link rel="stylesheet" type="text/css" media="all" href="$session{config}{extrasURL}/js/calendar/calendar-win2k-cold-1.css">
  <script type="text/javascript" src="$session{config}{extrasURL}/js/calendar/calendar.js"></script>
  <script type="text/javascript" src="$session{config}{extrasURL}/js/calendar/lang/calendar-en.js"></script>
  <script type="text/javascript" src="$session{config}{extrasURL}/js/calendar/calendar-setup.js"></script>
  <!-- end calendar -->	
	<DIV class=databox>
	<DIV class=boxhead>Search for</DIV>
	<table class>
		<FORM METHOD="GET" ACTION="$session{env}{scripturl}">
		<INPUT TYPE="hidden" NAME="op" VALUE="showStatMonitor">
		<INPUT TYPE="hidden" NAME="oid" VALUE="$oid">		
		<INPUT TYPE="hidden" NAME="mid" VALUE="$mid">
		<tr>
			<td><b>Start date:</b> <input type="text" value="$session{form}{date1}" name="date1" id="sel1" size="16"><input type="button" value=":::" id="btn1"></td>
			<td><b>End date:</b> <input type="text" value="$session{form}{date2}" name="date2" id="sel2" size="16"><input type="button" value=":::" id="btn2"></td>
		</tr>
		<tr>
			<td><b>Src IP:</b> <input type=text name=src value="$session{form}{src}"></td>
			<td><b>Dst IP:</b> <input type=text name=dst value="$session{form}{dst}"></td>
		</tr>
		<tr>
			<td><b>Src Port:</b> <input type=text name=srcport value="$session{form}{srcport}"></td>
			<td><b>Dst Port:</b> <input type=text name=dstport value="$session{form}{dstport}"></td>
		</tr>		
		<tr><td><b>Proto:</b> <select name=proto><option></option>$html{proto}</select></td><td><input type=submit value="Start"></td></tr>
		</FORM>
	</table>
	</DIV>
	<p>
	<table class=adminlist>
	<tr class=boxhead>$html{heads}</tr>$html{data}
	<tr><td colspan=6 align=right class=bold>Total:</td><td>$html{lensum}</td></tr>
	</table>

<script type="text/javascript">
    Calendar.setup({
        inputField     :    "sel1",
        ifFormat       :    "%Y-%m-%d %H:%M",
        showsTime      :    true,
        timeFormat     :    "24",
        button         :    "btn1",
        singleClick    :    false
    });
    Calendar.setup({
        inputField     :    "sel2",
        ifFormat       :    "%Y-%m-%d %H:%M",
        showsTime      :    true,
        timeFormat     :    "24",
        button         :    "btn2",
        singleClick    :    false
    });    
</script>
$menu
	~;
	
	return $result;
}


# getDBH2 ( storage-id )
#-------------------------------------------------------------------
sub getDBH2 {
	my ($dbh, %conf, $id, $type, $dsn, $user, $pass);
	$id = shift;
	%conf = $session{netams}->getService("storage $id");
	
	if ($conf{type} =~ m/(mysql|postgres|oracle)/) {
		my $dbtype = $1;
		$dbtype = "Oracle" if $dbtype eq "oracle";
		if ($conf{accept} =~ /all|$type/) {
			my $dbname = "netams";
			$dbname = $conf{dbname} if $conf{dbname} ne "";
			$dsn = "DBI:$dbtype:$dbname";
			$dsn .= "@".$conf{host} if $conf{host} ne "";
			$user = $conf{user};
			$pass = $conf{password};
		}
	}
	
	$dbh = DBI->connect($dsn,$user,$pass,{ RaiseError=>0,AutoCommit=>1 });
	
	return $dbh;
}

1;