package Nawt::Operation::Unit;
# $Id: Unit.pm,v 1.31 2005/04/20 13:01:12 ramirez Exp $

use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Navigation;
use Nawt::Login;
use Nawt::Unit;
use Nawt::Theme;
use Nawt::SQL;
use Nawt::DateTime;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( 
	&www_editUnit 
	&www_editUnitPolicy
	&www_deleteUnitPolicy
	&www_addUnitPolicy
	&www_invertUnitPolicy
	&www_breakUnitPolicy
	&www_showUnitQuota
	&www_editUnitQuota
	&www_editUnitLogin
	&www_editUnitMonitor
	&www_editUnitBW
	&www_saveUnit
	&www_saveUnitQuota
	&www_deleteUnitQuota 
	&www_deleteUnit 
	&www_saveUnitBW
	&www_saveUnitPolicy
	&www_saveUnitSysPolicy 
	&www_editUnitListBatch 
	&www_execUnitListBatch
	&www_saveUnitMonitor
	);

#-------------------------------------------------------------------
sub www_editUnit {
	checkAdmin();
	my ($result, %units, %html, $row, $oid, %ds, $hasUnit);
		$oid = $session{form}{oid};
		$hasUnit = $session{netams}->hasUnit($oid);
		%units = $session{netams}->getUnit();
		$session{page}{title} = "Configuring unit $units{$oid}{name}";
		addFormToDisable('unit') if (not canEdit('unit'));
		
		fillUnitMenu($oid);
		
		$html{notes} = "<p>".Nawt::Operation::Note::getNoteList("unit",$oid) if $hasUnit;
		
		%ds = $session{netams}->getService("data-source",1);
		
		if ($session{netams}->hasUnit($oid)) {
			$html{oid} = qq~<input type="hidden" name="oid" value="$oid">~;
			$html{name} = qq~<input type="text" name="name" value="$units{$oid}{name}">~;
			$html{type} = qq~<b>$units{$oid}{type}</b><input type="hidden" name="type" value="$units{$oid}{type}">~;
			$html{email} = qq~<input type="text" name="email" value="$units{$oid}{email}">~;
			my $acc = $session{netams}->unitInBilling($oid);
			$html{hasBill} = qq~<b>This unit attached to <a href="?op=editAccount&oid=$acc">account</a> in billing</b>~ if $acc;
		} else {
			$html{oid} = qq~<input type="hidden" name="oid" value="">~;
			$html{name} = qq~<input type="text" name="name" value="">~;
			foreach ($session{netams}->getUnitTypes()) {
				$html{tmp} .= qq~<option value="$_">$_</option>~;
			}
			$html{type} = qq~<SELECT NAME="type" onchange="showUnitParams(this)">$html{tmp}</SELECT>~;
			$html{email} = qq~<input type="text" name="email" value="">~;
		}

		# Building group list
		foreach (keys %units) {
			if ( not ($units{$oid}{type} eq "group" && $oid eq $_)) {
				if ($units{$_}{type} eq "group" && $units{$oid}{parent} eq $_) {
					$html{grplist} .= qq~ <option value="$units{$_}{name}" selected>$units{$_}{name}</option> ~;
				} elsif ($units{$_}{type} eq "group" && $units{$oid}{parent} ne $_) {
					$html{grplist} .= qq~ <option value="$units{$_}{name}">$units{$_}{name}</option> ~;
				}
			}
		}
		
		# Building Data-source list
		if (%ds > 1) {
			foreach (keys %ds) {
				$_ =~ m/data-source (\d+)/; 
				my $num = $1;
				if ($units{$oid}{'ds-list'} =~ m/$num/) {
					$html{dslist} .= qq~<input type="checkbox" name="dslist_$num" value="1" checked> <b>$_ ($ds{$_}{type})</b><br>~;
				} else {
					$html{dslist} .= qq~<input type="checkbox" name="dslist_$num" value="1"> <b>$_ ($ds{$_}{type})</b><br>~;
				}
			}
		} else {
			$html{dslist} = "You have only one data-source service";
		}

		if (defined $units{$oid}{nolp}) {
			$html{nolp} = qq~<INPUT TYPE="checkbox" NAME="nolp" VALUE="1" checked>~;
		} else {
			$html{nolp} = qq~<INPUT TYPE="checkbox" NAME="nolp" VALUE="1">~;
		}
		# Type-specific parameters
		if ($units{$oid}{type} =~ m/(host|user)/) {
			$html{params} = qq~
				<tr><td class="bold">IP</td><td><input type="text" name="ip" value="$units{$oid}{ip}"></td></tr>
				<tr><td class="bold">MAC</td><td><input type="text" name="mac" value="$units{$oid}{mac}" onblur="isMac(this)"></td></tr> ~;
		# NET
		} elsif ($units{$oid}{type} =~ m/net/) {
			my %proc = $session{netams}->getService("processor");
			foreach (keys %{$proc{'auto-units'}}) {
				my $tmp;
				$tmp = "selected" if $units{$oid}{'auto-units'} =~ m/$_/;
				$html{autounits} .= qq~<option value="$_" $tmp>$_ $proc{'auto-units'}{$_}{type} ($proc{'auto-units'}{$_}{naming})</option>~;
			}
			$html{params} = qq~
				<tr><td class="bold">IP</td><td><input type="text" name="ip" value="$units{$oid}{ip}"></td></tr>
				<tr><td class="bold">Netmask</td><td><input type="text" name="mask" value="$units{$oid}{mask}"></td></tr>
				<tr><td class="bold">Auto-units</td><td><select name="auto-units"><option value="">- -</option>$html{autounits}</td></tr>~;
		# CLUSTER
		} elsif ($units{$oid}{type} =~ m/cluster/) {
			$units{$oid}{ip} =~ s/ /\n/g;
			$html{params} = qq~<tr><td class="bold">IP list<div class="small-normal">One per line</div></td>
				<td><textarea name="ip" rows="10">$units{$oid}{ip}</textarea></td></tr>~;
		}
		# USER
		if ($units{$oid}{type} =~ m/user/) {
			$html{params} .= qq~
				<tr><td class="bold">Password</td><td>
				<input type="text" name="password" value="$units{$oid}{password}"></td></tr> ~;
		}
	
	
	# Building result HTML
	$result = qq~
	<DIV class=databox>
			<table>
				<form method="POST" action="$session{config}{scripturl}" id=unit>
				<input type="hidden" name="op" value="saveUnit">
				$html{oid}
				<tr class="row-category"><td colspan="2">$html{caption}</td></tr>				
				<tr><td class="bold" width="150">OID</td><td>$oid</td></tr>
				<tr><td class="bold">Name</td><td>$html{name}</td></tr>
				<tr><td class="bold">Type</td><td>$html{type}</td></tr>
				<tr><td class="bold">Parent</td><td><select name="parent"><option value="">- -</option>$html{grplist}</select></td></tr>
				<tr><td class="bold">E-Mail</td><td>$html{email}</td></tr>
				<tr><td class="bold">No local pass</td><td>$html{nolp}</td></tr>
				<tr><td class="bold">Data-Sources</td><td>$html{dslist}</td></tr>
				<tr><td class="bold">Description</td><td><input type="text" name="description" value="$units{$oid}{description}"></td></tr>
				$html{params}
				<tr><td colspan=2><input type="submit" value="Save"></td></tr>
				</form>
			</table>
		$html{hasBill}
	</DIV>
	$html{notes}
	~;
	return $result;
}



#-------------------------------------------------------------------
sub www_saveUnit {
	checkAdmin();
	my ($oid, $hasUnit, $url, %op, $dslist, $tmp, %unit);
		$oid = $session{form}{oid};
		#%unit = $session{netams}->getUnit($oid);

	$session{form}{name} =~ s/ +/_/g;
	$session{form}{description} =~ s/["']//g; #'"
	$session{form}{ip} =~ s/\n{2,}/\n/g;
	$session{form}{ip} =~ s/,/\./g;

	foreach (keys %{$session{form}}) {
		$session{form}{$_} =~ s/ {2,}/ /g;
		if ($_ =~ m/dslist_(\d+)/) {
			$dslist .= ",$1";
		}
	}
	$dslist =~ s/^,//g;

	$oid = $session{netams}->setUnit(oid=>$oid,
		type=>$session{form}{type},
		name=>$session{form}{name},
		parent=>$session{form}{parent},
		email=>$session{form}{email},
		description=>$session{form}{description},
		nolp=>$session{form}{nolp},
		"ds-list"=>$dslist,
		ip=>$session{form}{ip},
		mac=>$session{form}{mac},
		password=>$session{form}{password}
		);

	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editUnit&oid=$oid");
}

#-------------------------------------------------------------------
sub www_deleteUnit {
	checkAdmin();
	my (%unit, $oid, $cmd, $url);
		$oid = $session{form}{oid};
		%unit = $session{netams}->getUnit();	

	foreach (keys %{$session{form}}) {
		$session{form}{$_} =~ s/^ +$//g;
	}

	if (canEdit('unit') and $session{form}{confirmed}) {
		$session{netams}->runCmd("service processor");
		$session{netams}->runCmd("no unit $unit{$_}{type} oid $_") foreach split ",",$oid;
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
		return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showUnitList");
	} else {
		my $list;
		foreach (split ",",$oid) {
			$list .= qq~<tr><td><img src="$session{config}{extrasURL}/images/icons/$unit{$_}{type}.gif"></td><td>$unit{$_}{name} ($unit{$_}{type})</td></tr>~;
		}
		$session{page}{title} = "Delete Unit(s)?";
		return qq~<table>$list</table> <p>Be careful, all counted data will be lost! 
			<p><a class=btn1 href="$session{env}{scripturl}?op=deleteUnit&oid=$oid&confirmed=1">Yes!</a> 
			<a class=btn1 href="$session{env}{scripturl}?op=showUnitList">No</a></p>~;
	}	
	
}

#-------------------------------------------------------------------
sub www_editUnitBW {
	checkAdmin();
	my ($result, %unit, %html, $row, $oid);
		$oid = $session{form}{oid};
		%unit = $session{netams}->getUnit($oid);		
		$html{bwin} = qq~<input type="text" name="bw-in" value="$unit{'bw-in'}">~;
		$html{bwout} = qq~<input type="text" name="bw-out" value="$unit{'bw-out'}">~;
		$session{page}{title} = "Bandwidth Limits";
		addFormToDisable('bw') unless canEdit('unit');
	fillUnitMenu($oid);
	$result = qq~
	<DIV class=databox>
		<table>
			<FORM METHOD="GET" ACTION="$session{env}{scripturl}" ID=bw>
			<INPUT TYPE="hidden" NAME="op" VALUE="saveUnitBW">
			<INPUT TYPE="hidden" NAME="oid" VALUE="$oid">
			<tr><td class="bold">IN speed</td><td>$html{bwin}</td></tr>
			<tr><td class="bold">OUT speed</td><td>$html{bwout}</td></tr>
			<tr><td colspan="2"><input type="submit" value="Save"></td></tr>
			</FORM>
		</table>
	</DIV>	
		~;
	return $result;
}

#-------------------------------------------------------------------
sub www_saveUnitBW {
	checkAdmin();
	my ($oid, %units, $cmd);
		$oid = $session{form}{oid};
		%units = $session{netams}->getUnit($oid);
	
	return Nawt::Theme::getRedirect("?op=showUnitBW&oid=$oid") if not canEdit('unit');	
	
	foreach (keys %{$session{form}}) {
		$session{form}{$_} =~ s/ +//g;
	}
	if ($session{form}{'bw-in'} =~ m/^(\d+)(\.\d{3})?\w/) {
		$cmd .= "unit $units{type} name $units{name} bw $session{form}{'bw-in'} in";
	} else {
		$cmd .= "unit $units{type} name $units{name} bw 0 in";
	}
	if ($session{form}{'bw-out'} =~ m/^(\d+)(\.\d{3})?\w/) {
		$cmd .= " $session{form}{'bw-out'} out";
	} else {
		$cmd .= " 0 out";		
	}

	if ($cmd !~ m/^$/) {
		$session{netams}->runCmd("service processor");
		$session{netams}->runCmd($cmd);
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editUnitBW&oid=$oid");
}

#-------------------------------------------------------------------
sub www_editUnitPolicy {
	my ($result, %units, %html, $oid, %pols, %proc);
	$oid = $session{form}{oid};
	$session{page}{title} = "Unit Policies";
	
	fillUnitMenu($oid);
	addFormToDisable('policy') if not canEdit('unit');	
		
	%units = $session{netams}->getUnit($oid);
	%pols = $session{netams}->getPolicy();
	%proc = $session{netams}->getService('processor');

	# DEFAULT ACCT POLS
	foreach (split " ",$proc{'def-acct-policy'}) {
		my ($flag1, $flag2);
		if ($_ =~ m/^([!%]{0,2})(\w{6})/) {
			if ($1 =~ m/!/) { $flag1 = "invert1.gif" } else { $flag1 = "invert0.gif" }
			if ($1 =~ m/%/) { $flag2 = "break1.gif" } else { $flag2 = "break0.gif" }
			$html{unitAcct} .= qq~<tr><td></td>
				<td width=16><img src="$session{config}{extrasURL}/images/$flag1"></td>
				<td width=16><img src="$session{config}{extrasURL}/images/$flag2"></td>
				<td>$1$pols{$2}{name}</td><td>[default]</td></tr>~;
		}		
	}
	# CUSTOM ACCT POLS
	unless ($session{netams}->unitInBilling($oid)) {
		foreach (split(" ",$units{'acct-policy'})) {
			if ($_ =~ m/^([!%]{0,2})(\w{6})/) {
				my ($flag1,$flag2,$pid,$flg);
				$flg = $1;
				$pid = $2;
				if ($flg =~ m/!/) { $flag1 = "invert1.gif" } else { $flag1 = "invert0.gif" }
				if ($flg =~ m/%/) { $flag2 = "break1.gif" } else { $flag2 = "break0.gif" }
				$html{unitAcct} .= qq~<tr><td></td>
					<td width=16><a href="?op=invertUnitPolicy&oid=$oid&pid=$pid&mode=acct"><img src="$session{config}{extrasURL}/images/$flag1"></a></td>
					<td width=16><a href="?op=breakUnitPolicy&oid=$oid&pid=$pid&mode=acct"><img src="$session{config}{extrasURL}/images/$flag2"></a></td>
					<td>$pols{$pid}{name}</td>
					<td><img src="$session{config}{extrasURL}/images/bullet_arrow_up.gif">
						<img src="$session{config}{extrasURL}/images/bullet_arrow_down.gif">
						<a href="?op=deleteUnitPolicy&oid=$oid&pid=$pid&mode=acct"><img src="$session{config}{extrasURL}/images/trash.gif"></a>
					</td>~;
			}
		}
		# LIST 2 ADD
		foreach (keys %pols) {
			if ($_ =~ m/^\w{6}$/ && $units{'acct-policy'} !~ m/$_/ && $proc{'def-acct-policy'} !~ m/$_/) {
				$html{addAcctPol} .= qq~<option value="$_">$pols{$_}{name}</option>~;
			}
		}			
	}

	# DEFAULT FW POLS
	foreach (split " ",$proc{'def-fw-policy'}) {
		my ($flag1, $flag2);
		if ($_ =~ m/^([!%]{0,2})(\w{6})/) {
			if ($1 =~ m/!/) { $flag1 = "invert1.gif" } else { $flag1 = "invert0.gif" }
			if ($1 =~ m/%/) { $flag2 = "break1.gif" } else { $flag2 = "break0.gif" }
			$html{unitFw} .= qq~<tr><td></td>
				<td width=16><img src="$session{config}{extrasURL}/images/$flag1"></td>
				<td width=16><img src="$session{config}{extrasURL}/images/$flag2"></td>
				<td>$1$pols{$2}{name}</td><td>[default]</td></tr>~;
		}		
	}
	# CUSTOM FW POLS
	foreach (split(" ",$units{'fw-policy'})) {
		if ($_ =~ m/^([!%]{0,2})(\w{6})/) {
			my ($flag1,$flag2,$pid,$flg);
			$flg = $1;
			$pid = $2;
			if ($flg =~ m/!/) { $flag1 = "invert1.gif" } else { $flag1 = "invert0.gif" }
			if ($flg =~ m/%/) { $flag2 = "break1.gif" } else { $flag2 = "break0.gif" }
			$html{unitFw} .= qq~<tr><td></td>
				<td width=16><a href="?op=invertUnitPolicy&oid=$oid&pid=$pid&mode=fw"><img src="$session{config}{extrasURL}/images/$flag1"></a></td>
				<td width=16><a href="?op=breakUnitPolicy&oid=$oid&pid=$pid&mode=fw"><img src="$session{config}{extrasURL}/images/$flag2"></a></td>
				<td>$pols{$pid}{name}</td>
				<td><img src="$session{config}{extrasURL}/images/bullet_arrow_up.gif">
					<img src="$session{config}{extrasURL}/images/bullet_arrow_down.gif">
					<a href="?op=deleteUnitPolicy&oid=$oid&pid=$pid&mode=fw"><img src="$session{config}{extrasURL}/images/trash.gif"></a>
				</td>~;
			}
		}
	# LIST 2 ADD
	foreach (keys %pols) {
		if ($_ =~ m/^\w{6}$/ && $units{'fw-policy'} !~ m/$_/ && $proc{'def-fw-policy'} !~ m/$_/) {
			$html{addFwPol} .= qq~<option value="$_">$pols{$_}{name}</option>~;
		}
	}	
	
	$result = qq~
	<table width=100%>
		<tr><td width=50% valign=top>
			<table class=adminlist>
				<tr><td colspan=5 class=bold>Accounting policies</td></tr>
				$html{unitAcct}
				<tr><td colspan=5><SELECT id=addAcctPolicy>$html{addAcctPol}</SELECT><input type=button onclick="location.href='?op=addUnitPolicy&mode=acct&oid=$oid&pid='+document.getElementById('addAcctPolicy').value" value="Add"></td></tr>
			</table>
		</td><td width=50% valign=top>
			<table class=adminlist>
				<tr><td colspan=5 class=bold>Blocking policies</td></tr>
				$html{unitFw}
				<tr><td colspan=5><SELECT id=addFwPolicy>$html{addFwPol}</SELECT><input type=button onclick="location.href='?op=addUnitPolicy&mode=fw&oid=$oid&pid='+document.getElementById('addFwPolicy').value" value="Add"></td></tr>
			</table>	
		</td></tr>
	</table>
	
	<p>
	<DIV class=databox>
	<div><b>System Policy: </b>$units{'sys-policy'}</div>
	<div>
	<a class=btn1 href="?op=saveUnitSysPolicy&oid=$oid&pol=allow">Allow All</a>
	<a class=btn1 href="?op=saveUnitSysPolicy&oid=$oid&pol=allow-login">Allow login</a>
	<a class=btn1 href="?op=saveUnitSysPolicy&oid=$oid&pol=allow-money">Allow money</a>
	<a class=btn1 href="?op=saveUnitSysPolicy&oid=$oid&pol=allow-quota">Allow quota</a>
	</div>
	<div>
	<a class=btn1 href="?op=saveUnitSysPolicy&oid=$oid&pol=deny">Deny All</a>
	<a class=btn1 href="?op=saveUnitSysPolicy&oid=$oid&pol=deny-login">Deny login</a>
	<a class=btn1 href="?op=saveUnitSysPolicy&oid=$oid&pol=deny-money">Deny money</a>
	<a class=btn1 href="?op=saveUnitSysPolicy&oid=$oid&pol=deny-quota">Deny quota</a>	
	</div>
	</DIV>
		~;	
	return $result;
}

#-------------------------------------------------------------------
sub www_deleteUnitPolicy {
	checkAdmin();
	my ($oid,$pid,%unit,%pol,$mode);
		$oid = $session{form}{oid};
		$pid = $session{form}{pid};
		$mode = $session{form}{mode};
		%unit = $session{netams}->getUnit($oid);
	if ($unit{$mode.'-policy'} =~ m/([!%]{0,2})$pid/) {
		%pol = $session{netams}->getPolicy($pid);
		$session{netams}->runCmd("service processor");
		$session{netams}->runCmd("unit $unit{type} oid $oid no $mode-policy $1$pol{name}");
		$session{netams}->runCmd("exit");			
	}	
	return Nawt::Theme::getRedirect("?op=editUnitPolicy&oid=$oid");	
}

#-------------------------------------------------------------------
sub www_addUnitPolicy {
	checkAdmin();
	my ($oid,$pid,%unit,%pol,$mode);
		$oid = $session{form}{oid};
		$pid = $session{form}{pid};
		%unit = $session{netams}->getUnit($oid);
		%pol = $session{netams}->getPolicy($pid);
		$mode = $session{form}{mode};
	$session{netams}->runCmd("service processor");
	$session{netams}->runCmd("unit $unit{type} oid $oid $mode-policy $pol{name}");
	$session{netams}->runCmd("exit");			
	return Nawt::Theme::getRedirect("?op=editUnitPolicy&oid=$oid");	
}

#-------------------------------------------------------------------
sub www_invertUnitPolicy {
	checkAdmin();
	my ($oid,$pid,%unit,%pol,$newlist,$mode);
		$oid = $session{form}{oid};
		$pid = $session{form}{pid};
		$mode = $session{form}{mode};
		%unit = $session{netams}->getUnit($oid);
		%pol = $session{netams}->getPolicy();
		
		$session{netams}->runCmd("service processor");
		foreach (split " ",$unit{$mode."-policy"}) {
			my $flag;
			if ($_ =~ m/([!%]{0,2})($pid)/) {
				my $flg = $1;
				if ($flg =~ m/!/) { $flag = $flg; $flag =~ s/!//g; } else { $flag = "!".$flg; }
				$newlist .= $flag.$pol{$pid}{name}." ";
			} elsif ($_ =~ m/([!%]{0,2})(\w{6})/){
				$newlist .= $1.$pol{$2}{name}." ";
			} else {
				next;
			}
			$session{netams}->runCmd("unit $unit{type} oid $oid no $mode-policy $1$pol{$2}{name}");
		}
		#return $newlist;
		$session{netams}->runCmd("unit $unit{type} oid $oid $mode-policy $newlist");
		$session{netams}->runCmd("exit");
		
	return Nawt::Theme::getRedirect("?op=editUnitPolicy&oid=$oid");			
}

#-------------------------------------------------------------------
sub www_breakUnitPolicy {
	checkAdmin();
	my ($oid,$pid,%unit,%pol,$newlist,$mode);
		$oid = $session{form}{oid};
		$pid = $session{form}{pid};
		%unit = $session{netams}->getUnit($oid);
		%pol = $session{netams}->getPolicy();
		$mode = $session{form}{mode};
		
		$session{netams}->runCmd("service processor");
		foreach (split " ",$unit{"$mode-policy"}) {
			my $flag;
			if ($_ =~ m/([!%]{0,2})($pid)/) {
				my $flg = $1;
				if ($flg =~ m/%/) { $flag = $flg; $flag =~ s/%//g; } else { $flag = $flg."%"; }
				$newlist .= $flag.$pol{$pid}{name}." ";
			} elsif ($_ =~ m/([!%]{0,2})(\w{6})/){
				$newlist .= $1.$pol{$2}{name}." ";
			} else {
				next;
			}
			$session{netams}->runCmd("unit $unit{type} oid $oid no $mode-policy $1$pol{$2}{name}");
		}
		$session{netams}->runCmd("unit $unit{type} oid $oid $mode-policy $newlist");
		$session{netams}->runCmd("exit");
		
	return Nawt::Theme::getRedirect("?op=editUnitPolicy&oid=$oid");			
}

#-------------------------------------------------------------------
sub www_saveUnitSysPolicy {
	checkAdmin();
	my ($oid,$pol,%unit,@out);
		$oid = $session{form}{oid};
		$pol = $session{form}{pol};
		%unit = $session{netams}->getUnit($oid);
	$session{netams}->runCmd("service processor");
	if ($pol =~ m/^(allow|deny)(\-\w+)?$/) {
		@out = $session{netams}->runCmd("unit $unit{type} oid $oid sys-$pol");
	}
	$session{netams}->runCmd("exit");
	return Nawt::Theme::getRedirect("?op=editUnitPolicy&oid=$oid");
}

# Updating unit policy set
#-------------------------------------------------------------------
sub www_saveUnitPolicy {
	checkAdmin();
	my ($oid, %h, %unit, %pol);
		$oid = $session{form}{oid};
		%unit = $session{netams}->getUnit($oid);
		%pol = $session{netams}->getPolicy();
		$h{fw} = $session{form}{hdnfwPols};
		$h{ac} = $session{form}{hdnacctPols};
		$h{fw} =~ s/,/ /g;
		$h{ac} =~ s/,/ /g;

	$session{netams}->runCmd("service processor");
	if ($unit{'acct-policy'} ne $h{ac}) {
		$unit{'acct-policy'} =~ s/(\w{6})/$pol{$1}{name}/g;		
		$session{netams}->runCmd("unit $unit{type} name $unit{name} no acct-policy $_") foreach split(" ",$unit{'acct-policy'});
		$session{netams}->runCmd("unit $unit{type} name $unit{name} acct-policy $h{ac}");
	}
	if ($unit{'fw-policy'} ne $h{fw}) {
		$unit{'fw-policy'} =~ s/(\w{6})/$pol{$1}{name}/g;
		$session{netams}->runCmd("unit $unit{type} name $unit{name} no fw-policy $_") foreach split(" ",$unit{'fw-policy'});
		$session{netams}->runCmd("unit $unit{type} name $unit{name} fw-policy $h{fw}");
	}
	$session{netams}->runCmd("exit");
	$session{netams}->runCmd("save");
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editUnitPolicy&oid=$oid");
}


#-------------------------------------------------------------------
sub www_editUnitMonitor {
	checkAdmin();
	my ($result, %html, $oid, %mon, %unit, %srv);	
		$oid = $session{form}{oid};
	$session{page}{title} = "Packet Monitoring";
	fillUnitMenu($oid);
		
	
	if ($session{netams}->hasService("monitor")) {
		%mon = $session{netams}->getMonitor();
		%unit = $session{netams}->getUnit($oid);
		%srv = $session{netams}->getService("monitor",1);
		foreach (keys %srv) {
			my $mod;
			if ($mon{$oid} =~ m/$_/) {
				$mod = "<b>ENABLED</b> (<a href='$session{env}{scripturl}?op=saveUnitMonitor&oid=$oid&mon=$_&enabled=0'>DISABLE</a>) ";
			} else {
				$mod = "<b>DISABLED</b> (<a href='$session{env}{scripturl}?op=saveUnitMonitor&oid=$oid&mon=$_&enabled=1'>ENABLE</a>)";
			}
			$html{body} .= qq~<tr><td class="bold" width="150">Service: $_<BR>$srv{$_}{"type"} $srv{$_}{"targ"}</td><td>$mod <a href='?op=showStatMonitor&mid=$srv{$_}{id}&oid=$oid'>STATS</a></td></tr>~;
		}
		$html{body} = "<table>$html{body}</table>";
	} else {
		$html{body} = "Monitoring not avalible. Service Monitor not found. Create one, please.";
	}
	
	$result = qq~
		<DIV class=databox>
		<DIV class=boxhead>Packet Monitoring</DIV>
			$html{body}
		</DIV>
		~;
		
	return $result;
}

#-------------------------------------------------------------------
sub www_showUnitQuota {
	my ($result, $oid, $dbh, $sth, %pols, %html);
	$oid = $session{form}{oid};
	$session{page}{title} = "Unit Quotas";
	fillUnitMenu($oid);
	
	return "Service Quota is not enabled. Please enable service first." if not $session{netams}->hasService('quota');	
	
	%pols = $session{netams}->getPolicy();
	foreach (keys %pols) {
		next if $_ eq "name2oid";
		$html{pols} .= "<option value='$_'>$pols{$_}{name}</option>";
	}
	
	$dbh = Nawt::Operation::Stats::getDBH('quota');
	$sth = Nawt::SQL->new("SELECT * FROM quota WHERE unit_oid=".hex($oid),$dbh);
	my $row;
	while (my @data = $sth->array) {	
		if ($row % 2) { $html{rowclass} = "row0"; } else { $html{rowclass} = "row1"; }
		my $policy_oid = uc sprintf "%06lx",$data[1];
		$html{data} .= "<tr class=$html{rowclass}>
			<td width=16><img src='$session{config}{extrasURL}/images/statistics.gif'></td>
			<td><a href='?op=editUnitQuota&oid=$oid&pid=$policy_oid'>$pols{$policy_oid}{name}</a></td>
			<td>".bytesToHuman($data[9])."</td>
			<td>".bytesToHuman($data[10])."</td>
			<td>".bytesToHuman($data[11])."</td>
			<td>".bytesToHuman($data[12])."</td>
			<td>".bytesToHuman($data[13])."</td>
			<td>".bytesToHuman($data[14])."</td>
			<td>".bytesToHuman($data[15])."</td>
			<td>".bytesToHuman($data[16])."</td>
			<td>".bytesToHuman($data[17])."</td>			
			<td>".bytesToHuman($data[18])."</td>
			<td>".bytesToHuman($data[19])."</td>
			<td>".bytesToHuman($data[20])."</td>			
		</tr>";
		$row++;
	}
	$result = qq~
	<table class=adminlist border=1>
	<tr class=boxhead><th colspan=2 rowspan=2>Policy</th><th colspan=3>Hour</th><th colspan=3>Day</th><th colspan=3>Week</th><th colspan=3>Month</th></tr>
	<tr class=boxhead><th>IN</th><th>OUT</th><th>SUM</th><th>IN</th><th>OUT</th><th>SUM</th><th>IN</th><th>OUT</th><th>SUM</th><th>IN</th><th>OUT</th><th>SUM</th></tr>
	$html{data}
	</table>
	<p>
	<select id=addQuotaPol>$html{pols}</select> <input type=button value="Add Quota" onclick="location.href='$session{env}{scripturl}?op=editUnitQuota&oid=$oid&pid='+document.getElementById('addQuotaPol').value">
	~;
	return $result;
}

#-------------------------------------------------------------------
sub www_editUnitQuota {
	my ($result, %unit, %html, $oid, $pid, $dbh, %pols, %data, $hasUnit);
	$oid = $session{form}{oid};
	$pid = $session{form}{pid};
	$session{page}{title} = "Unit Quota";
	fillUnitMenu($oid);
	addFormToDisable('quota') if not canEdit('unit');
	$hasUnit = $session{netams}->hasUnit($oid);
	
	return "Service quota not found. Enable service first." if not $session{netams}->hasService("quota");
	
	$dbh = Nawt::Operation::Stats::getDBH('quota');
	%data = Nawt::SQL->quickHash("SELECT * FROM quota WHERE unit_oid=".hex($oid)." AND policy_oid=".hex($pid),$dbh);
	%pols = $session{netams}->getPolicy();
	%unit = $session{netams}->getUnit($oid);
#	%srvq = $session{netams}->getService("quota");
	
	


	foreach (keys %pols) {
		next if $_ eq "name2oid";
		if ($data{policy_oid} == hex($_) or $pid eq $_) {
			$html{pols} .= "<option value='$_' selected>$pols{$_}{name}</option>";	
		} else {
			$html{pols} .= "<option value='$_'>$pols{$_}{name}</option>";	
		}
		if ($data{block_policy} == hex($_)) {
			$html{bpols} .= "<option value='$_' selected>$pols{$_}{name}</option>";	
		} else {
			$html{bpols} .= "<option value='$_'>$pols{$_}{name}</option>";	
		}		
	}
	$html{cmd_delete} = qq~<input type=submit value="Delete" onclick="document.getElementById('op').value='deleteUnitQuota'">~ if defined $data{policy_oid};		
	
	$dbh = Nawt::Operation::Stats::getDBH('summary');
	my %hour = Nawt::SQL->quickHash("SELECT * FROM summary WHERE prefix LIKE 'H' AND unit_oid=".hex($oid)." AND policy_oid=".hex($pid)." ORDER BY t_from DESC LIMIT 1",$dbh);
	my %day = Nawt::SQL->quickHash("SELECT * FROM summary WHERE prefix LIKE 'D' AND unit_oid=".hex($oid)." AND policy_oid=".hex($pid)." ORDER BY t_from DESC LIMIT 1",$dbh);
	my %week = Nawt::SQL->quickHash("SELECT * FROM summary WHERE prefix LIKE 'W' AND unit_oid=".hex($oid)." AND policy_oid=".hex($pid)." ORDER BY t_from DESC LIMIT 1",$dbh);
	my %month = Nawt::SQL->quickHash("SELECT * FROM summary WHERE prefix LIKE 'M' AND unit_oid=".hex($oid)." AND policy_oid=".hex($pid)." ORDER BY t_from DESC LIMIT 1",$dbh);

	$result = "
	<DIV class=databox>
		<table>
			<FORM METHOD=GET ACTION='$session{env}{scripturl}' ID=quota>
			<INPUT TYPE=hidden NAME=op ID=op VALUE='saveUnitQuota'>
			<INPUT TYPE=hidden NAME=oid VALUE='$oid'>
			<tr><td class=bold>Accounting Policy: </td><td><select name=pid><option value=''>Default</option>$html{pols}</select></td></tr>
			<tr><td class=bold>Blocking Policy: </td><td><select name=bpolicy><option value=''>Default</option>$html{bpols}</select></td></tr>
			<tr><td class=bold>Soft-Treshold: </td><td><input name=treshold value='$data{soft_treshold}' size=3><b>%</b></td></tr>
		</table>
		<table>
			<tr><td></td><td class=bold>IN</td><td class=bold>OUT</td><td class=bold>SUM</td></tr>
			<tr>
				<td class=bold>Hour</td>
				<td><input type=text name=h_in size='10' value='".bytesToHuman($data{h_in})."'></td>
				<td><input type=text name=h_out size='10' value='".bytesToHuman($data{h_out})."'></td>
				<td><input type=text name=h_sum size='10' value='".bytesToHuman($data{h_sum})."'></td>
			</tr>
			<tr>
				<td class=bold></td>
				<td>".bytesToHuman($hour{bytes_in})."</td>
				<td>".bytesToHuman($hour{bytes_out})."</td>
				<td>".bytesToHuman($hour{bytes_in}+$hour{bytes_out})."</td>
			</tr>			
			<tr>
				<td class=bold>Day</td>
				<td><input type=text name=d_in size='10' value='".bytesToHuman($data{d_in})."'></td>
				<td><input type=text name=d_out size='10' value='".bytesToHuman($data{d_out})."'></td>
				<td><input type=text name=d_sum size='10' value='".bytesToHuman($data{d_sum})."'></td>
			</tr>
			<tr>
				<td class=bold></td>
				<td>".bytesToHuman($day{bytes_in})."</td>
				<td>".bytesToHuman($day{bytes_out})."</td>
				<td>".bytesToHuman($day{bytes_in}+$day{bytes_out})."</td>
			</tr>			
			<tr>
				<td class=bold>Week</td>
				<td><input type=text name=w_in size='10' value='".bytesToHuman($data{w_in})."'></td>
				<td><input type=text name=w_out size='10' value='".bytesToHuman($data{w_out})."'></td>
				<td><input type=text name=w_sum size='10' value='".bytesToHuman($data{w_sum})."'></td>
			</tr>
			<tr>
				<td class=bold></td>
				<td>".bytesToHuman($week{bytes_in})."</td>
				<td>".bytesToHuman($week{bytes_out})."</td>
				<td>".bytesToHuman($week{bytes_in}+$week{bytes_out})."</td>
			</tr>			
			<tr>
				<td class=bold>Month</td>
				<td><input type=text name=m_in size='10' value='".bytesToHuman($data{m_in})."'></td>
				<td><input type=text name=m_out size='10' value='".bytesToHuman($data{m_out})."'></td>
				<td><input type=text name=m_sum size='10' value='".bytesToHuman($data{m_sum})."'></td>
			</tr>
			<tr>
				<td class=bold></td>
				<td>".bytesToHuman($month{bytes_in})."</td>
				<td>".bytesToHuman($month{bytes_out})."</td>
				<td>".bytesToHuman($month{bytes_in}+$month{bytes_out})."</td>
			</tr>			
			<tr><td colspan=2><input type=submit value='Save'> $html{cmd_delete}</td></tr>
			</FORM>
		</table>

	</DIV>
	";	
	return $result;
}

#-------------------------------------------------------------------
sub www_editUnitLogin {
	checkAdmin();
	my (%unit, $oid, %html, $result, %login, $dbh);
		$oid = $session{form}{oid};
		%unit = $session{netams}->getUnit($oid);
		$session{page}{title} = "Service Login";
		fillUnitMenu($oid);
		return "Service login not found. Configure it first." if not $session{netams}->hasService('login');
		%login = Nawt::Login::getUnitLogin($oid);

		if (defined $login{flags}) {
			my ($delta, $units);
			$html{useLogin} = qq~<option value="0">Disabled</option><option value="1" selected>Enabled</option>~;
			$html{changed} = epochToHuman($login{last_changed},"%y-%m-%d %j:%n");
			($delta,$units) = Nawt::DateTime::secondsToInterval(time-$login{last_changed});
			$html{changed} .= " ($delta $units ago)";
			$html{opened} = epochToHuman($login{last_opened_time},"%y-%m-%d %j:%n");
			($delta,$units) = Nawt::DateTime::secondsToInterval(time-$login{last_opened_time});
			$html{opened} .= " ($delta $units ago)";
			if ($login{status} eq "CLOSED") {
				$html{connBtn} = qq~<input type="submit" onclick="#" value="OPEN">~;
			} else {
				$html{connBtn} = qq~<input type="submit" onclick="#" value="CLOSE">~;
			}
			$html{status} = qq~<tr><td> Connection: <b>$login{status}</b></td><td>$html{connBtn}</td></tr> ~;
		} else {
			$html{useLogin} = qq~<option value="0" selected>Disabled</option><option value="1">Enabled</option>~;
			$html{changed} = "Never";
			$html{opened} = "Never";
		}
	addFormToDisable('loginSetup') if not canEdit('user');
	$result = qq~
	<DIV class=databox>
		<DIV class=boxhead>Login Settings</DIV>
		<table>
		<script language="JavaScript" src="$session{config}{extrasURL}/js/unit_login.js"></script>
		<FORM ID="loginSetup" METHOD="GET" ACTION="$session{env}{scripturl}">
		<INPUT TYPE="hidden" NAME="op" VALUE="saveUnitLogin">
		<INPUT TYPE="hidden" NAME="oid" VALUE="$oid">
		<tr><td width="150">Login service</td><td><select id="useLogin" name="useLogin" onchange="toggleEnableForm('useLogin','loginPtrs');">$html{useLogin}</select></td></tr>
		<tr><td>Last changed:</td><td>$html{changed}</td></tr>
		<tr><td>Login:</td><td><b>$unit{name}</b></td></tr>
		<tr><td>Password:</td><td><input type="password" id="loginPass" name="password" value="$login{password}"> <a href="#" onclick="togglePassField();">show/hide</a></td></tr>
		<tr><td>Inact timeout:</td><td><input type="text" name="inact" onblur="isNumber(this)" value="$login{inact}"></td></tr>
		<tr><td>Abs timeout:</td><td><input type="text" name="abs" onblur="isNumber(this)" value="$login{abs}"></td></tr>
		<tr><td>MAC adress:</td><td><input type="text" name="mac" onblur="isMac(this)" value="$login{mac}"></td></tr>
		<tr><td></td><td><input type="submit" value="Save"></td></tr>
		</FORM>
		</table>	
	</DIV>
	~;
if (defined $login{flags}) {
	$result .= qq~
	<p>
	<DIV class=databox>
		<DIV class=boxhead>Connection Status</DIV>
		<table>
		<tr><td>Last opened:</td><td>$html{opened}</td></tr>
		<tr><td>Last IP:</td><td>$login{ip}</td></tr>
		<FORM METHOD="GET" ACTION="$session{env}{scripturl}">
		<INPUT TYPE="hidden" NAME="op" VALUE="toggleUnitLogin">
		<INPUT TYPE="hidden" NAME="oid" VALUE="$oid">
		$html{status}
		</FORM>
		</table>
		<a href="?op=showLoginList">Show all logged units</a>
	</DIV>
	~;
}
	return $result;	
}


#-------------------------------------------------------------------
sub www_deleteUnitQuota {
	checkAdmin();
	my $oid = $session{form}{oid};

	return Nawt::Theme::getRedirect("?op=showUnitQuota&oid=$oid") if not canEdit('unit') or not $session{netams}->hasService('quota');	
	
	foreach (keys %{$session{form}}) {
		$session{form}{$_} =~ s/ +//g;
		if ($_ =~ m/^[h|d|w|m]\_[in|out|sum]/) {
			$session{form}{$_} = 0;
		}
	}
	www_saveUnitQuota();
	my $dbh = Nawt::Operation::Stats::getDBH('quota');
	Nawt::SQL->write("DELETE FROM quota WHERE unit_oid=".hex($session{form}{oid})." AND policy_oid=".hex($session{form}{pid}),$dbh);
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showUnitQuota&oid=$oid");
}

#-------------------------------------------------------------------
sub www_saveUnitQuota {
	checkAdmin();
	my (%unit, %pols, $oid, $pid, $cmd, %op);
		$oid = $session{form}{oid};
		$pid = $session{form}{pid};
		%unit = $session{netams}->getUnit($oid);	
		%pols = $session{netams}->getPolicy();	
		%op = %{$session{form}};
		
	return Nawt::Theme::getRedirect("?op=showUnitQuota&oid=$oid") if not canEdit('unit') or not $session{netams}->hasService('quota');
	
	$op{treshold} = int($op{treshold});
	foreach (keys %op) {
		$op{$_} =~ s/ +//g;
		if ($_ =~ m/^[h|d|w|m]\_[in|out|sum]/) {
			$op{$_} = 0 if $op{$_} !~ m/^\d+(\.\d+)?[b|k|m|g]?$/i;
			$op{$_} =~ s/(\.\d+)?b//ig;
		}
	}
	
	$cmd .= "policy $pols{$pid}{name} " if defined $pols{$pid}{name};
	$cmd .= "soft-treshold $op{treshold} ";

	$session{netams}->runCmd("service quota");
	# hour
	$session{netams}->runCmd("set oid $oid $cmd hour $op{h_in} in");
	$session{netams}->runCmd("set oid $oid $cmd hour $op{h_out} out");
	$session{netams}->runCmd("set oid $oid $cmd hour $op{h_sum} sum");
	# day
	$session{netams}->runCmd("set oid $oid $cmd day $op{d_in} in");
	$session{netams}->runCmd("set oid $oid $cmd day $op{d_out} out");
	$session{netams}->runCmd("set oid $oid $cmd day $op{d_sum} sum");
	# week
	$session{netams}->runCmd("set oid $oid $cmd week $op{w_in} in");
	$session{netams}->runCmd("set oid $oid $cmd week $op{w_out} out");
	$session{netams}->runCmd("set oid $oid $cmd week $op{w_sum} sum");
	# month
	$session{netams}->runCmd("set oid $oid $cmd month $op{m_in} in");
	$session{netams}->runCmd("set oid $oid $cmd month $op{m_out} out");
	$session{netams}->runCmd("set oid $oid $cmd month $op{m_sum} sum");
		
	$session{netams}->runCmd("exit");

	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showUnitQuota&oid=$oid");
}

#-------------------------------------------------------------------
sub www_saveUnitMonitor {
	checkAdmin();
	my ($oid, %srv);
		$oid = $session{form}{oid};
		%srv = $session{netams}->getService("monitor",1);
	
	if (canEdit('unit') and defined $srv{$session{form}{mon}}) {
		$session{netams}->runCmd("service $session{form}{mon}");
		if ($session{form}{enabled}) {
			$session{netams}->runCmd("monitor unit $oid");
		} else {
			$session{netams}->runCmd("no monitor unit $oid");
		}
		$session{netams}->runCmd("exit");
		$session{netams}->runCmd("save");
	}
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editUnitMonitor&oid=$oid");	
}

#-------------------------------------------------------------------
sub fillUnitMenu {
	my $oid = $_[0];
	my $has = $session{netams}->hasUnit($oid);
	addContMenuItem("Navigation");
	addContMenuItem("Show All Units","?op=showUnitList");
	addContMenuItem("Add New Unit","?op=editUnit") if $has;
	addContMenuItem("Delete Unit","?op=deleteUnit&oid=$oid") if $has;	
	addContMenuItem("Unit Configuration") if $has;
	addContMenuItem("Basic Options","?op=editUnit&oid=$oid") if $has;
	addContMenuItem("Bandwidth Limits","?op=editUnitBW&oid=$oid") if $has;
	addContMenuItem("Unit Policies","?op=editUnitPolicy&oid=$oid") if $has;
	addContMenuItem("Traffic Quotas","?op=showUnitQuota&oid=$oid") if $has;
	addContMenuItem("Login Service","?op=editUnitLogin&oid=$oid") if $has;
	addContMenuItem("Packet Monitoring","?op=editUnitMonitor&oid=$oid") if $has;
	addContMenuItem("Statistics","?op=showStat&oid=$oid") if $has;
	
	#$session{navigation}{right} = "<div class=databox style='height:100%;overflow:auto;'><table class=adminlist>".Nawt::Operation::UnitList::buildList(units=>\%{$session{netams}->{config}{units}},mode=>"short")."</table></div>";

	#addContMenuItem("Add Note","?op=editNote&parentClass=unit&parentId=$oid") if $has;
}

1;