package Nawt::Operation::UnitList;
# $Id$
use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Navigation;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_showUnitList );


# usage = makeUnitList(@oids)
#-------------------------------------------------------------------
sub makeUnitList {
	my ($out, @oid, %html);
		@oid = @{$_[0]};

}	
	
	
#-------------------------------------------------------------------
sub www_showUnitList {
	checkAdmin();
	my ($result, %units, %html);
		%units = $session{netams}->getUnit();
		$session{page}{title} = "Unit List";

	# Adding related menu items
	$html{menu} .= qq~<a class=btn1 href="?op=editUnit">Add Unit</a>~ if canEdit('unit');
	
	foreach ($session{netams}->getUnitTypes()) {
		if ($session{form}{ftype} eq $_) {
			$html{seltypes} .= qq~<option value="$_" selected>$_</option>~;
		} else {
			$html{seltypes} .= qq~<option value="$_">$_</option>~;
		}
	}

	my %pols = $session{netams}->getPolicy();

	foreach (keys %pols) {
		if ($session{form}{fpol} eq "$pols{$_}{name}") {
			$html{fpol} .= qq~<option value="$pols{$_}{name}" selected>$pols{$_}{name}</option>~ if $_ ne "name2oid";
		} else {
			$html{fpol} .= qq~<option value="$pols{$_}{name}">$pols{$_}{name}</option>~ if $_ ne "name2oid";
		}
	}

	my %groups = $session{netams}->getUnit("groups");
	foreach (keys %groups) {
		if ($session{form}{fgroup} eq "$groups{$_}") {
			$html{grplist} .= qq~<option value="$_" selected>$groups{$_}</option>~;
		} else {
			$html{grplist} .= qq~<option value="$_">$groups{$_}</option>~;
		}
	}
	
	# FILTERS
	$html{filter} = qq~
		<FORM id=filter method="GET" action="$session{env}{scripturl}">
		<input type="hidden" name="op" value="showUnitList">
		<input type="hidden" name="filter" value="1">
		<tr>
			<td class=bold colspan=2>Find:</td>
			<td colspan=4><INPUT TYPE="text" NAME="fname" value="$session{form}{fname}" style="width:100%"></td>
			<td><SELECT NAME="ftype" style="width:100%"><option value=""></option>$html{seltypes}</SELECT></td>
			<td><select name="fgroup" style="width:100%"><option></option>$html{grplist}</select></td>
			<td><INPUT TYPE="text" style="width:100%" NAME="fip" value="$session{form}{fip}"></td>
			<td><select name="fserv" style="width:100%"><option></option><option value="quota">Quota</option><option value="login">Login</option><option value="policy">Policy</option><option value="bandwidth">Bandwidth</option></select></td>
			<td><nobr><select NAME="fsyspol"><option></option><option value="sys-deny">sys-deny</option><option value="sys-deny-quota">sys-deny-quota</option><option value="sys-deny-money">sys-deny-money</option></select><INPUT TYPE="submit" value="Find!"></nobr></td>
		</tr>
		</FORM>		
		~;

	# Filter list if needed
	if ($session{form}{filter} && $session{form}{op} ne "tree") {
		foreach (keys %units) {
			if ($session{form}{fname} ne "") {
				delete $units{$_} if $units{$_}{name} !~ m/$session{form}{fname}/i;
			}
			if ($session{form}{ftype} ne "") {
				delete $units{$_} if $units{$_}{type} !~ m/$session{form}{ftype}/i;
			}
			if ($session{form}{fgroup} ne "") {
				delete $units{$_} if $units{$_}{parent} !~ m/$session{form}{fgroup}/i;
			}
			if ($session{form}{fip} ne "") {
				delete $units{$_} if $units{$_}{ip} !~ m/$session{form}{fip}/i;				
			}
			if ($session{form}{fserv} ne "") {
				if ($session{form}{fserv} eq "quota") {
					delete $units{$_} if !defined $units{$_}{quota};
				} elsif ($session{form}{fserv} eq "policy") {
					delete $units{$_} if !defined $units{$_}{'acct-policy'} && !defined $units{$_}{'fw-policy'};
				} elsif ($session{form}{fserv} eq "bandwidth") {
					delete $units{$_} if !defined $units{$_}{'bw-in'} && !defined $units{$_}{'bw-out'};
				}
			}
			if ($session{form}{fsyspol} ne "") {
				delete $units{$_} if $units{$_}{'sys-policy'} !~ m/$session{form}{fsyspol}/i;				
			}
			if ($session{form}{fpol} ne "") {
				delete $units{$_} if $units{$_}{'acct-policy'} !~ m/$session{form}{fpol}/i; #|| $units{$_}{'fw-policy'} !~ m/$session{form}{fpol}/i;
			}
		}
	}

	# TREE VIEW
	if ($session{form}{view} eq "tree") {
		$result .= _buildTree(\%units);	
	# LIST VIEW
	} else {
		$result = qq~
		<div align=right>$html{menu}</div>
			<SCRIPT type=text/javascript SRC="$session{config}{extrasURL}/js/unit_list.js"></SCRIPT>
			<table class=adminlist>
				<tr class=boxhead><td colspan="4">Name</td>
					<td colspan="2">Actions</td>
					<td>Type</td>
					<td>Parent</td>
					<td>IP</td>
					<td>Services</td>
					<td>System policy</td>
				</tr>
				$html{filter}
				<FORM id=unitlist METHOD="GET" ACTION="$session{env}{scriptname}">
				<input type="hidden" name="op" id="multiUnitOp" value="editUnitListBatch">
				<input type="hidden" name="oid" id="multiUnitOid" value="">
		~;
		$result .= buildList(units=>\%units);
		$result .= qq~
			</FORM>
			</table>
			<table><tr><td width="16"></td>
			<td><img src="$session{config}{extrasURL}/images/arrow_ltr.png"></td>
			<td><a href="#pageBottom" onclick="selall();">Select all</a> / <a href="#pageBottom" onclick="clearall();">Clear all</a> / <a href="#pageBottom" onclick="selinv();">Invert selection</a></td>
			<td><a href="#pageBottom" onclick="multiUnitAct('showStat')"><img src="$session{config}{extrasURL}/images/statistics.gif" alt="Complex statistic.."></a></td>
			<td><a href="#pageBottom" onclick="multiUnitAct('deleteUnit')"><img src="$session{config}{extrasURL}/images/trash.gif" alt="Delete selected.."></a></td>
			</tr></table>
		<div align=right>$html{menu}</div>
		~;
	}

	return $result;
}


# buildList (%hash)
#-------------------------------------------------------------------
sub buildList {
	my ($result, %units, %html, $row, %op);
		%op = (@_);
		%units = %{$op{units}};
		foreach (sort { ($units{$a}{parent} cmp $units{$b}{parent}) or ($units{$a}{type} cmp $units{$b}{type}) or ($units{$a}{name} cmp $units{$b}{name}) } keys %units) {
			if ($_ ne "name2oid" && $_ ne "") {
				$html{optional} = "";
				$row ++;
				if ($row % 2) { $html{rowclass} = "row0"; } else { $html{rowclass} = "row1"; }
				if ($units{$_}{'sys-policy'} =~ m/sys-deny/) { $html{rowclass} = "rowred"; }
				$html{status} = $units{$_}{'sys-policy'};
				$html{status} =~ s/sys-deny-/&nbsp;/g;
				$html{opts} = "";
				$html{desc} = "";
				if ($op{mode} ne "short") {
					$html{opts} .= qq~<a href="?op=editUnitPolicy&oid=$_"><img src="$session{config}{extrasURL}/images/filter_ico.gif" alt="This unit uses custom policy set \n ACCT: $units{$_}{'acct-policy'} \n FW: $units{$_}{'fw-policy'}"></a>~ if $units{$_}{'acct-policy'} ne "" || $units{$_}{'fw-policy'} ne "";
					$html{opts} .= qq~<a href="?op=editUnitBW&oid=$_"><img src="$session{config}{extrasURL}/images/sim_ico.gif" alt="This unit uses bandwidth limits \n IN: $units{$_}{'bw-in'} \n OUT: $units{$_}{'bw-out'}"></a>~ if $units{$_}{'bw-in'} ne "" || $units{$_}{'bw-out'} ne "";
					$html{opts} .= qq~<a href="?op=showUnitQuota&oid=$_"><img src="$session{config}{extrasURL}/images/statistics.gif" alt="This unit uses quota"></a>~ if $units{$_}{quota};
					$html{desc} = qq~<div class=small>$units{$_}{description}</div>~ if defined $units{$_}{description};
					$html{optional} .= qq~
						<td width="10"><a href="?op=deleteUnit&oid=$_"><img src="$session{config}{extrasURL}/images/trash.gif" alt="Delete unit..."></a></td>
						<td width="10"><a href="?op=showStat&oid=$_"><img src="$session{config}{extrasURL}/images/statistics.gif" alt="Stats..."></a></td>
						<td align=center>$units{$_}{type}</td>
						<td align=center><nobr>$units{$units{$_}{parent}}{name}</nobr></td>
						<td><div onclick="if (this.style.overflow!='auto') {this.style.overflow='auto'} else {this.style.overflow=''}" style="overflow: auto;height: 16px;">$units{$_}{ip}</div></td>
						<td>$html{opts}</td>
						<td>$html{status}</td>
					~;
				}
				$html{units} .= qq~
					<tr class="$html{rowclass}" onmouseover="this.className='row3'" onmouseout="this.className='$html{rowclass}'">
						<td width="10" align=right>$row</td>
						<td width="20"><INPUT TYPE="checkbox" ID="u$row" value="$_"></td>
						<td width="10"><img onclick="toggleRow('$_')" style="cursor: hand" src="$session{config}{extrasURL}/images/icons/$units{$_}{type}.gif"></td>
						<td><nobr><a href="?op=editUnit&oid=$_">$units{$_}{name}</a></nobr> $html{desc}</td>
						$html{optional}
					</tr>
					<tr id=unitRow$_ style="display: none;">
						<td colspan=2></td>
						<td colspan=9 class=note>
							<b>Type:</b> $units{$_}{type}<br>
							<b>Parent:</b> <a href="?op=editUnit&oid=$units{$_}{parent}">$units{$units{$_}{parent}}{name}</a><br>
							<b>Description:</b> $units{$_}{description}<br>
						</td>
					</tr>
					~;
			}
		}
	return $html{units}.qq~<input type="hidden" id="listcount" value="$row">~;
}

# _buildTree ( %units , [ level , oid ] )
#-------------------------------------------------------------------
sub _buildTree {
	my ($result, %units, %html, $level);
		%units = %{$_[0]};
		$level = $_[1];
	
	## Building root level
	if (!defined $level) {
		foreach (keys %units) {
			my $oid = $_;
			if ($_ ne "" and $_ ne "name2oid" and $units{$_}{parent} eq "") {
				my $desc;
				$desc = qq~<div class=small style="padding-left: 20px">$units{$_}{description}</div>~ if defined $units{$_}{description};
				$html{rows} .= qq~ <tr>
					<td><nobr><a href="?op=editUnit&oid=$_"><img src="$session{config}{extrasURL}/images/icons/$units{$_}{type}.gif">$units{$_}{name}</a></nobr> $desc</td>
					<td width="10"><a href="?op=deleteUnit&oid=$_"><img src="$session{config}{extrasURL}/images/trash.gif" alt="Delete unit..."></a></td>
					<td width="10"><a href="?op=showStat&oid=$_"><img src="$session{config}{extrasURL}/images/statistics.gif" alt="Stats..."></a></td>
					<td align=center>$units{$_}{type}</td>
					<td><div onclick="if (this.style.overflow!='auto') {this.style.overflow='auto'} else {this.style.overflow=''}" style="overflow: auto;height: 16px;">$units{$_}{ip}</div></td>
					<td>$units{$_}{'sys-policy'}</td>
					</tr> ~;
				if ($units{$_}{type} eq "group") {
					## Recurse sub-levels
					my @childs = split(",",$units{$_}{childs});
					foreach (@childs) {
						$html{rows} .= _buildTree(\%units,$level+1,$_);
					}
				}
			}
		}
		$result = qq~<p>
				<table class=adminlist>
				<tr class=boxhead><td>Name</td>
					<td colspan="3">Actions</td>
					<td>Type</td>
					<td>IP</td>
					<td>Status</td>
				</tr>
				$html{rows}
				</table>
				~;
		return $result;	
	## Builging sub-levels
	} else {
		my $spacer = "&nbsp;&nbsp;&nbsp;&nbsp;"x$level;
		my $oid = $_[2];
		my $desc;
		$desc = qq~<div class=small style="padding-left: 20px">$units{$_}{description}</div>~ if defined $units{$_}{description};
		$html{rows} .= qq~ <tr>
				<td><nobr>$spacer<a href="?op=editUnit&oid=$_"><img src="$session{config}{extrasURL}/images/icons/$units{$_}{type}.gif"><font style="padding-bottom: 5px">$units{$oid}{name}</font></a></nobr> $desc</td>
				<td width="10"><a href="?op=deleteUnit&oid=$_"><img src="$session{config}{extrasURL}/images/trash.gif" alt="Delete unit..."></a></td>
				<td width="10"><a href="?op=showStat&oid=$_"><img src="$session{config}{extrasURL}/images/statistics.gif" alt="Stats..."></a></td>
				<td align=center>$units{$oid}{type}</td>
				<td><div onclick="if (this.style.overflow!='auto') {this.style.overflow='auto'} else {this.style.overflow=''}" style="overflow: auto;height: 16px;">$units{$_}{ip}</div></td>
				<td>$units{$oid}{'sys-policy'}</td>
				</tr> ~;
		if ($units{$oid}{type} eq "group") {
			## Recurse sub-levels
			my @childs = split(",",$units{$oid}{childs});
			foreach (@childs) {
				$html{rows} .= _buildTree(\%units,$level+1,$_);
			}
		}
		return $html{rows};
	}
}


1;