package Nawt::Operation::User;
# $Id$

use strict;
use Exporter;
use Nawt::SQL;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::Language;
use Nawt::Navigation;

our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_showUserList &www_editUser &www_saveUser &www_deleteUser &www_saveUserAcl);

# usage = www_showUserList()
#-------------------------------------------------------------------
sub www_showUserList {
	my ($out,%main,%user,%html);
		%main = $session{netams}->getService('main');
		%user = %{$main{users}};
		$session{page}{title} = $LANG{USER_LIST};
		addContMenuItem("Actions");
		addContMenuItem($LANG{NAWT_ADD}." ".$LANG{USER_USER},"?op=editUser");
		addContMenuItem($LANG{SERVICE_SERVICE}." Main","?op=editService&type=main");
		
	foreach (keys %user) {
		$html{list} .= qq~<tr><td width=16><img src="$session{config}{extrasURL}/images/user.gif"></td>
			<td><a href="?op=editUser&oid=$_">$user{$_}{name}</a></td>
			<td>$user{$_}{'real-name'}</td>
			<td>$user{$_}{'email'}</td>
			<td>$user{$_}{'permit'}</td></tr>~;
	}	
	
	$out = qq~
	<table class=adminform>
	<tr class=boxhead><td colspan=2>Login</td><td>Real Name</td><td>E-Mail</td><td>Permit</td></tr>
	$html{list}
	</table>
	~;
	return $out;
}

#-------------------------------------------------------------------
sub www_editUser {
	checkAdmin;
	my ($out);
		$session{page}{title} = "Edit User";
		$out = showUserParams($session{form}{oid});

	return $out;
}

# ( oid )
#-------------------------------------------------------------------
sub showUserParams {
	my ($oid,$out,%html,%user);
		$oid = $_[0];
		%user = $session{netams}->getUser($oid);
		addContMenuItem("Actions");
		addContMenuItem($LANG{USER_LIST},"?op=showUserList");
		addContMenuItem($LANG{SERVICE_SERVICE}." Main","?op=editService&type=main");
		addContMenuItem($LANG{NAWT_DELETE}." ".$LANG{USER_USER},"?op=deleteUser&oid=$oid") if $user{name};
	
		addFormToDisable('user') if not canEdit('user');
		foreach (qw(none web all)) {
			if ($user{permit} =~ m/$_/) {
				$html{permit} .= qq~<option value="$_" selected>$_</option>~;
			} else {
				$html{permit} .= qq~<option value="$_">$_</option>~;
			}
		}
		if ($user{name}) {
			$html{btndel} = qq~<input type=button value="$LANG{NAWT_DELETE}" onclick="location.href='?op=deleteUser&oid=$oid'">~;	
		}
			
$out = qq~
<DIV class=databox>
<TABLE>
<FORM METHOD="GET" ACTION="$ENV{SCRIPT_NAME}" ID=user>
<INPUT TYPE="hidden" NAME="op" VALUE="saveUser">
<INPUT TYPE="hidden" NAME="oid" VALUE="$oid">
<TR><TD class=bold>$LANG{USER_NAME_LBL}</TD><TD><INPUT TYPE=text NAME=name VALUE="$user{name}"><DIV class=small>$LANG{USER_NAME_TIP}</DIV></TD></TR>
<TR><TD class=bold>$LANG{USER_RNAME_LBL}</TD><TD><INPUT TYPE=text NAME=rname VALUE="$user{'real-name'}"><DIV class=small>$LANG{USER_RNAME_TIP}</DIV></TD></TR>
<TR><TD class=bold>$LANG{USER_EMAIL_LBL}</TD><TD><INPUT TYPE=text NAME=email VALUE="$user{email}"><DIV class=small>$LANG{USER_EMAIL_TIP}</DIV></TD></TR>
<TR><TD class=bold>$LANG{USER_PASS_LBL}</TD><TD><INPUT TYPE=password NAME=password VALUE="$user{password}"><DIV class=small>$LANG{USER_PASS_TIP}</DIV></TD></TR>
<TR><TD class=bold>$LANG{USER_PERMIT_LBL}</TD><TD><select name="permit">$html{permit}</select></TD></TR>
<TR><TD colspan=2><INPUT TYPE=submit VALUE="$LANG{NAWT_SAVE}"> $html{btndel}</TD></TR>
</FORM>
</TABLE>
</DIV>
<p>
~;
$out .= showRights($oid) if defined $user{name};	
	return $out;
}

#-------------------------------------------------------------------
sub showRights {
	my ($result, %html, $oid, %acl, %list);
	$oid = shift;
	%acl = getAclTypes();
	%list = Nawt::SQL->buildHash("SELECT action, value FROM nawt_premission WHERE userId LIKE ".quote($oid));
	addFormToDisable('acl') if not canEdit('user');
	
	my $i=0;
	foreach (keys %acl) {
		my ($state, $item);
		$state = "checked" if $list{$_};
		$item = qq~<td width=16><input type=checkbox value=1 name="acl_$_" $state></td><td class=bold>$acl{$_}</td>~;
		if ($i%2) { $html{list} .= $item."</tr>"; } else { $html{list} .= "<tr>".$item;	}		
		$i++;	
	}
	
	$result = qq~
	<table class=adminform>
	<FORM METHOD="GET" ACTION="$ENV{SCRIPT_NAME}" ID=acl>
	<INPUT TYPE="hidden" NAME="op" VALUE="saveUserAcl">
	<INPUT TYPE="hidden" NAME="oid" VALUE="$oid">	
	<tr class=boxhead><td colspan=4>This User Can Edit:</td></tr>
	$html{list}
	<tr><td colspan=4><input type=submit value="$LANG{NAWT_SAVE}"></td></tr>
	</FORM>
	</table>
	~;
	
	return $result;
}

#-------------------------------------------------------------------
sub www_saveUserAcl {
	checkAdmin;
	my ($oid,%list,%acl);
	$oid = $session{form}{oid};
	%acl = getAclTypes();
	%list = Nawt::SQL->buildHash("SELECT action, value FROM nawt_premission WHERE userId LIKE ".quote($oid));
	if (canEdit('user')) {
		foreach (keys %acl) {
			if ($session{form}{"acl_$_"}) {
				if (not $list{$_}) {
					Nawt::SQL->write("INSERT INTO nawt_premission SET userId = ".quote($oid).", action = '$_', value = '1'");
				}
			} else {
				Nawt::SQL->write("DELETE FROM nawt_premission WHERE userId = ".quote($oid)." AND action = '$_'");
			}
		}
	}
	
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=editUser&oid=$oid");
}

#-------------------------------------------------------------------
sub getAclTypes {
	my %acl = (user=>'Users',service=>'Services',unit=>'Units',policy=>'Policies',account=>'Accounts',plan=>'Plans');
	return %acl;
}

#-------------------------------------------------------------------
sub www_saveUser {
	checkAdmin();
	my ($oid);
	$oid = $session{form}{oid};
	$oid = $session{netams}->setUser(oid=>$oid,
		name=>$session{form}{name},
		'real-name'=>$session{form}{rname},
		email=>$session{form}{email},
		password=>$session{form}{password},
		permit=>$session{form}{permit}) if canEdit('user');
	return Nawt::Theme::getRedirect("?op=showUserList") if $oid eq "";
	return Nawt::Theme::getRedirect("?op=editUser&oid=$oid");
}

#--------------------------------------------------------------------
sub www_deleteUser {
	checkAdmin();
	my $oid;
	$oid = $session{form}{oid};
	return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showUserList") if not canEdit('user');
	if ($session{form}{confirmed}) {
		$session{netams}->runCmd("no user oid $oid") if $oid =~ m/^\w{6}$/;
		return Nawt::Theme::getRedirect("$session{env}{scripturl}?op=showUserList");
	} else {
		$session{page}{title} = "Delete User";
		return qq~
		<div class=bold>Are You Sure?</div>
		<a class=btn1 href="?op=showUserList">No</a><a class=btn1 href="?op=deleteUser&oid=$oid&confirmed=1">Yes</a>
		~;
	}

	
}

1;
