package Nawt::Operation::Usertool;
# $Id: Usertool.pm,v 1.3 2005/04/15 22:39:13 ramirez Exp $

use strict;
use Exporter;
use Nawt::Session;
use Nawt::Privilegies;
use Nawt::DateTime;
use Nawt::Language;
#use Nawt::SQL;
	
our @ISA = qw( Exporter ); 
our @EXPORT = qw( &www_usertool &www_unitLoginout);

#--------------------------------------------------------------------
sub www_usertool {
	my ($mode, $result, %html);
		$mode = $session{config}{usertoolMode};
#return sprintf ("%6.6X",25282);
	if ($session{var}{userId} < 0) {
		$result .= showLogin();
	} else {
		$result .= showUserData();
	}

	return $result;
}

#-------------------------------------------------------------------
sub showAccInfo {
	my ($result,%html,%ams,%row);
	
	%ams = $session{netams}->getAccount($session{var}{userId});
	$ams{balance} = sprintf ("%.2f",$ams{balance});
	%row = Nawt::SQL->quickHash("SELECT * FROM nawt_accountdata WHERE oid LIKE '$session{var}{userId}'");
	$result = qq~
	<DIV class=databox>
	<div class=boxhead>Account Info</div>
	<table>
	<tr><td class="bold">Balance</td><td>$ams{balance}</td></tr>
	<tr><td class="bold">Credit Limit</td><td>$ams{credit}</td></tr>
	<tr><td class="bold">Plan</td><td>$ams{plan}</td></tr>
	<tr>
		<td class=bold>$LANG{ACCOUNT_NAME}:</td>
		<td>$row{surname} $row{name} $row{patronymic}</td>
	</tr>
	<tr>
		<td class=bold>$LANG{ACCOUNT_STREET}:</td>
		<td>$row{street}</td>
	</tr>
	<tr>
		<td class=bold>$LANG{ACCOUNT_HOUSE}:</td>
		<td>$row{house}</td>
	</tr>
	<tr>
		<td class=bold>$LANG{ACCOUNT_FLAT}:</td>
		<td>$row{flat}</td>
	</tr>
	<tr>
		<td class=bold>$LANG{ACCOUNT_ROOM}:</td>
		<td>$row{room}</td>			
	</tr>	
	<tr>
		<td class=bold>$LANG{ACCOUNT_PHONE}:</td>
		<td>$row{phone}</td>
	</tr>

	</table>
	
	
	
	<div class=boxhead>$LANG{CARD_ACTIVATE} $LANG{CARD_CARD}</div>
	<form method=POST action="$session{config}{scripturl}" id=actform>
	<input type="hidden" name="op" value="activateCard">
	<table>
		<tr>
			<td>$LANG{CARD_CARDNUM}</td>
			<td><input type="text" name="id" size="8"></td>
			<td>$LANG{CARD_PIN}</td>
			<td><input type="text" name="pin" size="25"></td>
			<td><input type="submit" value="$LANG{CARD_ACTIVATE}"></td>
		</tr>
	</table>
	</form>	
	
	</DIV>
	<p>
	~;

	return $result;		
}

#-------------------------------------------------------------------
sub showUserData {
	my ($result,%html,%data);
	if ($session{var}{userType} eq "unit") {
		%data = $session{netams}->getUnit($session{var}{userId});
		$html{units} = showUnit($session{var}{userId});
	} elsif ($session{var}{userType} eq "account") {
		%data = $session{netams}->getAccount($session{var}{userId});
		$html{accInfo} = showAccInfo();
		$html{units} .= showUnit($_) foreach split ",",$data{units};
	}
	$session{page}{title} = "Welcome $data{name}";
	
	$result = qq~
	$html{accInfo}
	<div class=databox>
	<div class=boxhead>Attached Units</div>
	$html{units}
	</div>
	~;

	return $result;	
}

# oid
#-------------------------------------------------------------------
sub showUnit {
	my ($oid,%html,%data,%login);
	$oid = shift;
	return "" if $oid eq "";
	%data = $session{netams}->getUnit($oid);
	%login = Nawt::Login::getUnitLogin($oid);
	if (defined $login{flags}) {
		if ($session{var}{userType} eq "unit") {
			$html{btnlogin} = qq~<a class=btn1 href="?op=unitLoginout">Toggle Connection</a>~;
		} else {
			$html{btnlogin} = qq~<a class=btn1 href="?op=unitLoginout&oid=$oid">Toggle Connection</a>~;
		}
		$html{loginsts} = qq~<tr><td class=bold>Connection:</td><td>$login{status}</td></tr>~;
	}

	return qq~
	<table>
		<tr><td class=bold>Name:</td><td>$data{name}</td></tr>
		<tr><td class=bold>E-Mail:</td><td>$data{email}</td></tr>
		<tr><td class=bold>Description:</td><td>$data{description}</td></tr>
		<tr><td class=bold>IP-adress:</td><td>$data{ip}</td></tr>
		$html{loginsts}
	</table>
	<a class=btn1 href="?op=showStat">Statictics</a> $html{btnlogin}
	~;

}

# OPEN / CLOSE CONNECTION
#-------------------------------------------------------------------
sub www_unitLoginout {
	my ($oid, %unit, %login, $cmd);
		if (not $session{netams}->hasUnit($session{form}{oid}) and $session{var}{userType} eq "unit") {
			$oid = $session{var}{userId};
		} else {
			return Nawt::Theme::getRedirect($ENV{SCRIPT_NAME});
		}
		%unit = $session{netams}->getUnit($oid);
		%login = Nawt::Login::getUnitLogin($oid);
	if (defined $login{flags} && $login{flags} == 0) {
		$session{netams}->unitLogin(oid=>$oid, pass=>$login{password}, ip=>$session{env}{REMOTE_ADDR});
	} elsif (defined $login{flags} && $login{flags} == 1) {
		$session{netams}->unitLogout(oid=>$oid, pass=>$login{password}, ip=>$session{env}{REMOTE_ADDR});
	}
	return Nawt::Theme::getRedirect($ENV{SCRIPT_NAME});
}

1;