#!/usr/bin/perl -w
# $Id: access-script.pl,v 1.4 2005/04/11 18:03:46 ramirez Exp $
# This is just sample.
$|=1;
our ($nawtRoot, $configFile, $command, $outfile);

BEGIN {
		# Config file name (file must be in $nawtRoot/etc dir):
    		$configFile = "nawt.conf";

		# Path to root script dir (no trailing slash):
		$nawtRoot = "/var/www/nawt";
		
		# File where blocked IP strored:
		$outfile = "/var/www/apache2/addon-modules/nawt/etc/oops/acl/blocked.acl";
		
		# Command, this command will be run after all
		# In my case - relod proxy config
		$command = "oopsctl reconfigure";

#-----------------DO NOT MODIFY BELOW THIS LINE--------------------

		unshift (@INC, $nawtRoot."/lib");
}

print "This script must be called from Netams.\nAdd this option to service processor: access-script '$ENV{PWD}/access-script.pl'\n" unless @ARGV;

my ($action, $oid, $ip, $reason) = @ARGV;

use strict;
use Netams;
use Parse::PlainConfig;

# Load config
my %conf;
my $config = Parse::PlainConfig->new('DELIM' => '=', 'FILE' => $nawtRoot.'/etc/'.$configFile, 'PURGE' => 1);
	foreach ($config->directives) {	$conf{$_} = $config->get($_); }

# Connect netams
my $ams = Netams->new( host => $conf{nahost}, port => $conf{naport}, user => $conf{nauser}, pass => $conf{napass} );

my %users = $ams->getUnit();

open (FH, ">$outfile") || die "Can't open file: $outfile\n";
foreach (%users) {
	if ($users{$_}{'sys-policy'} =~ m/sys-deny/) {
		$users{$_}{ip} =~ s/ //g;
		print FH "$users{$_}{ip}/32\n" if $users{$_}{ip} ne "";
	}
}

close FH;

qx($command);

1;