#!/usr/bin/perl
# $Id$

our $nawtRoot;
our %cfg;
our $netams;
our $dbh;

BEGIN {
	$nawtRoot = $ARGV[0] || $ENV{PWD};
	$nawtRoot =~ s/\/sbin//g;
	#$nawtRoot = "/var/www/apache2/addon-modules/nawt"; # uncomment this if you have problems with cron
	unshift (@INC, $nawtRoot."/lib");
}

use strict;
use Netams;
use Parse::PlainConfig;
use DBI;
use Nawt::SQL;
use Net::Ping;   



# Loading nawt.conf
my $config = Parse::PlainConfig->new('DELIM' => '=', 'FILE' => $nawtRoot.'/etc/nawt.conf', 'PURGE' => 1);
foreach ($config->directives) {	$cfg{$_} = $config->get($_); }

# Connecting to NeTAMS
$netams = Netams->new(host => $cfg{nahost}, 
				   port => $cfg{naport}, 
				   user => $cfg{nauser}, 
				   pass => $cfg{napass}
				   );
my $res = $netams->connect;
die "Can't connect to NeTAMS. Check your nawt.conf.\n" unless $res == 200;
$netams->parseConfig();
$dbh = DBI->connect($cfg{dsn},$cfg{dbuser},$cfg{dbpass},{ RaiseError=>0,AutoCommit=>1 }) or die "Can't connect to database.\n";

exit if -f "/tmp/nawt_ping.lock";
`touch /tmp/nawt_ping.lock`;

print "Checking units...\n\n";                                                                                                  
my %units = $netams->getUnit();
                                                                                                                                    
foreach (keys %units) { 
		next if $_ eq "name2oid";   
		next if $units{$_}{type} !~ m/user|host|cluster/;                                                                                                            
        my @ips = split " ",$units{$_}{ip};                                     
        my ($dbchk) = Nawt::SQL->buildArray("SELECT COUNT(*) FROM nawt_ping WHERE unit_oid=".hex($_),$dbh);                            
        my $sId = $_;                                                                                                               
        my $msg;                                                                                                                    
        my $status;                                                                                                                 
        my $deadIpCount = 0;                                                                                                        
        my $ipTotal = $#ips + 1;                                                                                                    
		print "* Unit $units{$sId}{name}\n";
        foreach (@ips) {   
        	$_ =~ s/\/\d+$//g;                                                                                                         
            my $p = Net::Ping->new("icmp",1);                                                                                   
            #$p->{port_num} = getservbyname("http", "tcp");                                                                     
	        if ($p->ping($_)) {                                                                                                         
	                print "   + $_ is alive.\n";                                                                                           
	        } else {                                                                                                                    
	                print "   - $_ is DEAD.\n";                                                                                            
	                $deadIpCount++;                                                                                                     
	                $msg .= "$_ \n";                                                                          
	        }                                                                                                                           
        	$p->close();                                                                                                                
        }                                                                                                                           
                                                                                                                                    
        if ($deadIpCount > 0) { $status = 1; } else { $status = 0; }                                                                                                                           
                                                                                                                                    
        if (not @ips) {                                                                                                             
                $status = 1;                                                                                                        
                $msg = "IP adress not configured!";                                                                                 
        }                                                                                                                           
                                                                                                                                    
        if ($dbchk) {
        	if ($status) {                                                                                                               
                Nawt::SQL->write("UPDATE nawt_ping SET status='$status', message='$msg' WHERE unit_oid=".hex($sId),$dbh);
        	} else {
        		Nawt::SQL->write("DELETE FROM nawt_ping WHERE unit_oid=".hex($sId),$dbh);
        	}
        } else {                                                                                                                    
                Nawt::SQL->write("INSERT INTO nawt_ping SET status='$status', message='$msg', unit_oid=".hex($sId),$dbh) if $status;              
        }                                                                                                                           
        print "   Total IP's: $ipTotal. Dead: $deadIpCount\n\n";                                                               
}                                                                                                                                   
                                                                                                                                    
print "Check Finished\n\n"; 
`rm /tmp/nawt_ping.lock`;
